#!/bin/echoe System module for Wotan, try source

#
# Wotan.system.io v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

#
# @Ident:
# $Id: Wotan.system.io ,v0.2 1999/11/24 09:56:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux $
#

#
# Description:
# This is the system accounting module for Wotan. This module is monitoring
# Linux I/O information
#

#
# *****************************************************************************
#                          Copyright 1999 by Marek Uher
#
#                               All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Remove old data files
#
(rm -f ${WOTAN_DATA_SYS}/system.io*) >& /dev/null

#
# Query and store the number of times hard #1 disks have been accessed.
#
procinfo -ba | awk -F"disk 1:" '/disk 1:/{print $2}' >! ${WOTAN_DATA_SYS}/system.io.dev1.dat

#
# Query and store the number of times hard #2 disks have been accessed.
#
procinfo -ba | awk -F"disk 2:" '/disk 2:/{print $2}' >! ${WOTAN_DATA_SYS}/system.io.dev2.dat

#
# Query and store the number of times hard #3 disks have been accessed.
#
procinfo -ba | awk -F"disk 3:" '/disk 3:/{print $2}' >! ${WOTAN_DATA_SYS}/system.io.dev3.dat

#
# Query and store the number of times hard #4 disks have been accessed.
#
procinfo -ba | awk -F"disk 4:" '/disk 4:/{print $2}' >! ${WOTAN_DATA_SYS}/system.io.dev4.dat

# End of Wotan.system.io
