#!/bin/echoe System module for Wotan, try source

#
# Wotan.system.io v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

#
# @Ident:
# $Id: Wotan.system.io ,v0.2 1999/11/24 09:56:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: SunOS $
#

#
# Description:
# This is the system accounting module for Wotan. This module is monitoring
# SunOS I/O information
#

#
# *****************************************************************************
#                          Copyright 1999 by Marek Uher
#
#                               All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Remove old data files
#
(rm -f ${WOTAN_DATA_SYS}/system.io*) >& /dev/null

#
# Query and store SunOS disk device list
#
set DEVICE_LIST = `iostat -x | fgrep -v "device" | awk '{ print $1 }'`
echo $DEVICE_LIST >! ${WOTAN_DATA_SYS}/system.io.devices.all.dat

#
# Query device list limit
#
set limit	= $#DEVICE_LIST

#
# Query device name in descriptive format
#
set DEVICE_DESCR = `iostat -l $limit -n | awk '/cpu/{ for ( i = 1 ; i < NF ; i++ ) { lookup = index ( $i, "tty") ; if ( lookup == 0 ) print $i } }'`
@ index = 1
foreach device (`echo $DEVICE_LIST`)
	echo "$DEVICE_DESCR[$index]" >! ${WOTAN_DATA_SYS}/system.io.$device.dat
	@ index ++
end

#
# For each device report the number of kilobytes transferred per second,
# the number of transfer per second and the average service time
# in milliseconds
#
@ index = 0
foreach device (`echo $DEVICE_LIST`)
	@ offset = 1
	while ( $offset <= 3 )
		@ token = $index + $offset
		set value = `iostat -l $limit -d | egrep -v "($device[1]|kps)" | awk '{ print $'$token'}'`
		if ("$value" == "") set value = "0"
		echo "$value" >>! ${WOTAN_DATA_SYS}/system.io.$device.dat
		@ offset ++
	end	
	@ index += 3
end

#
# For each device report the reads per seconds, writes per seconds and
# percentage device utilization
#
@ index = 0
foreach device (`echo $DEVICE_LIST`)
	@ offset = 1
	while ( $offset <= 3 )
		@ token = $index + $offset
		set value = `iostat -l $limit -D | egrep -v "($device[1]|rps)" | awk '{ print $'$token'}'`
		if ("$value" == "") set value = "0"
		echo "$value" >>! ${WOTAN_DATA_SYS}/system.io.$device.dat
		@ offset ++
	end	
	@ index += 3
end

#
# For each device report extended statistics
#
foreach device (`echo $DEVICE_LIST`)
	iostat -l $limit -x | awk '/'"$device"'/{ print $0 }' >>! ${WOTAN_DATA_SYS}/system.io.$device.dat
end

# End of Wotan.system.io
