#!/bin/tcsh -f

#
# Wotan.Audit.Accounting.Group.cgi v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Accounting.Group.cgi ,v0.2 1999/10/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about concrete group
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw
set GROUP	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/GROUP=/ { print $2 }'`
set GROUP	= `echo $GROUP | tr -dc "[:alnum:]-_"`
if ("$GROUP" == "") then
	set GROUP	= "UNKNOWN_GROUP"
endif


#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>


<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<B><EM>
	Actions:
	</EM></B>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Groups.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Groups.gif' 'Group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Groups.cgi?HOST=$HOST&STATUS=$STATUS">group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">user and group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/Unix.gif" BORDER=0 ALT="Monitoring and auditing page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main monitoring and auditing page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>. Wotan now support Linux and Solaris operating system only. Other
platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif

#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux and SunOS have the same data format
#
case "Linux":
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Concrete account monitoring page for group $GROUP'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Groups.gif' 'Concrete account monitoring'`
	&nbsp;<B>Account monitoring page for group <EM>`HTMLOut '$GROUP'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about group account for group <B><EM>`HTMLOut '$GROUP'`
	</EM></B> on host <B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>
	`HTMLOut '$TIMESTAMP'`</EM>. Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#GroupAccount">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor group account'`</A>
		&nbsp;Monitor <A HREF="#GroupAccount">group account</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Groups.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Groups.gif' 'Group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Groups.cgi?HOST=$HOST&STATUS=$STATUS">group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">user and group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">monitoring and auditing page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/GroupFinder.gif' 'Monitor group account'`
	<A NAME="GroupAccount"><EM><B>Monitor group account</B></EM></A>
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
EOM

set GROUP_DATA	= `grep "^$GROUP|" $WOTAN_HOME/hosts/$HOST/data/account/account.groups.dat | sed "s/,/ /g"`
set GROUP_NAME	= `echo $GROUP_DATA | awk -F"|" '{ print $1 }'`
set GROUP_PASS	= `echo $GROUP_DATA | awk -F"|" '{ print $2 }'`
set GROUP_ID	= `echo $GROUP_DATA | awk -F"|" '{ print $3 }'`
set GROUP_LIST	= `echo $GROUP_DATA | awk -F"|" '{ print $4 }'`

echo '\t<TABLE ALIGN="CENTER" BORDER=0 WIDTH="95%">'

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Group name:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$GROUP_NAME"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Group password (encrypted):</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$GROUP_PASS"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>GID:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$GROUP_ID"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>User list:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	foreach user (`echo $GROUP_LIST`)
		echo '&nbsp;&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$user"'">'"$user</A>"
	end
echo "\t</TD>"
echo "\t</TR>"

echo "\t</TABLE>"

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan is monitoring the groups to which users belong. For group <B><EM>
`HTMLOut '$GROUP'`</EM></B> there is one entry, which contains fields. The
field descriptions are: group name (the name of the group), password (the
[encrypted] group password, i password is meeded), GID (numerical group ID),
user list (all the group member's user names, separated by spaces).
</TD>
</TR>


<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
