#!/bin/tcsh -f

#
# Wotan.Audit.Accounting.Sessions.cgi v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
# $Platform: Linux Apache HTTP server distribution $
#

# 
# @Ident:
# $Id: Wotan.Audit.Accounting.Sessions.cgi ,v0.2 1999/12/14 13:04:47 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
#

#
# Description:
# CGI script which generate Wotan document with information
# about user activity
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>


<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<B><EM>
	Actions:
	</EM></B>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">user and group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/Unix.gif" BORDER=0 ALT="Monitoring and auditing page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>. Wotan now support Linux and Solaris operating system only. Other
platforms will be supported later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif

#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux data format
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'User acticity monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Sessions.gif' 'User activity monitoring'`
	&nbsp;<B>User activity monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about user activity on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>
	`HTMLOut '$TIMESTAMP'`</EM>. Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#UsersActivity">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor user activity'`</A>
		&nbsp;Monitor <A HREF="#UsersActivity">user activity</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">user and group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">auditning and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/SessionsFinder.gif' 'Monitor user activity'`
	<A NAME="UsersActivity"><EM><B>Monitor user activity</B></EM></A>
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
EOM

echo '\t<TABLE ALIGN="CENTER" BORDER=0 WIDTH="95%">'

echo "\t<TR>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>User name</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>TTY</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Status</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>From</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Login date</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Login time</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Idle</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>JCPU</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>PCPU</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>What</EM><B>"
echo "\t</TD>"

echo "\t</TR>"

set TTY	= `awk '{print $2}' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`

foreach tty (`echo $TTY`)
	set user	= `awk '/'$tty'/{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set from	= `awk '/'$tty'/{ print substr($0, 15, 20) }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	if ("$from" == "(") set from	= "( )"
	set logintime	= `awk '/'$tty'/{ print substr($0, 34, 10) }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set idle	= `awk '/'$tty'/{ print substr($0, 43, 8) }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set jcpu	= `awk '/'$tty'/{ print substr($0, 50, 9) }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set pcpu	= `awk '/'$tty'/{ print substr($0, 57, 9) }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set what	= `awk '/'$tty'/{ command = substr($0, 64, 20) ; split ( command, process ) ; print process[1] }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set line	= `awk '/'$tty'/{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.status.dat`
	set logindate	= `awk '/'$tty'/{ print $4, $5 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.status.dat`


	echo "\t<TR>"

	echo '\t<TD ALIGN="LEFT" WIDTH="10%">'
	echo '\t\t<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$user"'">'"$user</A>"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo "\t\t$tty"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo '\t\t'"$line"' <FONT SIZE="-1">(*)</FONT>'
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	if ("$from" != "") then
		echo "\t\t$from"
	else
		echo "\t\t&nbsp;"
	endif
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo "\t\t$logindate"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo "\t\t$logintime"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo "\t\t$idle"
	echo "\t</TD>"

	echo '\t<TD ALIGN="RIGHT" WIDTH="10%">'
	echo "\t\t$jcpu"
	echo "\t</TD>"

	echo '\t<TD ALIGN="RIGHT" WIDTH="10%">'
	echo "\t\t$pcpu"
	echo "\t</TD>"

	echo '\t<TD ALIGN="LEFT" WIDTH="10%">'
	echo "\t\t$what"
	echo "\t</TD>"

echo "\t</TR>"

end

echo "\t</TABLE>"

CGIBody
<BR><BR>
<FONT SIZE="-1">(*)</FONT> Character indicating the user's message status:
	<TABLE BORDER="0" ALIGN="LEFT" WIDTH="60%">
	<TR>

	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD WIDTH="90%">
		<B>+</B>&nbsp;&nbsp;allowing write messages
	</TD>
	</TR>
	<TR>
	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD WIDTH="90%">
		<B>-</B>&nbsp;&nbsp;disallowing write messages
	</TD>
	</TR>
	<TR>
	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD WIDTH="90%">
		<B>?</B>&nbsp;&nbsp;cannot find terminal device
	</TD>

	</TR>
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
The following information for each user currently logged on are available:
login name, terminal line, login time, remote hostname or X display, the number
of hours and minutes that the user has been idle, user's message status, user's
processes, time used by all user processes attached to the tty
(<EM><B>JCPU</B></EM>), time used by the current process named in the
<EM><B>What</B></EM> field (<EM><B>PCPU</B></EM>), etc.
<BR><BR>
The notion of the current process is unclear. The current algorithm
is the highest numbered process on the terminal that is not ignoring
interrupts, or, if there is none, the highest numbered process on the
terminal. This fails, for example, in critical sections of programs like
the shell and editor, or when faulty programs running in the background fork
and fail to ignore interrupts. In cases where no process can be found, Wotan 
prints -.
<BR><BR>
The CPU time is only an estimate, in particular, if someone leaves a
background process running after logging out, the person currently on that
terminal is charged with the time.
<BR><BR>
Background processes are not shown, even though they account for much of the
load on the system.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS data format
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'User acticity monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Sessions.gif' 'User activity monitoring'`
	&nbsp;<B>User activity monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about user activity on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>
	`HTMLOut '$TIMESTAMP'`</EM>. Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#UsersActivity">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor user activity'`</A>
		&nbsp;Monitor <A HREF="#UsersActivity">user activity</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">user and group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">auditning and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/SessionsFinder.gif' 'Monitor user activity'`
	<A NAME="UsersActivity"><EM><B>Monitor user activity</B></EM></A>
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
EOM

echo '\t<TABLE ALIGN="CENTER" BORDER=0 WIDTH="95%">'

echo "\t<TR>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>User name</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>TTY</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Status</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>From</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Login date</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Login time</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>Idle</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>JCPU</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>PCPU</EM><B>"
echo "\t</TD>"

echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
echo "\t\t<B><EM>What</EM><B>"
echo "\t</TD>"

echo "\t</TR>"

set TTY	= `awk '{print $2}' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
set TTY	= `echo $TTY | sed "s/\//\\\//g"`

foreach tty (`echo $TTY`)
	set user	= `awk '/'$tty'/{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set from	= `awk '/'$tty'/{ print $9 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.status.dat`
	if ("$from" == "(") set from	= "( )"
	set logintime	= `awk '/'$tty'/{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.status.dat`
	set idle	= `awk '/'$tty'/{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.status.dat`
	if ("$idle" == ".") set idle	= "0:00"
	set jcpu	= `awk '/'$tty'/{ print substr($0, 36, 9) }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	if ("$jcpu" == "") set jcpu	= "?"
	set pcpu	= `awk '/'$tty'/{ print substr($0, 45, 6) }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	if ("$pcpu" == "") set pcpu	= "?"
	set what	= `awk '/'$tty'/{ command = substr($0, 51, 20) ; split ( command, process ) ; print process[1] }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.activity.dat`
	set line	= `awk '/'$tty'/{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.status.dat`
	set logindate	= `awk '/'$tty'/{ print $4, $5 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.session.status.dat`


	echo "\t<TR>"

	echo '\t<TD ALIGN="LEFT" WIDTH="10%">'
	echo '\t\t<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$user"'">'"$user</A>"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	set real_tty	= `echo $tty | sed "s/\\//g"`
	echo "\t\t$real_tty"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo '\t\t'"$line"' <FONT SIZE="-1">(*)</FONT>'
	echo "\t</TD>"

	echo '\t<TD ALIGN="LEFT" WIDTH="10%">'
	if ("$from" != "") then
		echo "\t\t$from"
	else
		echo "\t\t&nbsp;"
	endif
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo "\t\t$logindate"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo "\t\t$logintime"
	echo "\t</TD>"

	echo '\t<TD ALIGN="CENTER" WIDTH="10%">'
	echo "\t\t$idle"
	echo "\t</TD>"

	echo '\t<TD ALIGN="RIGHT" WIDTH="10%">'
	echo "\t\t$jcpu"
	echo "\t</TD>"

	echo '\t<TD ALIGN="RIGHT" WIDTH="10%">'
	echo "\t\t$pcpu"
	echo "\t</TD>"

	echo '\t<TD ALIGN="LEFT" WIDTH="10%">'
	echo "\t\t$what"
	echo "\t</TD>"

echo "\t</TR>"

end

echo "\t</TABLE>"

CGIBody
<BR><BR>
<FONT SIZE="-1">(*)</FONT> Character indicating the user's message status:
	<TABLE BORDER="0" ALIGN="LEFT" WIDTH="60%">
	<TR>

	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD WIDTH="90%">
		<B>+</B>&nbsp;&nbsp;allowing write messages
	</TD>
	</TR>
	<TR>
	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD WIDTH="90%">
		<B>-</B>&nbsp;&nbsp;disallowing write messages
	</TD>
	</TR>
	<TR>
	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD WIDTH="90%">
		<B>?</B>&nbsp;&nbsp;cannot find terminal device
	</TD>

	</TR>
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
<BR><BR>
The following information for each user currently logged on are available:
login name, terminal line, login time, remote hostname or X display, the number
of hours and minutes that the user has been idle, user's message status, user's
processes, time used by all user processes attached to the tty
(<EM><B>JCPU</B></EM>), time used by the current process named in the
<EM><B>What</B></EM> field (<EM><B>PCPU</B></EM>), etc.
<BR><BR>
The notion of the current process is unclear. The current algorithm
is the highest numbered process on the terminal that is not ignoring
interrupts, or, if there is none, the highest numbered process on the
terminal. This fails, for example, in critical sections of programs like
the shell and editor, or when faulty programs running in the background fork
and fail to ignore interrupts. In cases where no process can be found, Wotan 
prints -.
<BR><BR>
The CPU time is only an estimate, in particular, if someone leaves a
background process running after logging out, the person currently on that
terminal is charged with the time.
<BR><BR>
Background processes are not shown, even though they account for much of the
load on the system.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
