#!/bin/tcsh -f

#
# Wotan.Audit.Accounting.User.cgi v0.6
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Accounting.User.cgi ,v0.6 1999/11/26 08:58:14 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about concrete user
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw
set USER	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/USER=/ { print $2 }'`
set USER	= `echo $USER | tr -dc "[:alnum:]-_"`
if ("$USER" == "") then
	set HOST	= "UNKNOWN_USER"
endif


#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>


<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Users.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/User.gif' 'User accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Users.cgi?HOST=$HOST&STATUS=$STATUS">user accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">user and group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/Unix.gif" BORDER=0 ALT="Monitoring and auditing page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main monitoring and auditing page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>. Wotan now support Linux and Solaris operating system only. Other
platforms will be supported later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux and SunOS have the same data format
#
case "Linux":
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Concrete account monitoring page for user $USER'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/User.gif' 'Concrete account monitoring'`
	&nbsp;<B>Account monitoring page for user <EM>`HTMLOut '$USER'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about user account for user <B><EM>`HTMLOut '$USER'`
	</EM></B> on host <B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>
	`HTMLOut '$TIMESTAMP'`</EM>. Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#UserAccount">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor user account'`</A>
		&nbsp;Monitor <A HREF="#UserAccount">user account</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Users.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/User.gif' 'User accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.Users.cgi?HOST=$HOST&STATUS=$STATUS">user accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group accounts monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">user and group accounts monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/UserFinder.gif' 'Monitor user account'`
	<A NAME="UserAccount"><EM><B>Monitor user account</B></EM></A>
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD>
EOM

set USER_DATA	= `grep "^$USER|" $WOTAN_HOME/hosts/$HOST/data/account/account.userdb.dat | sed "s/,/ /g"`
set USER_LOGIN	= `echo $USER_DATA | awk -F"|" '{ print $1 }'`
set USER_UID	= `echo $USER_DATA | awk -F"|" '{ print $2 }'`
set USER_GID	= `awk -F"|" '/^'"$USER"'\174/{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/account/account.info.dat`
set USER_GNAME	= `echo $USER_DATA | awk -F"|" '{ print $3 }'`
set USER_GROUPS = `awk -F"|" '/^'"$USER"'\174/{ for( i = 2 ; i <= NF ; i++) print $i }' < $WOTAN_HOME/hosts/$HOST/data/account/account.info.groups.dat`
set USER_NAME	= `echo $USER_DATA | awk -F"|" '{ print $4 }'`
set USER_HOME	= `echo $USER_DATA | awk -F"|" '{ print $5 }'`
set USER_SHELL	= `echo $USER_DATA | awk -F"|" '{ print $6 }'`

echo '\t<TABLE ALIGN="CENTER" BORDER=0 WIDTH="95%">'

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Login name:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$USER_LOGIN"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>User name:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$USER_NAME"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>UID:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$USER_UID"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Login GID:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$USER_GID"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Login group:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo '<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$USER_GNAME"'">'"$USER_GNAME</A>"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Other user groups:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	foreach ogroup (`echo $USER_GROUPS`)
		echo '<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$ogroup"'">'"$ogroup</A>&nbsp;&nbsp;"
	end
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Home directory:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$USER_HOME"
echo "\t</TD>"
echo "\t</TR>"

echo "\t<TR>"
echo '\t<TD ALIGN="RIGHT" WIDTH="30%">'
	echo "\t\t<EM><B>Command interpreter:</B></EM>"
echo "\t</TD>"
echo '\t<TD ALIGN="CENTER" WIDTH="5%">'
	echo "&nbsp;"
echo "\t</TD>"
echo '\t<TD ALIGN="LEFT" WIDTH="65%">'
	echo "$USER_SHELL"
echo "\t</TD>"
echo "\t</TR>"

echo "\t</TABLE>"

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring various pieces of information for user
<B><EM>`HTMLOut '$USER'`</EM></B>.  Included is login name, numerical user ID,
numerical login group ID, login group name, names of other groups which user is
member, user name or comment field, user home directory and user command
interpreter. The comment field is used by various system utilities, such as
<EM>finger(1)</EM>.  The home directory field provides the name of the the
initial working directory.  Login process uses this information to set the
value of the <EM>HOME</EM> environmental variable.  The command interpreter
field provides the name of the user's command language interpreter, or the name
of the initial program to execute. Login process uses this information to set
the value of the <EM>SHELL</EM> environmental variable.  If this field is
empty, it defaults to the value <EM>/bin/sh</EM>.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
