#!/bin/tcsh -f

#
# Wotan.Audit.Filesystem.cgi v0.5
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Filesystem.cgi ,v0.5 1999/12/16 19:13:45 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about filesystems
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux and SunOS have the same data format
#
case "Linux":
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Filesystems monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/CDSmall.gif' 'Filesystems monitoring'`
	&nbsp;<B>Filesystems monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<B><EM>
	Actions:
	</EM></B>
	<BR><BR>
	<TABLE>
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.Supported.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/DiskFloppy.gif' 'Supported filesystems monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.Supported.cgi?HOST=$HOST&STATUS=$STATUS">Supported filesystems monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.Mounted.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/OpticalDisk.gif' 'Mounted filesystems monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.Mounted.cgi?HOST=$HOST&STATUS=$STATUS">Mounted filesystems monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.Usage.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/PieGraph.gif' 'Fylesystems usage monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.Usage.cgi?HOST=$HOST&STATUS=$STATUS">Fylesystems usage monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">auditing and monitoring page</A> for host $HOST
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan package is monitoring filesystem hierarchy, the amount of
disk space available on the filesystem, mounted filesystems, etc.
<BR><BR>
All  files accessible in a UNIX system are arranged in one big tree, the file
hierarchy, rooted at <TT><B>/</B></TT>.  These  files can be spread out over
several devices. The <EM>mount(8)</EM> command serves to attach the file system
found on some device to the big file tree. Conversely, the <EM>umount(8)</EM>
command will detach it again.
<BR><BR>
Wotan shows the space available on that filesystem rather than on the
filesystem containing  the  device node (which is always the root filesystem).
This version of Wotan cannot show the space available on unmounted filesystems,
because on most kinds of systems doing so requires very nonportable intimate
knowledge of filesystem structures.
<BR><BR>
Wotan supports this filesystem types: minix, ext, ext2, xia, msdos, umsdos,
vfat, proc, nfs, iso9660, hpfs,  sysv, smb, ncpfs, ufs, pcfs, hsfs, ...
<BR><BR>
For more information see manual pages <EM>mount(8)</EM>, <EM>umount(8)</EM>,
<EM>df(1)</EM>, <EM>fs(5)</EM> and relating HOWTO documents.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
