#!/bin/tcsh -f

#
# Wotan.Audit.Main.cgi v0.6
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Main.cgi ,v0.6 1999/12/04 11:26:34 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with main user interface
# for auditing and monitoring
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Select run time method (CGI or spooling)
#
@ argc	= $#argv
if ($argc == 1) then
	set CGI_FLAG = "$argv[1]"
else
	set CGI_FLAG = "CGI"
endif

#
# Test local rwhod server database
#
set AUDIT_TIMESTAMP	= `date "+%d.%m.%Y %H:%M:%S"`
set FLAG_TCP		= "OFF"
set FLAG_RPC		= "OFF"
set TCP			= "NOT_DEFINED"
set RPC			= "NOT_DEFINED"
set WotanError 		= `( ruptime ) | & awk 'BEGIN{ FS = ":" }{ print $3 }'`
if ("$WotanError" != "No such file or directory.") then
	set rwhod_pid	= `ps auxf | grep -v awk | awk '/rwhod/{print $11}'`
	if ( "$rwhod_pid" != "" ) then
		set Protocol	= "TCP"
		set TCP		= "ON"
	else
		set Protocol	= "NONE"
		set TCP		= "OFF"
	endif
else
	set Protocol	= "NONE"
	set TCP		= "OFF"
endif

#
# Begin of CGI script
#
if ("$CGI_FLAG" != "-NO_CGI" && "$CGI_FLAG" != "--NO_CGI") then
	CGIHeader
endif

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan Audit main page'`
`HTMLBody`

<CENTER>
<TABLE ALIGN=CENTER WIDTH=680>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Monitoring and auditing page'`
	<B><EM>
	&nbsp;&nbsp;Main auditing and monitoring page
	</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about monitored remote hosts. Wotan is
	monitoring remote host status, uptime or downtime, system load and
	number of user working on remote host.
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<B><EM>
	Actions:
	</EM></B>
	<BR><BR>
	<TABLE>
	<TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#HostTable">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor host'`</A>
		&nbsp;<A HREF="#HostTable">Monitor host</A>
	</TD>
	</TR>
	
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Update.gif' 'Update now'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">Update now</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="http://cop.uhkt.cz/~wotan/">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Back to Wotan home'`</A>
		&nbsp;Back to <A HREF="http://cop.uhkt.cz/~wotan/">Wotan main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/MonitorFinder.gif' 'Monitor host'`
	<EM><B>Monitor host</B></EM><A NAME="HostTable">
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	Last update: `HTMLOut '$AUDIT_TIMESTAMP'`
	<BR>
</TD>
</TR>
</TABLE>

<TABLE ALIGN=CENTER WIDTH=680>
<TR>
<TD>
	<BR>
	<A NAME="HostTable">
	<TABLE BORDER=0 ALIGN=LEFT WIDTH=650>
	<TR>
	<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>
		&nbsp;	
	</TD>

	<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>
		<EM><B>
		Status
		</B></EM>
	</TD>

	<TD WIDTH="20%" ALIGN=CENTER VALIGN=CENTER>
		<EM><B>
		System uptime or downtime
		</B></EM>
	</TD>

	<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>
		<EM><B>
		System<BR>load
		</B></EM>
	</TD>

	<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>
		<EM><B>
		Users
		</B></EM>
	</TD>

	<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>
		<EM><B>
		Scanning<BR>protocols
		</B></EM>
	</TD>

	<TD WIDTH="20%" ALIGN=LEFT VALIGN=CENTER>
		<EM><B>
		System name
		</B></EM>
	</TD>
	</TR>

	<TR>
	<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>
		&nbsp;	
	</TD>

	<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>
		&nbsp;	
	</TD>

	<TD WIDTH="20%" ALIGN=CENTER VALIGN=CENTER>
		&nbsp;	
	</TD>

	<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>
		&nbsp;	
	</TD>

	<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>
		&nbsp;	
	</TD>

	<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>
		&nbsp;	
	</TD>

	<TD WIDTH="20%" ALIGN=LEFT VALIGN=CENTER>
		&nbsp;	
	</TD>
	</TR>
EOM

#
# Run network broadcast monitoring
#
set Protocol		= "NONE"
set NumberOfHost	= `egrep -v "^#" $WOTAN_HOME/etc/Wotan.hosts | wc -l`
set WotanHosts		= `egrep -v "^#" $WOTAN_HOME/etc/Wotan.hosts | awk '{print $1}'`
@ LookUpIndex = 1
while ($LookUpIndex <= $NumberOfHost)

	#
	# Init flags
	#
	set FLAG_TCP		= "OFF"
	set FLAG_RPC		= "OFF"

	#
	# Remote hosts status (TCP protocol)
	#
	set WotanHostStatus		= ""
	if ("$TCP" == "ON") then
		set WotanHostStatus	= `ruptime | awk '/^'"$WotanHosts[$LookUpIndex] "'/{print $2}'`
		if ("$WotanHostStatus" != "") set FLAG_TCP	= "ON"
	endif
	
	#
	# No data, try to switch to RPC
	#
	if ("$WotanHostStatus" == "")  then


		#
		# Test RPC (rstatd) services on remote host
		#
		if ("$RPC" == "NOT_DEFINED") then
			set WotanError	= `( rup $WotanHosts[$LookUpIndex] & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | & egrep "^rup" | awk -F: '{ print $3 }'`

			if ( "$WotanError" != "RPC" && "$WotanError" == "") then
				set RPC		= "ON"
			else
				set RPC		= "OFF"
			endif
		endif

		#
		# RPC is working, try get data
		#
		if ("$RPC" == "ON") then
			set WotanHostStatus	= `( rup $WotanHosts[$LookUpIndex] | awk '{print $2}' & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | egrep "^(up|down)"`
			if ("$WotanHostStatus" != "") set FLAG_RPC	= "ON"
		endif
	endif

	#
	# There are no data, remote host is down or unreachable
	#
	if ( "$WotanHostStatus" == "" ) set WotanHostStatus	= "down"

	#
	# Remote host uptime, try TCP
	#
	set WotanHostUptime		= ""
	if ("$TCP" == "ON") then
		set WotanHostUptime	= `ruptime | awk '/^'"$WotanHosts[$LookUpIndex] "'/{print $3}' | tr "," " "`
		if ("$WotanHostUptime" != "") set FLAG_TCP	= "ON"
	endif

	#
	# No data, try RPC
	#
	if ("$WotanHostUptime" == "" && "$WotanHostStatus" != "down") then
	
		#
		# Test RPC (rstatd) services on remote host
		#
		if ("$RPC" == "NOT_DEFINED") then
			set WotanError	= `( rup $WotanHosts[$LookUpIndex] & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | & egrep "^rup" | awk -F: '{ print $3 }'`

			if ( "$WotanError" != "RPC" && "$WotanError" == "") then
				set RPC		= "ON"
			else
				set RPC		= "OFF"
			endif
		endif

		#
		# RPC is working, try get data
		#
		if ("$RPC" == "ON") then

			#
			# Remote host uptime (RPC protocol)
			#
			set WotanHostUptime	= `( rup $WotanHosts[$LookUpIndex] | awk '{print $3}' & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | sed "s/,//" | egrep "^(1|2|3|4|5|6|7|8|9|0)"`
			if ("$WotanHostUptime" != "") set FLAG_RPC	= "ON"
		endif
	endif

	#
	# There are no data, remote host uptime is unknown
	#
	if ( "$WotanHostUptime" == "" ) set WotanHostUptime	= "?"

	#
	# Remote host load, try TCP
	#
	set WotanHostLoad		= ""
	if ("$TCP" == "ON" && "$WotanHostStatus" != "down") then
		set WotanHostLoad	= `ruptime | awk '/^'"$WotanHosts[$LookUpIndex] "'/{print $7}'| tr "," " "`
		if ("$WotanHostLoad" != "") set FLAG_TCP	= "ON"
	endif

	#
	# No data, try RPC
	#
	if ("$WotanHostLoad" == "" && "$WotanHostStatus" != "down") then
		#
		# Test RPC (rstatd) services on remote host
		#
		if ("$RPC" == "NOT_DEFINED") then
			set WotanError	= `( rup $WotanHosts[$LookUpIndex] & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | & egrep "^rup" | awk -F: '{ print $3 }'`

			if ( "$WotanError" != "RPC" && "$WotanError" == "") then
				set RPC		= "ON"
			else
				set RPC		= "OFF"
			endif
		endif

		#
		# RPC is working, try get data
		#
		if ("$RPC" == "ON") then
			#
			# Remote host load (RPC protocol)
			#
			set WotanHostLoad	= `( rup $WotanHosts[$LookUpIndex] | awk -F, '{print $2}' | awk -F: '{print $2}' & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | fgrep "." | awk '{print $1}'`
			if ("$WotanHostLoad" != "") set FLAG_RPC	= "ON"
		endif
	endif

	#
	# There are no data, remote host load is unknown
	#
	if ( "$WotanHostLoad" == "" ) set WotanHostLoad		= "?"

	#
	# Remote host number of users, try TCP
	#
	set WotanHostUsers		= ""
	if ("$TCP" == ON && "$WotanHostStatus" != "down") then
		set WotanHostUsers	= `ruptime | awk '/^'"$WotanHosts[$LookUpIndex] "'/{print $4}'`
		if ("$WotanHostUsers" != "") set FLAG_TCP	= "ON"
	endif

	#
	# No data, try RPC
	#
	if ("$WotanHostUsers" == "") then

		#
		# Test RPC (rusersd) services on remote host
		#
		set WotanError	= `( rusers $WotanHosts[$LookUpIndex] & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | & egrep "^rusers" | awk -F: '{ print $2 }'`
		if ( "$WotanError" != "RPC" && "$WotanError" == "") then
			set RPC		= "ON"
		else
			set RPC		= "OFF"
		endif

		#
		# Remote host number of users (RPC protocol)
		#
		if ("$RPC" == "ON") then
			set WotanHostUsers	= `( ( rusers $WotanHosts[$LookUpIndex] | awk '{ for ( i = 1 ; i <= NF ; i++ ) print $i }' | wc -l | awk '{print $1}' ) & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | egrep "^(1|2|3|4|5|6|7|8|9|0)"`
			if ("$WotanHostUsers" != "") set FLAG_RPC	= "ON"
		endif

	endif

	#
	# There are no data, remote host number of users is unknown
	#
	if ( "$WotanHostUsers" == "" ) then
		set WotanHostUsers	= "?"
	else

		#
		# Remote host may be up, try to switch to RPC rstatd service
		#
		if ( "$WotanHostStatus" == "down" && "$RPC" == "ON" ) then

			#
			# Init RPC from rusersd to rstatd
			#
			set RPC		= "NOT_DEFINED"

			#
			# Test RPC (rstatd) services on remote host
			#
			if ("$RPC" == "NOT_DEFINED") then
				set WotanError	= `( rup $WotanHosts[$LookUpIndex] & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | & egrep "^rup" | awk -F: '{ print $3 }'`

				if ( "$WotanError" != "RPC" && "$WotanError" == "") then
					set RPC		= "ON"
				else
					set RPC		= "OFF"
				endif
			endif

			#
			# RPC is working, try get data
			#
			if ("$RPC" == "ON") then
				set WotanHostStatus	= `( rup $WotanHosts[$LookUpIndex] | awk '{print $2}' & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | egrep "^(up|down)"`
				if ("$WotanHostStatus" != "") set FLAG_RPC	= "ON"
			endif
	
			#
			# There are no data, remote host is down or unreachable
			#
			if ( "$WotanHostStatus" == "" ) set WotanHostStatus	= "down"
	
			#
			# If remote host is up and RPC is running, try to get
			# remote host uptime
			#
			if ("$WotanHostStatus" == "up") then
	
				#
				# Test RPC (rstatd) services on remote host
				#
				if ("$RPC" == "NOT_DEFINED") then
					set WotanError	= `( rup $WotanHosts[$LookUpIndex] & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | & egrep "^rup" | awk -F: '{ print $3 }'`
	
					if ( "$WotanError" != "RPC" && "$WotanError" == "") then
						set RPC		= "ON"
					else
						set RPC		= "OFF"
					endif
				endif
	
				#
				# RPC is working, try get data
				#
				if ("$RPC" == "ON") then
	
					#
					# Remote host uptime (RPC protocol)
					#
					set WotanHostUptime	= `( rup $WotanHosts[$LookUpIndex] | awk '{print $3}' & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | sed "s/,//" | egrep "^(1|2|3|4|5|6|7|8|9|0)"`
					if ("$WotanHostUptime" != "") set FLAG_RPC	= "ON"
				endif
			endif

			#
			# There are no data, remote host uptime is unknown
			#
			if ( "$WotanHostUptime" == "" ) set WotanHostUptime	= "?"
		

			#
			# If remote host is up and RPC is running, try to get
			# remote host load
			#
			if ("$WotanHostStatus" == "up") then
		
				#
				# Test RPC (rstatd) services on remote host
				#
				if ("$RPC" == "NOT_DEFINED") then
					set WotanError	= `( rup $WotanHosts[$LookUpIndex] & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | & egrep "^rup" | awk -F: '{ print $3 }'`
		
					if ( "$WotanError" != "RPC" && "$WotanError" == "") then
						set RPC		= "ON"
					else
						set RPC		= "OFF"
					endif
				endif

				#
				# RPC is working, try get data
				#
				if ("$RPC" == "ON") then
				
					#
					# Remote host load (RPC protocol)
					#
					set WotanHostLoad	= `( rup $WotanHosts[$LookUpIndex] | awk -F, '{print $2}' | awk -F: '{print $2}' & ; sleep $WOTAN_RPC_TIMEOUT ; kill %1 > & /dev/null ) | fgrep "." | awk '{print $1}'`
					if ("$WotanHostLoad" != "") set FLAG_RPC	= "ON"
				endif
			endif

			#
			# There are no data, remote host load is unknown
			#
			if ( "$WotanHostLoad" == "" ) set WotanHostLoad		= "?"
		endif
	endif

	#
	# Remote host status is unknown
	#
	if ("$WotanHostStatus" == "down" && "$WotanHostUptime" == "?" && "$WotanHostLoad" == "?" && "$WotanHostUsers" == "?") set WotanHostStatus	= "unknown"

	#
	# Build HTML table
	#
	switch ("$WotanHostStatus")

		case "up":
			echo "\t<TR>"
			echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<IMG SRC="'"$AUDIT_IMG_URL"'/Up.gif" ALT="System is up">'
			echo "\t</TD>"
			echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<FONT COLOR="#009900">'
				echo "\t\t$WotanHostStatus"
				echo "\t\t</FONT>"
			echo "\t</TD>"
			breaksw

		case "down":
			echo "\t<TR>"
			echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<IMG SRC="'"$AUDIT_IMG_URL"'/Down.gif" ALT="System is down">'
			echo "\t</TD>"
			echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<FONT COLOR="#FF0000"><BLINK>'
				echo "\t\t$WotanHostStatus"
				echo "\t\t</BLINK></FONT>"
			echo "\t</TD>"
			breaksw

		case "unknown":
			echo "\t<TR>"
			echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<IMG SRC="'"$AUDIT_IMG_URL"'/Unknown.gif" ALT="System status is unknown">'
			echo "\t</TD>"
			echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<FONT COLOR="#888888">'
				echo "\t\t$WotanHostStatus"
				echo "\t\t</FONT>"
			echo "\t</TD>"
			breaksw

		default:
			echo "\t<TR>"
			echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<IMG SRC="'"$AUDIT_IMG_URL"'/Down.gif" ALT="System is down">'
			echo "\t</TD>"
			echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<FONT COLOR="#000000">'
				echo "\t\t$WotanHostStatus"
				echo "\t\t</FONT>"
			echo "\t</TD>"
			breaksw
	endsw

	echo '\t<TD WIDTH="20%" ALIGN=RIGHT VALIGN=CENTER>'
		echo "\t\t$WotanHostUptime&nbsp;&nbsp;&nbsp;&nbsp;"
	echo "\t</TD>"

	if ("$WotanHostLoad" == "?") then
		echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
			echo "\t\t$WotanHostLoad"
		echo "\t</TD>"
	else
		set overload	= `echo $WotanHostLoad | awk -F. '{ print $1 }'`
		if ($overload >= $WOTAN_MAX_LOAD) then
			echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
				echo "\t\t<BLINK>"
				echo '\t\t<FONT COLOR="#FF0000">'
				echo "\t\t$WotanHostLoad"
				echo "\t\t</FONT>"
				echo "\t\t</BLINK>"
			echo "\t</TD>"
		else
			echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<FONT COLOR="#009900">'	
				echo "\t\t$WotanHostLoad"
				echo "\t\t</FONT>"
			echo "\t</TD>"
		endif
	endif

	if ("$WotanHostUsers" == "?") then
		echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
			echo "\t\t$WotanHostUsers"
		echo "\t</TD>"
	else
		if ($WotanHostUsers >= $WOTAN_MAX_USERS) then
			echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
				echo "\t\t<BLINK>"
				echo '\t\t<FONT COLOR="#FF0000">'
				echo "\t\t$WotanHostUsers"
				echo "\t\t</FONT>"
				echo "\t\t</BLINK>"
			echo "\t</TD>"
		else
			echo '\t<TD WIDTH="10%" ALIGN=CENTER VALIGN=CENTER>'
				echo '\t\t<FONT COLOR="#009900">'	
				echo "\t\t$WotanHostUsers"
				echo "\t\t</FONT>"
			echo "\t</TD>"
		endif
	endif

	if ("$FLAG_TCP" == "ON" && "$FLAG_RPC" == "ON") then
		echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
			echo "\t\tTCP / RPC"
		echo "\t</TD>"
	else
		if ("$FLAG_TCP" == "ON" && "$FLAG_RPC" == "OFF") then
			echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
				echo "\t\tTCP"
			echo "\t</TD>"
		else
			if ("$FLAG_TCP" == "OFF" && "$FLAG_RPC" == "ON") then
				echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
					echo "\t\tRPC"
				echo "\t</TD>"
			else
				echo '\t<TD WIDTH="15%" ALIGN=CENTER VALIGN=CENTER>'
					echo "\t\tNONE"
				echo "\t</TD>"
			endif
		endif
	endif

	echo '\t<TD WIDTH="20%" ALIGN=LEFT VALIGN=CENTER>'
		if (-e $WOTAN_HOME/hosts/$WotanHosts[$LookUpIndex] && -d $WOTAN_HOME/hosts/$WotanHosts[$LookUpIndex]) then
			echo '\t\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$WotanHosts[$LookUpIndex]"'&STATUS='"$WotanHostStatus"'">'"$WotanHosts[$LookUpIndex]"'</A>'
		else
			echo "\t\t$WotanHosts[$LookUpIndex]"
		endif
	echo "\t</TD>"

	echo "\t</TR>"
	@ LookUpIndex ++
end

CGIBody

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
The <EM>rwhod(8)</EM> or <EM>rpc.rstatd(8)</EM> and <EM>rpc.rusersd(8)</EM>
daemon(s) must be running on the remote host. Wotan use an rwhod server
database in <EM>/var/spool/rwho</EM> or RPC protocol defined in
<EM>/usr/include/rpcsvc/rstat.x</EM> and <EM>/etc/inetd.conf</EM>. Its
operation is predicated on the ability to broadcast messages on a network.
<BR><BR>
Please, select one daemon(s) (i.e. <EM>rwhod(8)</EM> or <EM>rpc.rstatd(8)</EM>
and <EM>rpc.rusersd(8)</EM>) and run this daemon(s) on remote monitored host.
In other way, Wotan can not run monitoring and auditing services on a network.
See documentation for <EM>rwhod</EM>, <EM>rpc.rstatd</EM> and
<EM>rpc.rusersd</EM> (man pages for <EM>inetd(8)</EM>, <EM>rwhod(8)</EM>,
<EM>rpc.rstatd(8)</EM>, <EM>rpc.rusersd(8)</EM>).
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

end:

# /* End of CGI script */
