#!/bin/tcsh -f

#
# Wotan.Audit.Network.Interface.cgi v0.4
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Network.Interface.cgi ,v0.4 1999/11/29 17:21:52 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about concrete network interface
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw
set INTERFACE	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/INTERFACE=/ { print $2 }'`
set INTERFACE	= `echo $INTERFACE | tr -dc "[:alnum:]"`
if ("$INTERFACE" == "") set INTERFACE	= "UNKNOWN_INTERFACE"

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Interfaces.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/NetInterface.gif' 'Network interfaces monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Interfaces.cgi?HOST=$HOST&STATUS=$STATUS">network interfaces monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/Unix.gif" BORDER=0 ALT="Monitoring and auditing page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Network interface monitoring page for interface $INTERFACE'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/NetInterface.gif' 'Concrete interface monitoring'`
	&nbsp;<B>Network interface monitoring page for interface <EM>`HTMLOut '$INTERFACE'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about interface <B><EM>`HTMLOut '$INTERFACE'`
	</EM></B> on host <B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>
	`HTMLOut '$TIMESTAMP'`</EM>. Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#NetworkInterface">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network interface'`</A>
		&nbsp;Monitor <A HREF="#NetworkInterface">network interface</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Interfaces.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/NetInterface.gif' 'Network interfaces monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Interfaces.cgi?HOST=$HOST&STATUS=$STATUS">network interfaces monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Ethernet.gif' 'Monitor network interface'`
	<A NAME="NetworkInterface"><EM><B>Monitor network interface</B></EM></A>
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD>

	<TABLE ALIGN=CENTER BORDER=0 WIDTH="95%">
	
	<TR>
	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD>
		Configuration:
	</TD>
	</TR>

	<TR>
	<TD WIDTH="10%" NOWRAP>
		&nbsp;
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>
</TABLE>

EOM

echo "<TABLE BORDER=0>"
echo "<TR>"
echo "<TD>"
if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.conf.dat) then
	echo "\t\t<PRE>"
	cut -c "10-" $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.conf.dat
	echo "\t\t</PRE>"
else
	echo "Can not find any configuration data"
endif


echo "</TD>"
echo "</TR>"
echo "</TABLE>"

echo "<TABLE WIDTH=650>"
echo "<TR>"
echo "<TD>"

        echo '\t<TABLE ALIGN=CENTER BORDER=0 WIDTH="95%">'

	echo "\t<TR>"
	echo '\t<TD WIDTH="10%">'
		echo "\t\t&nbsp;"
	echo "\t</TD>"
	echo "\t<TD>"
		echo "\t\tStatistics:<BR><BR>"
	echo "\t</TD>"
	echo "\t</TR>"

	echo "\t<TR>"
	echo '\t<TD WIDTH="10%" NOWRAP>'
		echo "\t\t&nbsp;"
	echo "\t</TD>"
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat) then
			set iface	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set mtu		= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set met		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set rxok	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set rxerr	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set rxdpr	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set rxovr	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set txok	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set txerr	= `awk '{ print $9 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set txdpr	= `awk '{ print $10 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set txovr	= `awk '{ print $11 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set ifaceflags	= `awk '{ print $12 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`

			echo "\t<TD>"

			echo '\t\t<TABLE WIDTH="95%" BORDER="0">'

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tMTU:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$mtu"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tMetric:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$met"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tRX-OK:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$rxok"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"
			
			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tRX-ERROR:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$rxerr"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tRX-DPR:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$rxdpr"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tRX-OVR:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$rxovr"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tTX-OK:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$txok"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tTX-ERROR:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$txerr"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tTX-DPR:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$txdpr"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tTX-OVR:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$txovr"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tFlags:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$ifaceflags"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"
			echo "\t\t</TABLE>"
			echo "\t</TD>"
		else
			echo "\t<TD>"
			echo "Can not find any statistics data"
			echo "\t</TD>"
		endif
	echo "\t</TR>"

	echo "\t</TABLE>"

echo "</TD>"
echo "</TR>"
echo "</TABLE>"

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring system network kernel-resident network
interface `HTMLOut '$INTERFACE'`. Aavailable are this information:
interface name, IP address, hardware address (ethernet address), MTU
(Maximum Transfer Unit), broadcast address, network mask, interface flags
(up, down, running, broadcast, multicast, ...), metric; RX packets, errors,
dropped, overruns, frame; TX packets, errors, dropped, overruns, carrier;
collisions, interrupt request (IRQ), memory address, etc.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Network interface monitoring page for interface $INTERFACE'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/NetInterface.gif' 'Concrete interface monitoring'`
	&nbsp;<B>Network interface monitoring page for interface <EM>`HTMLOut '$INTERFACE'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about interface <B><EM>`HTMLOut '$INTERFACE'`
	</EM></B> on host <B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>
	`HTMLOut '$TIMESTAMP'`</EM>. Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#NetworkInterface">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network interface'`</A>
		&nbsp;Monitor <A HREF="#NetworkInterface">network interface</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Interfaces.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/NetInterface.gif' 'Network interfaces monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Interfaces.cgi?HOST=$HOST&STATUS=$STATUS">network interfaces monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Ethernet.gif' 'Monitor network interface'`
	<A NAME="NetworkInterface"><EM><B>Monitor network interface</B></EM></A>
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD>

	<TABLE ALIGN=CENTER BORDER=0 WIDTH="95%">
	
	<TR>
	<TD WIDTH="10%">
		&nbsp;
	</TD>
	<TD>
		Configuration:
	</TD>
	</TR>

	<TR>
	<TD WIDTH="10%" NOWRAP>
		&nbsp;
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>
</TABLE>

EOM

echo "<TABLE BORDER=0>"
echo "<TR>"
echo "<TD>"
if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.conf.dat) then
	echo "\t\t<PRE>"
	sed "s/"$INTERFACE":/       /" $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.conf.dat | sed "s/</ (/g" | sed "s/>/)/g"
	echo "\t\t</PRE>"
else
	echo "Can not find any configuration data"
endif
echo "</TD>"
echo "</TR>"
echo "</TABLE>"

echo "<TABLE WIDTH=650>"
echo "<TR>"
echo "<TD>"

        echo '\t<TABLE ALIGN=CENTER BORDER=0 WIDTH="95%">'


	echo "\t<TR>"
	echo '\t<TD WIDTH="10%">'
		echo "\t\t&nbsp;"
	echo "\t</TD>"
	echo "\t<TD>"
		echo "\t\tStatistics:<BR><BR>"
	echo "\t</TD>"
	echo "\t</TR>"

	echo "\t<TR>"
	echo '\t<TD WIDTH="10%" NOWRAP>'
		echo "\t\t&nbsp;"
	echo "\t</TD>"
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat) then
			set iface	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set mtu		= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set dest	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set address	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set ipkts	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set ierrs	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set opkts	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set oerrs	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set collis	= `awk '{ print $9 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`
			set queue	= `awk '{ print $10 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.iface.$INTERFACE.stat.dat`


			echo "\t<TD>"

			echo '\t\t<TABLE WIDTH="95%" BORDER="0">'

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tMTU:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$mtu"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tNet/Dest:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$dest"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tAddress:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$address"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"
			
			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tIpkts:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$ipkts"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tIerrs:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$ierrs"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tOpkts:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$opkts"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tOerrs:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$oerrs"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tCollis:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$collis"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="10%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="15%">'
				echo "\t\t\tQueue:"
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN=RIGHT WIDTH="25%">'
				echo "\t\t\t$queue"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="60%">'
				echo "\t\t\t&nbsp;"
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t</TABLE>"

			echo "\t</TD>"
		else
			echo "\t<TD>"
			echo "Can not find any statistics data"
			echo "\t</TD>"
		endif
	echo "\t</TR>"

	echo "\t</TABLE>"

echo "</TD>"
echo "</TR>"
echo "</TABLE>"

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring system network kernel-resident network
interface `HTMLOut '$INTERFACE'`. Aavailable are this information: interface
name, mtu (maximum transmission unit, or maximum packet size - see
<EM>ifconfig(1M)</EM>), the network to which the interface is attached,
addresses for each interface, and counter associated with the interface. The
counters  show  the  number  of input  packets, input errors, output packets,
output errors, and collisions, respectively. For Point-to-Point interfaces,
the Net/Dest field is the name or address on the other side of the link.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw





default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
