#!/bin/tcsh -f

#
# Wotan.Audit.Network.Protocol.cgi v0.3
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Network.Protocol.cgi ,v0.3 1999/11/25 16:17:49 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about concrete network protocol
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw
set PROTOCOL	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/PROTOCOL=/ { print $2 }'`
set PROTOCOL	= `echo $PROTOCOL | tr -dc "[:alnum:]-_"`
if ("$PROTOCOL" == "") set PROTOCOL	= "UNKNOWN_PROTOCOL"

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Protocols.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Protocols.gif' 'Network protocols monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Protocols.cgi?HOST=$HOST&STATUS=$STATUS">network protocols monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/Unix.gif" BORDER=0 ALT="Monitoring and auditing page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Network protocol monitoring page for protocol $PROTOCOL'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Protocols.gif' 'Network protocol monitoring'`
	&nbsp;<B>Network protocol monitoring page for protocol <EM>`HTMLOut '$PROTOCOL'`</EM>
	on host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about network protocols on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#NetworkProtocol">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network protocol'`</A>
		&nbsp;Monitor <A HREF="#NetworkProtocol">network protocol</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Protocols.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Protocols.gif' 'Network protocols monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Protocols.cgi?HOST=$HOST&STATUS=$STATUS">network protocols monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/ProtocolsFinder.gif' 'Monitor network protocol'`
	<A NAME="NetworkProtocol"><EM><B>Monitor network protocol - `HTMLOut '$PROTOCOL'`</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>	

EOM

switch ("$PROTOCOL")

	case "tcp":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.tcp.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRecv-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tSend-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tLocal Address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tForeign Address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tState"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tUser"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tTimer"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tValue"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $2, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $3, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $4, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $5, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD>", $6, "</TD>" \
				printf "\t%s\n\t\t<A HREF=\"'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER="'%s\">%s</A>\n\t%s\n", "<TD>", $7, $7, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $8, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD>", $9, "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.tcp.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw
		
	case "udp":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.udp.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRecv-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tSend-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tLocal Address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tForeign Address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tTimer"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tValue"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tFlag"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $2, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $3, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $4, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $5, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $6, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $7, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $8, "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.udp.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	case "unix":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.unix.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRefCnt"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tFlags"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tType"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tState"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tI-Node"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tPath"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr($0, 6, 7), "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr($0, 13, 10), "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr($0, 25, 10), "</TD>" \
				unixstate = substr($0, 35, 12) ; gsub ( / /, "\&nbsp;", unixstate ) \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", unixstate, "</TD>" \
				iend = 51 ; ichar = substr($0, iend, 1) \
				while (ichar != " ") { \
					ichar = substr($0, iend, 1) \
					iend++ \
				} \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr($0, 50, iend-50), "</TD>" \
				unixpath = substr($0, iend, 50) \
				printf "\t%s\n\t\t&nbsp;%s\n\t%s\n", "<TD ALIGN=LEFT>", unixpath, "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.unix.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	case "raw":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.raw.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRecv-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tSend-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tLocal Address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tForeign Address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tTimer"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tValue"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tFlag"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $2, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $3, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $4, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $5, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $6, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $7, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $8, "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.raw.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	case "arp":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.arp.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tHost"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tIP"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tEthernet address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tClass"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tInterface"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=LEFT>", $1, "</TD>" \
					gsub ( /[\50\51]/, "", $2 ) \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=LEFT>", $2, "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT><TT>", $4, "</TT></TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $5, "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=LEFT>", $7, "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.arp.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	case "rarp":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.rarp.dat) then
			set testmsg	= `head -1 $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.rarp.dat`
			@ rarpflag		= 0
			if ("$testmsg" == "This kernel does not support RARP.") then
				echo "\tThis kernel does not support RARP."
				@ rarpflag	= 1
			endif
			if ("$testmsg" == "RARP disabled until entries added to cache.") then
				echo "\tRARP disabled until entries added to cache."
				@ rarpflag	= 1
			endif
			if ($rarpflag == 0) then	
				echo '\t<TABLE BORDER="1">'
				echo "\t<TR>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tIP"
				echo "\t</TD>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tMedia type"
				echo "\t</TD>"
					echo "\t<TD ALIGN=CENTER>"
					echo "\t\tClass"
				echo "\t</TD>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tEthernet address"
				echo "\t</TD>"
				echo "\t</TR>"
				awk '{ \
					printf "\t%s\n", "<TR>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $1, "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $2, "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $3, "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT><TT>", $4, "</TT></TD>" \
					printf "\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.rarp.dat
				echo "\t</TABLE>"
			endif
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	case "ipx":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.ipx.dat) then
			if !(-z $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.ipx.dat) then
				echo '\t<TABLE BORDER="1">'
				echo "\t<TR>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tRecv-Q"
				echo "\t</TD>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tSend-Q"
				echo "\t</TD>"
					echo "\t<TD ALIGN=CENTER>"
					echo "\t\tLocal Address"
				echo "\t</TD>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tForeign Address"
				echo "\t</TD>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tState"
				echo "\t</TD>"
				echo "\t<TD ALIGN=CENTER>"
					echo "\t\tUser"
				echo "\t</TD>"
				echo "\t</TR>"
				awk '{ \
					printf "\t%s\n", "<TR>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $2, "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $3, "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT><TT>", $4, "</TT></TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT><TT>", $5, "</TT></TD>" \
					ipxstate = substr($0, 74, 5) ; gsub ( / /, "\&nbsp;", ipxstate ) \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", ipxstate, "</TD>" \
					ipxuser = substr($0, 80, 15) ; gsub ( / /, "", ipxuser ) \
					printf "\t%s\n\t\t<A HREF=\"'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER="'%s\">%s</A>\n\t%s\n", "<TD>", ipxuser, ipxuser, "</TD>" \
					printf "\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.ipx.dat
				echo "\t</TABLE>"
			else
				echo "\tNo IPX connections"
			endif
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	case "unsupported":
		echo "\t<TABLE WIDTH=650 ALIGN=CENTER BORDER=0>"
		foreach protocol (`cat $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.unsupported.dat`)
			echo '\t<TR>\n\t<TD WIDTH="10%">\n\t\t&nbsp;\n\t</TD>\n\t<TD>\t\t<UL>'
			echo "\t\t<LI>$protocol<BR></LI>"
			echo "\t</UL>\n\t</TD>\n\t</TR>"
		end
		echo "\t</TABLE>"
		breaksw

	default:
		echo "Can not find any data for protocol: $PROTOCOL"
		breaksw
endsw


CGIBody

<TABLE WIDTH=650>
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring network protocol `HTMLOut '$PROTOCOL'`.
Description of filds:
<BR><BR>
<EM>Recv-Q</EM> - the  count  of  bytes  not copied by the user program
connected to this socket.
<BR>
<EM>Send-Q</EM> - the count of bytes not acknoledged by the remote host.
<BR>
<EM>Local Address</EM> - the local address (local hostname) and port number
of the socket.
<BR>
<EM>Foreign Address</EM> - the remote address (remote hostname) and port number
of he socket.
<BR>
<EM>State</EM> - the state of the socket. Since there are no states in RAW and
usually no states used in UDP, this row may be left blank. Normally this can be
one of several values: <TT>ESTABLISHED</TT> - the socket has an established
connection, <TT>SYN_SENT</TT> - the socket is actively attempting to establish
a connection, <TT>SYN_RECV</TT> - the connection is being initialized,
<TT>FIN_WAIT1</TT> - the socket is closed, and the connection is shutting down,
<TT>FIN_WAIT2</TT> - connection is closed, and the socket is waiting for a
shutdown from the remote end, <TT>TIME_WAIT</TT> - the socket is waiting after
close for remote  shutdown retransmission, <TT>CLOSED</TT> - the socket is not
being used, <TT>CLOSE_WAIT</TT> - the remote end has shut down, waiting for the
socket to close, <TT>LAST_ACK</TT> - the remote end shut down, and the socket
is closed. Waiting for acknowledgement, <TT>LISTEN</TT> - the socket is
listening for incoming connections, <TT>CLOSING</TT>  - both sockets are shut
down but we still don't have all our data sent, <TT>UNKNOWN</TT>  - the state
of the socket is unknown.
<BR><BR>
<EM>User</EM> - the name or the UID of the owner of the socket.
<BR>
<EM>RefCnt</EM> - the reference count (i.e. attached processes via this socket).
<BR>
<EM>Flags</EM> - the flags displayed is <TT>SO_ACCEPTON</TT> (displayed as
ACC), <TT>SO_WAITDATA</TT> (W) or <TT>SO_NOSPACE</TT> (N).
<TT>SO_ACCECPTON</TT> is used on  unconnected sockets if their corresponding
processes are waiting for a connect request. The other flags are not of normal
interest.
<BR>
<EM>Type</EM> - there are several types of socket access: <TT>SOCK_DGRAM</TT> -
the socket is used in Datagram (connectionless) mode, <TT>SOCK_STREAM</TT> -
this is a stream (connection) socket, <TT>SOCK_RAW</TT> - the socket is used as
a raw socket, <TT>SOCK_RDM</TT> - this one serves reliably-delivered messages,
<TT>SOCK_SEQPACKET</TT> - this is a sequential packet socket,
<TT>SOCK_PACKET</TT> - RAW interface access socket.
<BR><BR>
<EM>State</EM> - this field will contain one of the following Keywords:
<TT>FREE</TT>
- the socket is not allocated, <TT>LISTENING</TT> - the socket is listening for
a connection request, <TT>CONNECTING</TT> - the socket is about to establish a
connection, <TT>CONNECTED</TT> - the socket is connected, <TT>DISCONNECTING</TT>
- the socket is disconnecting, <TT>(empty)</TT> - the socket is not connected
to another one.
<BR>
<EM>Path</EM> - this  displays the  path name as which the corresponding
processes attached to the socket.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS 
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Network protocols monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Protocols.gif' 'Network protocols monitoring'`
	&nbsp;<B>Network protocols monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about network protocols on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#NetworkProtocol">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network protocol'`</A>
		&nbsp;Monitor <A HREF="#NetworkProtocol">network protocol</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Protocols.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Protocols.gif' 'Network protocols monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Protocols.cgi?HOST=$HOST&STATUS=$STATUS">network protocols monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Protocols.gif' 'Monitor network protocol'`
	<A NAME="NetworkProtocol"><EM><B>Monitor network protocol - `HTMLOut '$PROTOCOL'`</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>	

EOM

switch ("$PROTOCOL")

	case "tcp":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.tcp.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tLoacal address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRemote address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tSend wind"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tSend-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tReceive wind"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRecv-Q"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tState"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=CENTER>", $1, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $2, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $3, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $4, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $5, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $6, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=LEFT>", $7, "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.tcp.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw
		
	case "udp":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.udp.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tLocal address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRemote address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tState"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr ( $0, 1, 20 ), "</TD>" \
				rem_addr = substr ( $0, 20, 20) ; gsub ( / / , "\&nbsp;", rem_addr ) \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", rem_addr, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr ( $0, 40, 20 ), "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.udp.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	case "unix":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.unix.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tAddress"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tType"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tV-Node"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tConnection"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tLocal address"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tRemote Address"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $1, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $2, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $3, "</TD>" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", $4, "</TD>" \
				loc_addr = $5 ; gsub ( / /, "\&nbsp;", loc_addr ) \
				if ( loc_addr == "" ) loc_addr = "&nbsp;" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=LEFT>", loc_addr, "</TD>" \
				rem_addr = $6 ; gsub ( / /, "\&nbsp;", rem_addr ) \
				if ( rem_addr == "" ) rem_addr = "&nbsp;" \
				printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=LEFT>", rem_addr, "</TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.unix.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw


	case "arp":
		if ( -e $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.arp.dat) then
			echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tInterface"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tHost"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tMask"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tFlags"
			echo "\t</TD>"
			echo "\t<TD ALIGN=CENTER>"
				echo "\t\tEthernet address"
			echo "\t</TD>"
			echo "\t</TR>"
			awk '{ \
				printf "\t%s\n", "<TR>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=LEFT>", substr($0, 1, 5), "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr($0, 7, 15), "</TD>" \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", substr($0, 28, 16), "</TD>" \
					arpflags = substr($0, 44, 5) ; gsub ( / /, "\&nbsp;", arpflags ) \
					printf "\t%s\n\t\t%s\n\t%s\n", "<TD ALIGN=RIGHT>", arpflags, "</TD>" \
					printf "\t%s\n\t\t&nbsp;%s\n\t%s\n", "<TD ALIGN=RIGHT><TT>", substr($0, 50, 18), "</TT></TD>" \
				printf "\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/net/net.protocol.arp.dat
			echo "\t</TABLE>"
		else
			echo "Can not find any data for protocol: $PROTOCOL"
		endif
		breaksw

	default:
		echo "Can not find any data for protocol: $PROTOCOL"
		breaksw
endsw


CGIBody

<TABLE WIDTH=650>
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring network protocol `HTMLOut '$PROTOCOL'`.
Description of filds:
<BR><BR>
<EM>Recv-Q</EM> - the  count  of  bytes  not copied by the user program
connected to this socket.
<BR>
<EM>Send-Q</EM> - the count of bytes not acknoledged by the remote host.
<BR>
<EM>Local Address</EM> - the local address (local hostname) and port number
of the socket.
<BR>
<EM>Foreign Address</EM> - the remote address (remote hostname) and port number
of he socket.
<BR>
<EM>State</EM> - the state of the socket. Since there are no states in RAW and
usually no states used in UDP, this row may be left blank. The possible state
values for TCP sockets are as follows:
<BR>
<TT>BOUND</TT> - bound, ready to connect or listen, <TT>CLOSED</TT> - closed,
the socket is not being used, <TT>CLOSING</TT> - closed, then remote shutdown
(awaiting acknowledg ment), <TT>CLOSE_WAIT</TT> - remote shutdown, waiting for
the socket to close, <TT>ESTABLISHED</TT> - connection has been established,
<TT>FIN_WAIT_1</TT> - socket closed (shutting down connection),
<TT>FIN_WAIT_2</TT> - socket closed, waiting for shutdown from remote,
<TT>IDLE</TT> - idle, opened but not bound, <TT>LAST_ACK</TT> - remote shutdown,
then closed (awaiting acknowledgment), <TT>LISTEN</TT> - listening for
incoming connections, <TT>SYN_RECEIVED</TT> - initial synchronization of the
connection under way, <TT>SYN_SENT</TT> - actively trying to establish
connection, <TT>TIME_WAIT</TT> - wait after close for remote  shutdown
retransmission.  
<BR><BR>
<EM>RefCnt</EM> - the reference count (i.e. attached processes via this socket).
<BR>
<EM>Flags</EM> - the flags displayed is <TT>SO_ACCEPTON</TT> (displayed as
ACC), <TT>SO_WAITDATA</TT> (W) or <TT>SO_NOSPACE</TT> (N).
<TT>SO_ACCECPTON</TT> is used on  unconnected sockets if their corresponding
processes are waiting for a connect request. The other flags are not of normal
interest.
<BR>
<EM>Type</EM> - there are several types of socket access: <TT>SOCK_DGRAM</TT>
- the socket is used in Datagram (connectionless) mode, <TT>SOCK_STREAM</TT>
- this is a stream (connection) socket, <TT>SOCK_RAW</TT> - the socket is used
as a raw socket, <TT>SOCK_RDM</TT> - this one serves reliably-delivered
messages, <TT>SOCK_SEQPACKET</TT> - this is a sequential packet socket,
<TT>SOCK_PACKET</TT> - RAW interface access socket.
<BR><BR>
<EM>State</EM> - this field will contain one of the following Keywords:
<TT>FREE</TT>
- the socket is not allocated, <TT>LISTENING</TT> - the socket is listening for
a connection request, <TT>CONNECTING</TT> - the socket is about to establish a
connection, <TT>CONNECTED</TT> - the socket is connected,
<TT>DISCONNECTING</TT> - the socket is disconnecting, <TT>(empty)</TT> - the
socket is not connected to another one.
<BR>
<EM>Path</EM> - this  displays the  path name as which the corresponding
processes attached to the socket.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw





default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
