#!/bin/tcsh -f

#
# Wotan.Audit.Network.Routing.Masquerade.cgi v0.3
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Network.Routing.Masquerade.cgi ,v0.3 1999/10/29 14:18:20 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about masqueraded connections
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Cisco.gif' 'Network routing monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">network routing monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/Unix.gif" BORDER=0 ALT="Monitoring and auditing page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Network routing masquerade monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Cisco2.gif' 'Network routing masquerade monitoring'`
	&nbsp;<B>Network routing masquerade monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about network routing masquerade on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#RoutingMasquerade">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network routing masquerade'`</A>
		&nbsp;Monitor <A HREF="#RoutingMasquerade">network routing masquerade</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Cisco.gif' 'Network routing monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">network routing monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monotoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">monitoring and auditing page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Cisco2Finder.gif' 'Monitor network routing masquerade'`
	<A NAME="RoutingMasquerade"><EM><B>Monitor network routing masquerade</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

if !( -z $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat) then

	@ rowindex	= 1
	set rows	= `cat $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat | wc -l`
	set proto	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set expire	= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set initseq	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set delta	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set prevd	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set source	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set destination	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set src_port	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set dest_port	= `awk '{ print $10 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`
	set masq_port	= `awk '{ print $11 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.masquerade.dat`


	echo '\t<TABLE BORDER="1">'

	echo "\t<TR>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tProtocol"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tExpire"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tInit sequence"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tDelta"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tPrevd"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tSource address"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tDestination address"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tSource port"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tDestination port"
	echo "\t</TD>"
	echo "\t<TD ALIGN=CENTER>"
		echo "\t\tMasquerade port"
	echo "\t</TD>"
	echo "\t</TR>"

	while ($rowindex <= $rows)

		echo "\t<TR>"
		echo "\t<TD ALIGN=CENTER>"
			echo "\t\t$proto[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=RIGHT>"
			echo "\t\t$expire[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=CENTER>"
			echo "\t\t$initseq[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=CENTER>"
			echo "\t\t$delta[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=CENTER>"
			echo "\t\t$prevd[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=LEFT>"
			echo "\t\t&nbsp;&nbsp;$source[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=LEFT>"
			echo "\t\t&nbsp;&nbsp;$destination[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=CENTER>"
			echo "\t\t$src_port[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=CENTER>"
			echo "\t\t$dest_port[$rowindex]"
		echo "\t</TD>"
		echo "\t<TD ALIGN=CENTER>"
			echo "\t\t$masq_port[$rowindex]"
		echo "\t</TD>"
		echo "\t</TR>"
	
		@ rowindex++
	end
	echo "\t</TABLE>"
	

else
	echo "Can not find any data for masquerade"
endif

CGIBody
<TABLE WIDTH="650">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring network routing masquerade table.
For more information see <EM>ipfwadm(8)</EM>, <EM>ipchains(8)</EM>,
<EM>ipmasq(8)</EM>, Linux kernel documentation and
<EM>Networking-Overview-HOWTO</EM>, <EM>NET-3-HOWTO</EM>
or <EM>NET-4-HOWTO</EM>.


</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
