#!/bin/tcsh -f

#
# Wotan.Audit.Network.Routing.Table.cgi v0.4
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Network.Routing.Table.cgi ,v0.4 1999/12/09 09:01:52 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about routing table
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Cisco.gif' 'Network routing monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">network routing monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/Unix.gif" BORDER=0 ALT="Monitoring and auditing page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Network routing table monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Cisco2.gif' 'Network routing table monitoring'`
	&nbsp;<B>Network routing table monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about network routing table on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#RoutingTable">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network routing table'`</A>
		&nbsp;Monitor <A HREF="#RoutingTable">network routing table</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Cisco.gif' 'Network routing monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">network routing monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monotoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">monitoring and auditing page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Cisco2Finder.gif' 'Monitor network routing table'`
	<A NAME="RoutingTable"><EM><B>Monitor network routing table</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>
	
EOM

set rows	= `cat $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | wc -l`
@ rowindex	= 1

set num_dest	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set sym_dest	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.symbolic.dat`
set num_gate	= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set sym_gate	= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.symbolic.dat`
set genmask	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set rflags	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set rmetric	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set rref	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set ruse	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set riface	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set mss		= `awk '{ print $9 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set window	= `awk '{ print $10 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set irtt	= `awk '{ print $11 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'
	echo "\t\t<TR>"
	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tDestination IP"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tDestination name"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tGateway IP"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tGateway name"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tGenmask"
	echo '\t\t</TD>'
	
	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tFlags"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tMetric"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tRef"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tUse"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tIface"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tMSS"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tWindow"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tIRTT"
	echo '\t\t</TD>'

	echo "\t\t</TR>"

	
	while ($rowindex <= $rows)
		echo "\t\t<TR>"
		echo '\t\t<TD>'
			echo "\t\t$num_dest[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$sym_dest[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$num_gate[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$sym_gate[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$genmask[$rowindex]"
		echo '\t\t</TD>'
		
		echo '\t\t<TD>'
			echo "\t\t$rflags[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$rmetric[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$rref[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$ruse[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$riface[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$mss[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$window[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$irtt[$rowindex]"
		echo '\t\t</TD>'

		echo "\t\t</TR>"

		@ rowindex++
	end
	echo "</TABLE>"

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring network table. The routing table display lists
the available routes and the status of each. Each route consists of a
destination host or network, and a gateway to use  in  forwarding  packets.
The flags  column  shows  the  status  of the route (U if "up"), whether the
route is to a gateway (G), and whether the route was  created dynamically by a
redirect (D).
<BR><BR>
Interface routes are created for each interface attached  to the local host;
the gateway field for such entries shows the address of the outgoing interface.
<BR><BR>
The refcnt column gives the current number  of  routes  that share the same
link layer address.
<BR><BR>
The use column displays the number of packets sent  using  a combined  routing
and address resolution or a broadcast route. For a local route, this count is
the  number of  packets  received,  and  for  all other routes it is the number
of times the routing entry has been used to create a new combined route and
address resolution entry. 
<BR><BR>
The interface entry indicates the network interface utilized for the route.
<BR><BR>
For more information see manual pages <EM>route(8)</EM>, <EM>netstat(8)</EM>,
<EM>routed(8)</EM> , <EM>gated(8)</EM>, Linux kernel documentation and
<EM>Networking-Overview-HOWTO</EM>, <EM>NET-3-HOWTO</EM> or
<EM>NET-4-HOWTO</EM>.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS 
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Network routing table monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Cisco2.gif' 'Network routing table monitoring'`
	&nbsp;<B>Network routing table monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about network routing table on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#RoutingTable">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network routing table'`</A>
		&nbsp;Monitor <A HREF="#RoutingTable">network routing table</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Cisco.gif' 'Network routing monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.Routing.cgi?HOST=$HOST&STATUS=$STATUS">network routing monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monotoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">network off-line monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">monitoring and auditing page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Cisco2Finder.gif' 'Monitor network routing table'`
	<A NAME="RoutingTable"><EM><B>Monitor network routing table</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>
	
EOM

set rows	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | wc -l`
echo "rows=[$rows]"
@ rowindex	= 1

set num_dest	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set sym_dest	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.symbolic.dat`
set genmask	= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set num_gate	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat`
set sym_gate	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/net/net.route.symbolic.dat`
set riface	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | awk '{ riface = substr ( $0, 58, 7) ; gsub ( / / , "", riface ) ; if ( riface == "" ) riface = "NONE" ; print riface }'`
set mss		= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | awk '{ print substr ( $0, 66, 7) }'`
set rtt		= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | awk '{ print substr ( $0, 74, 3) }'`
set rref	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | awk '{ print substr ( $0, 78, 3) }'`
set rflags	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | awk '{ print substr ( $0, 81, 4) }'`
set out	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | awk '{ print substr ( $0, 84, 8) }'`
set in_fwd	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/net/net.route.numeric.dat | awk '{ print substr ( $0, 95, 5) }'`

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'
	echo "\t\t<TR>"
	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tDestination IP"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tDestination name"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tGenmask"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tGateway IP"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tGateway name"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tDevice"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tMSS"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tRtt"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tRef"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tFlags"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tOut"
	echo '\t\t</TD>'

	echo '\t\t<TD ALIGN="CENTER">'
		echo "\t\tIn/Fwd"
	echo '\t\t</TD>'

	echo "\t\t</TR>"

	
	while ($rowindex <= $rows)
		echo "\t\t<TR>"
		echo '\t\t<TD>'
			echo "\t\t$num_dest[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$sym_dest[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$genmask[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$num_gate[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$sym_gate[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			if ("$riface[$rowindex]" != "NONE") then
				echo "\t\t$riface[$rowindex]"
			else
				echo '\t\t&nbsp;'
			endif
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$mss[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$rtt[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$rref[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD>'
			echo "\t\t$rflags[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$out[$rowindex]"
		echo '\t\t</TD>'

		echo '\t\t<TD ALIGN="RIGHT">'
			echo "\t\t$in_fwd[$rowindex]"
		echo '\t\t</TD>'

		echo "\t\t</TR>"

		@ rowindex++
	end
	echo "</TABLE>"

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring network table. The routing table display lists
the available routes and the status of each. Each route consists of a
destination host or network, and a gateway to use  in  forwarding  packets.
The flags  column  shows  the  status  of the route (U if "up"), whether the
route is to a gateway (G), and whether the route was  created dynamically by a
redirect (D).
<BR><BR>
Interface routes are created for each interface attached  to the local host;
the gateway field for such entries shows the address of the outgoing interface.
<BR><BR>
The refcnt column gives the current number  of  routes  that share the same
link layer address.
<BR><BR>
The use column displays the number of packets sent  using  a combined  routing
and address resolution or a broadcast route. For a local route, this count is
the  number of  packets  received,  and  for  all other routes it is the number
of times the routing entry has been used to create a new combined route and
address resolution entry. 
<BR><BR>
The interface entry indicates the network interface utilized for the route.
<BR><BR>
For more information see manual pages <EM>route(8)</EM>, <EM>netstat(8)</EM>,
<EM>routed(8)</EM> and <EM>gated(8)</EM>.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw



default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
