#!/bin/tcsh -f

#
# Wotan.Audit.Overview.cgi v0.4
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Overview.cgi ,v0.4 1999/12/08 16:28:10 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document main auditing overview page
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Search for remote host data files
#
if !(-e $WOTAN_HOME/hosts/$HOST && -d $WOTAN_HOME/hosts/$HOST) then

error:

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' ' Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM

if ("$WOTAN_WEB_METHOD" == "CGI") then
	echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Main.cgi"><IMG SRC="'"$AUDIT_IMG_URL"'/Monitoring.gif" BORDER=0 ALT="Main page"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>'
else
	echo '\t<A HREF="'"$AUDIT_DOC_URL"'/Wotan.Audit.Main.html"><IMG SRC="'"$AUDIT_IMG_URL"'/Monitoring.gif" BORDER=0 ALT="Main page"></A>&nbsp;Back to <A HREF="'"$AUDIT_DOC_URL"'/Wotan.Audit.Main.html">main auditing and monitoring page</A>'
endif
CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan monitoring and auditing package operates as both a producer and consumer
of status information.  As a producer of information it periodically queries
the state of the remote system and constructs status messages which are stored
as simple text databases located in the directory
<EM>$WOTAN_HOME/hosts/<B>hostname</B></EM>. As a consumer of information, it
listens for queries on web server, validating them and then collection
available information as HTML documents.
<BR><BR>
Wotan can not find any data for host <EM>`HTMLOut '$HOST'`</EM>. It means, that
directory <EM>$WOTAN_HOME/hosts/<B>`HTMLOut '$HOST'`</B></EM> not exists.
Please, check Wotan configuration and directory structure for host
<EM>`HTMLOut '$HOST'`</EM>. For more information see included documentation.
Wotan now support Linux and Solaris operating system only. Other platforms will
be supported later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Auditing and monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH="650" BORDER=0>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Auditing and monitoring'`
	&nbsp;<B>Auditing and monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Accounting.gif' 'User and group monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Accounting.cgi?HOST=$HOST&STATUS=$STATUS">User and group monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network off-line monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Network.cgi?HOST=$HOST&STATUS=$STATUS">Network off-line monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/CDSmall.gif' 'Filesystems monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Filesystem.cgi?HOST=$HOST&STATUS=$STATUS">Filesystems monitoring</A>
	</TD>
	</TR>


	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring</A>
	</TD>
	</TR>

EOM
set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
if ( "$WotanPlarform" == "Linux" ) then
	echo "\t<TR>"
	echo "\t<TD WIDTH=5%>"
		echo "\t\t&nbsp;"
	echo "\t</TD>"
	echo "\t<TD WIDTH=95%>"
		echo '\t\t<A HREF="'"$SNMP_CGI_URL"'/Wotan.SNMP.Main.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/SNMP.gif" BORDER=0 ALT="SNMP monitor"></A>'
		echo '\t\t&nbsp;<A HREF="'"$SNMP_CGI_URL"'/Wotan.SNMP.Main.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">SNMP extended monitor</A>'
	echo "\t</TD>"
	echo "\t</TR>"

endif
CGIBody
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
EOM

if ("$WOTAN_WEB_METHOD" == "CGI") then
		echo '\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Main.cgi"><IMG SRC="'"$AUDIT_IMG_URL"'/Monitoring.gif" BORDER=0 ALT="Main page"></A>'
		echo '\t\t&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>'
else
		echo '\t\t<A HREF="'"$AUDIT_DOC_URL"'/Wotan.Audit.Main.html"><IMG SRC="'"$AUDIT_IMG_URL"'/Monitoring.gif" BORDER=0 ALT="Main page"></A>'
		echo '\t\t&nbsp;Back to <A HREF="'"$AUDIT_DOC_URL"'/Wotan.Audit.Main.html">main auditing and monitoring page</A>'
endif

CGIBody
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM><BR><BR></A>
Wotan monitoring and auditing package operates as both a producer and consumer
of status information.  As a producer of information it periodically queries
the state of the remote system and constructs status messages which are stored
as simple text databases located in the directory
<EM>$WOTAN_HOME/hosts/<B>hostname</B></EM>. As a consumer of information, it
listens for queries on web server, validating them and then collection
available information as HTML documents.
<BR><BR>
Wotan find data for host <EM>`HTMLOut '$HOST'`</EM>. It means, that databases
stored in directory <EM>$WOTAN_HOME/hosts/<B>`HTMLOut '$HOST'`</B></EM> may be
OK and valid. In other way, please, check Wotan configuration and directory
structure for host <EM>`HTMLOut '$HOST'`</EM>. Wotan now support Linux and
Solaris operating system only. Other platforms will be supported later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

end:

# /* End of CGI script */
