#!/bin/tcsh -f

#
# Wotan.Audit.System.Devices.IO.cgi v0.5
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.System.Devices.IO.cgi ,v0.5 1999/11/11 11:11:11 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about system devices I/O
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">system monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif

#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System devices I/O monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/mech.gif' 'System devices I/O monitoring'`
	&nbsp;<B>System devices I/O monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about system devices I/O operations on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#SystemIO">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor system devices I/O'`</A>
		&nbsp;Monitor <A HREF="#SystemIO">system devices I/O</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Devices.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/mech.gif' 'System devices monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Devices.cgi?HOST=$HOST&STATUS=$STATUS">devices monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/mechFinder.gif' 'Monitor system devices I/O'`
	<A NAME="SystemIO"><EM><B>Monitor system devices I/O</B></EM></A>
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
EOM

	echo '\t<TABLE WIDTH="650" BORDER="0">'

	echo "\t<TR>"
	echo '\t<TD WIDTH="95%" VALIGN="TOP">'
	
		echo '\t\t<TABLE BORDER="0">'
	
		echo "\t\t<TR>"
		echo '\t\t<TD VALIGN="TOP">'
			echo '\t\t\t<UL><LI>Devices I/O operations:</LI></UL>'
		echo "\t\t</TD>"
		echo "\t\t</TR>"
		
		echo "\t\t<TR>"
		echo '\t\t<TD ALIGN="CENTER" VALIGN="TOP">'
			
			echo '\t\t<TABLE BORDER="0">'
			
			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="33%">'
				echo '\t\t\t<EM>Device</EM>'
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="33%">'
				echo '\t\t\t<EM>Read blocks</EM>'
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="33%">'
				echo '\t\t\t<EM>Write blocks</EM>'
			echo "\t\t</TD>"
			echo "\t\t</TR>"
		
			@ dev_index	= 1
			while ($dev_index <= 4)
			awk '{ \
				devices[1] = "hda" ; devices[2] = "hdb" \
				devices[3] = "hdc" ; devices[4] = "hdd" \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD ALIGN=LEFT WIDTH=\"33%\">" \
					dev = '"$dev_index"' \
					printf "\t\t\t/dev/%s\n", devices[dev] \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=RIGHT WIDTH=\"33%\">" \
					if ( $1 != "" ) { \
						gsub ( /[rw]/ , "", $1 ) ; read = $1\
					} \
					else { \
						read = "&nbsp;" \
					} \
					printf "\t\t\t%s\n", read \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=RIGHT WIDTH=\"33%\">" \
					if ( $2 != "" ) { \
						gsub ( /[rw]/ , "", $2 ) ; write = $2 \
					} \
					else { \
						write = "&nbsp;" \
					} \
					printf "\t\t\t%s\n", write \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.io.dev${dev_index}.dat
			@ dev_index++
			end
			echo "\t\t</TABLE>"

		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t\t</TABLE>"

		echo "<BR><BR>"

		echo '\t\t<TABLE BORDER="0">'
	
		echo "\t\t<TR>"
		echo '\t\t<TD VALIGN="TOP">'
			echo '\t\t\t<UL><LI>Block I/O operations:</LI></UL>'
		echo "\t\t</TD>"
		echo "\t\t</TR>"
		
		echo "\t\t<TR>"
		echo '\t\t<TD ALIGN="CENTER" VALIGN="TOP">'

			echo '\t\t<TABLE BORDER="0">'

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Blocks sent to a block device:" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s(blocks/s)\n", $10 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Blocks received from a block device:" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s(blocks/s)\n", $11 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

			echo "\t\t</TABLE>"

		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t\t</TABLE>"

		echo "<BR><BR>"

		echo '\t\t<TABLE BORDER="0">'
	
		echo "\t\t<TR>"
		echo '\t\t<TD VALIGN="TOP">'
			echo '\t\t\t<UL><LI>System I/O operations:</LI></UL>'
		echo "\t\t</TD>"
		echo "\t\t</TR>"
		
		echo "\t\t<TR>"
		echo '\t\t<TD ALIGN="CENTER" VALIGN="TOP">'

			echo '\t\t<TABLE BORDER="0">'

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Interrupts per second:" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n", $12 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Context switches per second:" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n", $13 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

			echo "\t\t</TABLE>"

		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t\t</TABLE>"


	echo "\t</TD>"
	echo "\t</TR>"
	echo "\t</TABLE>"

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring system device I/O subsystem.
Wotan reports terminal, disk, and tape I/O activity, as well as CPU
utilization.
<BR><BR>
To compute this information, the kernel maintains a number of counters. For
each disk, the kernel counts reads, writes, bytes read, and bytes written. The
kernel also takes  hi-res time stamps at queue entry and exit points, which
allows it to keep track of the residence time and cumulative residence-length
product for each queue.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS 
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System devices I/O monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/mech.gif' 'System devices I/O monitoring'`
	&nbsp;<B>System devices I/O monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about system devices I/O operations on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#SystemIO">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor system devices I/O'`</A>
		&nbsp;Monitor <A HREF="#SystemIO">system devices I/O</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Devices.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/mech.gif' 'System devices monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Devices.cgi?HOST=$HOST&STATUS=$STATUS">devices monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/mechFinder.gif' 'Monitor system devices I/O'`
	<A NAME="SystemIO"><EM><B>Monitor system devices I/O</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

	set devices	= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.io.devices.all.dat`

	foreach device (`echo $devices`)
		echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Device</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Name</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Transferred<BR>(KB/s)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Transfers<BR>(per&nbsp;second)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Average&nbsp;service<BR>time (ms)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Reads<BR>(per&nbsp;second)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Writes<BR>(per&nbsp;second)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Disk utilization<BR>(%)</EM>"
			echo "\t</TD>"

			echo "\t</TR>"

			echo "\t<TR>"
			echo '\t<TD ALIGN="CENTER">'
				echo "\t\t${device}"
			echo "\t</TD>"

				awk 'BEGIN{ i = 1 }{ \
					if ( int ( i ) <= 7 ) { \
						printf "\t%s\n", "<TD ALIGN=\"RIGHT\" VALIGN=\"TOP\">" \
						printf "\t\t%s\n", $1 \
						printf "\t%s\n", "</TD>" \
					} \
					i++ \
			}END{ printf "\t%s\n", "</TR>" }' < $WOTAN_HOME/hosts/$HOST/data/system/system.io.${device}.dat

		echo "\t</TABLE>"
		echo "\t<BR><BR>"
	end

	echo "\t<BR><BR>"
	echo "<EM>Average I/O statistic:</EM>"
	echo "\t<BR><BR>"

	foreach device (`echo $devices`)
		echo '\t<TABLE BORDER="1">'
			echo "\t<TR>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Device</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Reads/s</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Writes/s</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Read<BR>(KB/s)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Write<BR>(KB/s)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>I/O wait</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Average&nbsp;number<BR>of&nbsp;transactions</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Average&nbsp;service<BR>time&nbsp;(ms)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Waiting&nbsp;for<BR>service&nbsp;(%)</EM>"
			echo "\t</TD>"

			echo '\t<TD ALIGN="CENTER" VALIGN="TOP">'
				echo "\t\t<EM>Busy&nbsp;time<BR>(%)</EM>"
			echo "\t</TD>"

			echo "\t</TR>"

			echo "\t<TR>"
				awk '/'"$device"'    /{ \
					for ( i = 1 ; i <= 10 ; i++ ) { \
						printf "\t%s\n", "<TD ALIGN=\"RIGHT\" VALIGN=\"TOP\">" \
						printf "\t\t%s\n", $i \
						printf "\t%s\n", "</TD>" \
					} \
					i++ \
			}END{ printf "\t%s\n", "</TR>" }' < $WOTAN_HOME/hosts/$HOST/data/system/system.io.${device}.dat

		echo "\t</TABLE>"
		echo "\t<BR><BR>"
	end


CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring system device I/O subsystem.
Wotan reports terminal, disk, and tape I/O activity, as well as CPU
utilization.
<BR><BR>
To compute this information, the kernel maintains a number of counters. For
each disk, the kernel counts reads, writes, bytes read, and bytes written. The
kernel also takes  hi-res time stamps at queue entry and exit points, which
allows it to keep track of the residence time and cumulative residence-length
product for each queue.
<BR><BR>
See Solaris 1.x to 2.x Transition Guide for device naming conventions for
disks.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# Unknown platform
#
default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
