#!/bin/tcsh -f

#
# Wotan.Audit.System.IPC.MessageQueues.cgi v0.6
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.System.IPC.MessageQueues.cgi ,v0.6 1999/10/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about IPC message queues
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">system monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System IPC message queues monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC message queues monitoring'`
	&nbsp;<B>System IPC message queues monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about IPC message queues on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#IPCMessageQueues">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor message queues'`</A>
		&nbsp;Monitor <A HREF="#IPCMessageQueues">message queues</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/IPCFinder.gif' 'Monitor message queues'`
	<A NAME="IPCMessageQueues"><EM><B>Monitor message queues</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

	set queues		= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat | sed '/^$/d' | wc -l`
	set queues_keys		= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_msqid	= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_owner	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_perms	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_bytes	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_messages	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_lspid	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.pids.dat`
	set queues_lrpid	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.pids.dat`
	set queues_send		= `awk '{ send = substr ( $0, 20, 20 ) ; gsub ( / /, "\377", send ) ; print send }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.times.dat`
	set queues_recv		= `awk '{ recv = substr ( $0, 40, 20 ) ; gsub ( / /, "\377", recv ) ; print recv }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.times.dat`
	set queues_change	= `awk '{ change = substr ( $0, 60, 20 ) ; gsub ( / /, "\377", change ) ; print change }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.times.dat`
	set queues_cuid		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.creators.dat`
	set queues_cgid		= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.creators.dat`
	set queues_uid		= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.creators.dat`
	set queues_gid		= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.creators.dat`


	if ("$queues" == "0") then

		echo "IPC facility message queues inactive."

	else

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Key</EM>"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>ID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Owner</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Permisions</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Used bytes</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Number of messages</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Sender PID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Receiver PID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Send</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Receive</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Change</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator GID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>GID</EM>"	
		echo "\t</TD>"
	
		echo "\t</TR>"

	@ queue_index	= 1
	while ($queue_index <= $queues)

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_keys[$queue_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_msqid[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$queues_owner[$queue_index]"'">'"$queues_owner[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_perms[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_bytes[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_messages[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_lspid[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_lrpid[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set send	= `echo $queues_send[$queue_index] | awk '{ send = $0 ; gsub ( /\377/, " ", send) ; print send }'`
			echo "\t\t&nbsp;$send&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set recv	= `echo $queues_recv[$queue_index] | awk '{ recv = $0 ; gsub ( /\377/, " ", recv) ; print recv }'`
			echo "\t\t&nbsp;$recv&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set change	= `echo $queues_change[$queue_index] | awk '{ change = $0 ; gsub ( /\377/, " ", change) ; print change }'`
			echo "\t\t&nbsp;$change&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$queues_cuid[$queue_index]"'">'"$queues_cuid[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$queues_cgid[$queue_index]"'">'"$queues_cgid[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$queues_uid[$queue_index]"'">'"$queues_uid[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$queues_gid[$queue_index]"'">'"$queues_gid[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo "\t</TR>"

		@ queue_index++
	end

	echo "\t</TABLE>"

	endif

	echo "<BR><BR>"

	echo '\t\t<TABLE WIDTH="500" BORDER="0">'

		echo "\t\t<TR>" 
		echo '\t\t<TD WIDTH="70%">'
		echo "\t\t\t<EM>Message queues limits:</EM>"
		echo "\t\t</TD>"
		echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
		echo "\t\t\t<EM>Value</EM>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"

		awk -F"=" '/max queues system wide/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max queues system wide:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.limits.dat

		awk -F"=" '/max size of message/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max size of message (bytes):" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.limits.dat
		
		awk -F"=" '/default max size of queue/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Default max size of queue (bytes):" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.limits.dat

	echo "\t\t</TABLE>"

	echo "<BR><BR>"

	echo '\t\t<TABLE WIDTH="500" BORDER="0">'

		echo "\t\t<TR>" 
		echo '\t\t<TD WIDTH="70%">'
		echo "\t\t\t<EM>Message queues summary:</EM>"
		echo "\t\t</TD>"
		echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
		echo "\t\t\t<EM>Value</EM>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"

		awk '/allocated queues/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Allocated queues:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $4 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.summary.dat

		awk '/used headers/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Used headers:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $4 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.summary.dat
		
		awk '/used space/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Used space (bytes):" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $4 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.summary.dat

	echo "\t\t</TABLE>"

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring information about active message queues.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS 
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System IPC message queues monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC message queues monitoring'`
	&nbsp;<B>System IPC message queues monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about IPC message queues on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#IPCMessageQueues">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor message queues'`</A>
		&nbsp;Monitor <A HREF="#IPCMessageQueues">message queues</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/IPCFinder.gif' 'Monitor message queues'`
	<A NAME="IPCMessageQueues"><EM><B>Monitor message queues</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

	set queues		= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat | sed '/^$/d' | wc -l`
	set queues_types	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_ids		= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_keys		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_modes	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_owner	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_group	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.info.dat`
	set queues_lspid	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.pids.dat`
	set queues_lrpid	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.pids.dat`
	set queues_send		= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.times.dat`
	set queues_recv		= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.times.dat`
	set queues_change	= `awk '{ print $9 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.times.dat`
	set queues_cuid		= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.creators.dat`
	set queues_cgid		= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.queues.creators.dat`

	if ("$queues" == "0") then

		echo "IPC facility message queues inactive."

	else

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Type</EM>"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>ID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Key</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Mode</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Owner</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Gropu</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Sender PID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Receiver PID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Send</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Receive</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Change</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator GID</EM>"	
		echo "\t</TD>"
	
		echo "\t</TR>"

	@ queue_index	= 1
	while ($queue_index <= $queues)

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_types[$queue_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_ids[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_keys[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_modes[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$queues_owner[$queue_index]"'">'"$queues_owner[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$queues_group[$queue_index]"'">'"$queues_group[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_lspid[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$queues_lrpid[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$queues_send[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$queues_recv[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$queues_change[$queue_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$queues_cuid[$queue_index]"'">'"$queues_cuid[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$queues_cgid[$queue_index]"'">'"$queues_cgid[$queue_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo "\t</TR>"

		@ queue_index++
	end

	echo "\t</TABLE>"

	endif

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring information about active message queues.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
