#!/bin/tcsh -f

#
# Wotan.Audit.System.IPC.SemaphoreArrays.cgi v0.5
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.System.IPC.SemaphoreArrays.cgi ,v0.5 1999/12/09 15:29:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about IPC semaphore arrays
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">system monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System IPC semaphore arrays monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC semaphore arrays monitoring'`
	&nbsp;<B>System IPC semaphore arrays monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about IPC semaphore arrays on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#IPCSemaphoreArrays">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor semaphore arrays'`</A>
		&nbsp;Monitor <A HREF="#IPCSemaphoreArrays">semaphore arrays</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/IPCFinder.gif' 'Monitor semaphore arrays'`
	<A NAME="IPCSemaphoreArrays"><EM><B>Monitor semaphore arrays</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

	set semaphores		= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat | sed '/^$/d' | wc -l`
	set semaphore_keys	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_semid	= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_owner	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_perms	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_nsems	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_status	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`

	set num_of_fields	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat | awk '{print NF}'`
	if ("$num_of_fields" == "6") then
		set semaphore_status	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	else
		set num_of_raws	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat | wc -l`
		set semaphore_status	= ""
		@ tmp_index		= 1
		while ($tmp_index <= $num_of_raws)
			set semaphore_status	= ($semaphore_status "?")
			@ tmp_index++
		end
	endif
	set semaphore_op	= `awk '{ op = substr ( $0, 19, 25 ) ; gsub ( / /, "\377", op ) ; print op }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.times.dat`
	set semaphore_changed	= `awk '{ changed = substr ( $0, 46, 25 ) ; gsub ( / /, "\377", changed ) ; print changed }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.times.dat`
	set semaphore_cuid	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.creators.dat`
	set semaphore_cgid	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.creators.dat`
	set semaphore_uid	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.creators.dat`
	set semaphore_gid	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.creators.dat`

	if ("$semaphores" == "0") then
		
		echo "IPC facility semaphore arrays inactive."

	else

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Key</EM>"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>ID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Owner</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Permisions</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Number<BR>of semaphores</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Status</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Last operation</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Last changed</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator<BR>UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator<BR>GID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>GID</EM>"	
		echo "\t</TD>"
	
		echo "\t</TR>"

	@ semaphore_index	= 1
	while ($semaphore_index <= $semaphores)

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_keys[$semaphore_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_semid[$semaphore_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$semaphore_owner[$semaphore_index]"'">'"$semaphore_owner[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_perms[$semaphore_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_nsems[$semaphore_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_status[$semaphore_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set op	= `echo $semaphore_op[$semaphore_index] | awk '{ op = $0 ; gsub ( /\377/, " ", op) ; print op }'`
			echo "\t\t&nbsp;$op&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set changed	= `echo $semaphore_changed[$semaphore_index] | awk '{ changed = $0 ; gsub ( /\377/, " ", changed) ; print changed }'`
			echo "\t\t&nbsp;$changed&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$semaphore_cuid[$semaphore_index]"'">'"$semaphore_cuid[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$semaphore_cgid[$semaphore_index]"'">'"$semaphore_cgid[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$semaphore_uid[$semaphore_index]"'">'"$semaphore_uid[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$semaphore_gid[$semaphore_index]"'">'"$semaphore_gid[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo "\t</TR>"

		@ semaphore_index++
	end

	echo "\t</TABLE>"

	endif

	echo "<BR><BR>"

	echo '\t\t<TABLE WIDTH="500" BORDER="0">'

		echo "\t\t<TR>" 
		echo '\t\t<TD WIDTH="70%">'
		echo "\t\t\t<EM>Semaphore arrays limits:</EM>"
		echo "\t\t</TD>"
		echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
		echo "\t\t\t<EM>Value</EM>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"

		awk -F"=" '/max number of arrays/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max number of arrays:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.limits.dat

		awk -F"=" '/max semaphores per array/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max semaphores per array:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.limits.dat
		
		awk -F"=" '/max semaphores system wide/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max semaphores system wide:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.limits.dat

		awk -F"=" '/max ops per semop call/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max ops per semop call:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.limits.dat

		awk -F"=" '/semaphore max value/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Semaphore max value:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.limits.dat

	echo "\t\t</TABLE>"

	echo "<BR><BR>"

	echo '\t\t<TABLE WIDTH="500" BORDER="0">'

		echo "\t\t<TR>" 
		echo '\t\t<TD WIDTH="70%">'
		echo "\t\t\t<EM>Semaphore arrays summary:</EM>"
		echo "\t\t</TD>"
		echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
		echo "\t\t\t<EM>Value</EM>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"

		awk '/used arrays/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Used arrays:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $4 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.summary.dat

		awk '/allocated semaphores/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Allocated semaphores:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $4 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.summary.dat
		
	echo "\t\t</TABLE>"


CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring information about active semaphores.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS 
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System IPC semaphore arrays monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC semaphore arrays monitoring'`
	&nbsp;<B>System IPC semaphore arrays monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about IPC semaphore arrays on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#IPCSemaphoreArrays">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor semaphore arrays'`</A>
		&nbsp;Monitor <A HREF="#IPCSemaphoreArrays">semaphore arrays</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/IPCFinder.gif' 'Monitor semaphore arrays'`
	<A NAME="IPCSemaphoreArrays"><EM><B>Monitor semaphore arrays</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

	set semaphores		= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat | sed '/^$/d' | wc -l`
	set semaphore_types	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_ids	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_keys	= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_modes	= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_owner	= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_group	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.info.dat`
	set semaphore_op	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.times.dat`
	set semaphore_changed	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.times.dat`
	set semaphore_cuid	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.creators.dat`
	set semaphore_cgid	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.semaphore.creators.dat`

	if ("$semaphores" == "0") then
		
		echo "IPC facility semaphore arrays inactive."

	else

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Type</EM>"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>ID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Key</EM>"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Mode</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Owner</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Group</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Last operation</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Last changed</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator<BR>UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator<BR>GID</EM>"	
		echo "\t</TD>"
	
		echo "\t</TR>"

	@ semaphore_index	= 1
	while ($semaphore_index <= $semaphores)

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_types[$semaphore_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_ids[$semaphore_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_keys[$semaphore_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$semaphore_modes[$semaphore_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$semaphore_owner[$semaphore_index]"'">'"$semaphore_owner[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$semaphore_group[$semaphore_index]"'">'"$semaphore_group[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$semaphore_op[$semaphore_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$semaphore_changed[$semaphore_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$semaphore_cuid[$semaphore_index]"'">'"$semaphore_cuid[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$semaphore_cgid[$semaphore_index]"'">'"$semaphore_cgid[$semaphore_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo "\t</TR>"

		@ semaphore_index++
	end

	echo "\t</TABLE>"

	endif

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring information about active semaphores.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw



default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
