#!/bin/tcsh -f

#
# Wotan.Audit.System.IPC.SharedMemory.cgi v0.8
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.System.IPC.SharedMemory.cgi ,v0.8 1999/11/18 17:33:40 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about IPC shared memory segments
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">system monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif

#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System IPC shared memory monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC shared memory monitoring'`
	&nbsp;<B>System IPC shared memory monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about IPC shared memory segments on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#IPCSharedMemory">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor shared memory segments'`</A>
		&nbsp;Monitor <A HREF="#IPCSharedMemory">shared memory segments</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/IPCFinder.gif' 'Monitor shared memory segments'`
	<A NAME="IPCSharedMemory"><EM><B>Monitor shared memory segments</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

	set shmems		= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat | sed '/^$/d' | wc -l`
	set shmem_keys		= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_shmid		= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_owner		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_perms		= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_bytes		= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_nattch	= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set num_of_fields	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat | awk '{print NF}'`
	if ("$num_of_fields" == "7") then
		set shmem_status	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	else
		set num_of_raws	= `sed '/^$/d' $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat | wc -l`
		set shmem_status	= ""
		@ tmp_index		= 1
		while ($tmp_index <= $num_of_raws)
			set shmem_status	= ($shmem_status "?")
			@ tmp_index++
		end
	endif
	set shmem_cpid		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.pids.dat`
	set shmem_lpid		= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.pids.dat`
	set shmem_attached	= `awk '{ attached = substr ( $0, 22, 20 ) ; gsub ( / /, "\377", attached ) ; print attached }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.times.dat`
	set shmem_detached	= `awk '{ detached = substr ( $0, 42, 20 ) ; gsub ( / /, "\377", detached ) ; print detached }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.times.dat`
	set shmem_changed	= `awk '{ changed = substr ( $0, 62, 20 ) ; gsub ( / /, "\377", changed ) ; print changed }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.times.dat`
	set shmem_cuid		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.creators.dat`
	set shmem_cgid		= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.creators.dat`
	set shmem_uid		= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.creators.dat`
	set shmem_gid		= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.creators.dat`

	if ("$shmems" == "0") then
		
		echo "IPC facility shared memory segments inactive."

	else

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Key</EM>"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>ID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Owner</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Permisions</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Used bytes</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Number of attachments</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Status</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator PID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>LPID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Attached</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Detached</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Changed</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator GID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>GID</EM>"	
		echo "\t</TD>"
	
		echo "\t</TR>"

	@ shmem_index	= 1
	while ($shmem_index <= $shmems)

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_keys[$shmem_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_shmid[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$shmem_owner[$shmem_index]"'">'"$shmem_owner[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_perms[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_bytes[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_nattch[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_status[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_cpid[$shmem_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_lpid[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set attached	= `echo $shmem_attached[$shmem_index] | awk '{ attached = $0 ; gsub ( /\377/, " ", attached) ; print attached }'`
			echo "\t\t&nbsp;$attached&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set detached	= `echo $shmem_detached[$shmem_index] | awk '{ detached = $0 ; gsub ( /\377/, " ", detached) ; print detached }'`
			echo "\t\t&nbsp;$detached&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER" NOWRAP>'
			set changed	= `echo $shmem_changed[$shmem_index] | awk '{ changed = $0 ; gsub ( /\377/, " ", changed) ; print changed }'`
			echo "\t\t&nbsp;$changed&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$shmem_cuid[$shmem_index]"'">'"$shmem_cuid[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$shmem_cgid[$shmem_index]"'">'"$shmem_cgid[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$shmem_uid[$shmem_index]"'">'"$shmem_uid[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$shmem_gid[$shmem_index]"'">'"$shmem_gid[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo "\t</TR>"

		@ shmem_index++
	end

	echo "\t</TABLE>"

	endif

	echo "<BR><BR>"

	echo '\t\t<TABLE WIDTH="500" BORDER="0">'

		echo "\t\t<TR>" 
		echo '\t\t<TD WIDTH="70%">'
		echo "\t\t\t<EM>Shared memory segments limits:</EM>"
		echo "\t\t</TD>"
		echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
		echo "\t\t\t<EM>Value</EM>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"

		awk -F"=" '/max number of segments/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max number of segments:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.limits.dat

		awk -F"=" '/max seg size/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max seg size (kbytes):" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.limits.dat
		
		awk -F"=" '/max total shared memory/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Max total shared memory (kbytes):" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.limits.dat

		awk -F"=" '/min seg size/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Min seg size (bytes):" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $2 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.limits.dat

	echo "\t\t</TABLE>"

	echo "<BR><BR>"

	echo '\t\t<TABLE WIDTH="500" BORDER="0">'

		echo "\t\t<TR>" 
		echo '\t\t<TD WIDTH="70%">'
		echo "\t\t\t<EM>Shared memory summary:</EM>"
		echo "\t\t</TD>"
		echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
		echo "\t\t\t<EM>Value</EM>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"

		awk '/segments allocated/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Segments allocated:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $3 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.summary.dat

		awk '/pages allocated/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Pages allocated:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $3 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.summary.dat
		
		awk '/pages resident/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Pages resident:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $3 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.summary.dat

		awk '/pages swapped/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
			printf "\t\t\t%s\n", "Pages swapped:" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
			printf "\t\t\t%s\n", $3 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.summary.dat

		awk '/Swap performance/{ \
			printf "\t\t%s\n", "<TR>" \
			printf "\t\t%s\n", "<TD WIDTH=\"70%\" NOWRAP>" \
			printf "\t\t\t%s\n", "Swap performance (attempts/successes):" \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" VALIGN=\"TOP\" WIDTH=\"30%\">" \
			printf "\t\t\t%s/%s\n", $3, $5 \
			printf "\t\t%s\n", "</TD>" \
			printf "\t\t%s\n", "</TR>" \
		}' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.summary.dat


	echo "\t\t</TABLE>"


CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring information about active shared memory
segments.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS 
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System IPC shared memory monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC shared memory monitoring'`
	&nbsp;<B>System IPC shared memory monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about IPC shared memory segments on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#IPCSharedMemory">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor shared memory segments'`</A>
		&nbsp;Monitor <A HREF="#IPCSharedMemory">shared memory segments</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'System IPC monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">system IPC monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/IPCFinder.gif' 'Monitor shared memory segments'`
	<A NAME="IPCSharedMemory"><EM><B>Monitor shared memory segments</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

EOM

	set shmems		= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat | sed '/^$/d' | wc -l`
	set shmem_types		= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_ids		= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_keys		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_modes		= `awk '{ print $4 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_owner		= `awk '{ print $5 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_group		= `awk '{ print $6 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.info.dat`
	set shmem_cpid		= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.pids.dat`
	set shmem_lpid		= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.pids.dat`
	set shmem_attached	= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.times.dat`
	set shmem_detached	= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.times.dat`
	set shmem_changed	= `awk '{ print $9 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.times.dat`
	set shmem_cuid		= `awk '{ print $7 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.creators.dat`
	set shmem_cgid		= `awk '{ print $8 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.ipc.shmem.creators.dat`


	if ("$shmems" == "0") then
		
		echo "IPC facility shared memory segments inactive."

	else

	echo '\t<TABLE ALIGN="CENTER" BORDER="1">'

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Type</EM>"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>ID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Key</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Mode</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Owner</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Group</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator PID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>LPID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Attached</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Detached</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Changed</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator UID</EM>"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="CENTER">'
			echo "\t\t<EM>Creator GID</EM>"	
		echo "\t</TD>"
	
		echo "\t</TR>"

	@ shmem_index	= 1
	while ($shmem_index <= $shmems)

		echo "\t<TR>"
		
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_types[$shmem_index]&nbsp;"	
		echo "\t</TD>"

		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_ids[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_keys[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_modes[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$shmem_owner[$shmem_index]"'">'"$shmem_owner[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$shmem_group[$shmem_index]"'">'"$shmem_group[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_cpid[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER">'
			echo "\t\t&nbsp;$shmem_lpid[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$shmem_attached[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$shmem_detached[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="RIGHT" VALIGN="CENTER" NOWRAP>'
			echo "\t\t&nbsp;$shmem_changed[$shmem_index]&nbsp;"	
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER=$shmem_cuid[$shmem_index]"'">'"$shmem_cuid[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo '\t<TD ALIGN="LEFT" VALIGN="CENTER">'
			echo '\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.Group.cgi?HOST=$HOST&STATUS=$STATUS&GROUP=$shmem_cgid[$shmem_index]"'">'"$shmem_cgid[$shmem_index]</A>&nbsp;"
		echo "\t</TD>"
	
		echo "\t</TR>"

		@ shmem_index++
	end

	echo "\t</TABLE>"

	endif

CGIBody

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring information about active shared memory
segments.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
