#!/bin/tcsh -f

#
# Wotan.Audit.System.Kernel.Usage.cgi v0.4
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.Kernel.Usage.cgi ,v0.4 1999/11/30 21:36:12 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about kernel usage
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Workshop.gif' 'System kernel monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">kernel monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">system monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Kernel usage monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Workshop.gif' 'Kernel usage monitoring'`
	&nbsp;<B>Kernel usage monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about kernel usage on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#KernelUsage">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor kernel usage'`</A>
		&nbsp;Monitor <A HREF="#KernelUsage">kernel usage</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Workshop.gif' 'System kernel monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">kernel monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/WorkshopFinder.gif' 'Monitor kernel usage'`
	<A NAME="KernelUsage"><EM><B>Monitor kernel usage</B></EM></A>
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
EOM
	echo '\t<TABLE WIDTH="650" BORDER="0">'

	echo "\t<TR>"
	echo '\t<TD WIDTH="500" VALIGN="TOP">'
	
		echo '\t\t<TABLE WIDTH="450" BORDER="0">'
	
		echo "\t\t<TR>"
		echo '\t\t<TD ALIGN="CENTER" VALIGN="TOP">'
			
			echo '\t\t<TABLE WIDTH="400" BORDER="0">'
			
			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="33%">'
				echo '\t\t\t<EM>Space type</EM>'
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="33%">'
				echo '\t\t\t<EM>Time</EM>'
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN="RIGHT" WIDTH="33%">'
				echo '\t\t\t<EM>Percentage</EM>'
			echo "\t\t</TD>"
			echo "\t\t</TR>"
			
			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "User" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $2 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.user.dat
			
			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "Nice" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $2 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.nice.dat
			
			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "System" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $2 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.system.dat

			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "Idle" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $2 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.idle.dat

			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "Uptime" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "100.0%" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.uptime.dat

			echo "\t\t</TABLE>"

			echo "<BR><BR>"

			echo '\t\t<TABLE WIDTH="400" BORDER="0">'

				echo "\t\t<TR>"
				echo '\t\t<TD WIDTH="50%">'
				echo "\t\t\t<EM>System load average</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="RIGHT" WIDTH="50%">'
				echo "\t\t\t<EM>Value</EM>"
				echo "\t\t</TD>"
				echo "\t\t</TR>"

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", "For the past 1 minute" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", $1 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.load.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", "For the past 5 minutes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", $2 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.load.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", "For the past 15 minutes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", $3 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.load.dat

			echo "\t\t</TABLE>"

			echo "<BR><BR>"

			echo '\t\t<TABLE WIDTH="400" BORDER="0">'

				echo "\t\t<TR>"
				echo '\t\t<TD WIDTH="70%">'
				echo "\t\t\t<EM>The average number of jobs</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
				echo "\t\t\t<EM>Value</EM>"
				echo "\t\t</TD>"
				echo "\t\t</TR>"

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Running processes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					running = $4 ; split ( running, RUNNING, "/") \
					printf "\t\t\t%s\n", RUNNING[1] \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.load.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Runnable processes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					running = $4 ; split ( running, RUNNING, "/") \
					printf "\t\t\t%s\n",  RUNNING[2] \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.load.dat

			echo "\t\t</TABLE>"

			echo "<BR><BR>"
			
			echo '\t\t<TABLE WIDTH="400" BORDER="0">'

				echo "\t\t<TR>" 
				echo '\t\t<TD WIDTH="70%">'
				echo "\t\t\t<EM>The number of processes:</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
				echo "\t\t\t<EM>Value</EM>"
				echo "\t\t</TD>"
				echo "\t\t</TR>"

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Waiting for run time:" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n", $1 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "In uninterruptable sleep:" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n", $2 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat
				
				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Swapped out but runnable:" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n", $3 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

			echo "\t\t</TABLE>"

			echo "<BR><BR>"

			echo '\t\t<TABLE WIDTH="400" BORDER="0">'

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "<EM>BogoMIPs kernel benchmark:</EM>" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n", $1 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.info.bmips.dat

			echo "\t\t</TABLE>"



		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t\t</TABLE>"

	echo "\t</TD>"
	echo "\t</TR>"

	echo "\t</TABLE>"

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring kernel usage
(for more information see Linux kernel documentations and HOWTO).

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Kernel usage monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Workshop.gif' 'Kernel usage monitoring'`
	&nbsp;<B>Kernel usage monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about kernel usage on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#KernelUsage">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor kernel usage'`</A>
		&nbsp;Monitor <A HREF="#KernelUsage">kernel usage</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Workshop.gif' 'System kernel monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">kernel monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/WorkshopFinder.gif' 'Monitor kernel usage'`
	<A NAME="KernelUsage"><EM><B>Monitor kernel usage</B></EM></A>
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
EOM
	echo '\t<TABLE WIDTH="650" BORDER="0">'

	echo "\t<TR>"
	echo '\t<TD WIDTH="500" VALIGN="TOP">'
	
		echo '\t\t<TABLE WIDTH="450" BORDER="0">'
	
		echo "\t\t<TR>"
		echo '\t\t<TD ALIGN="CENTER" VALIGN="TOP">'
			
			echo '\t\t<TABLE WIDTH="400" BORDER="0">'
			
			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="33%">'
				echo '\t\t\t<EM>Space type</EM>'
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="33%">'
				echo '\t\t\t<EM>&nbsp;</EM>'
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN="RIGHT" WIDTH="33%">'
				echo '\t\t\t<EM>Percentage</EM>'
			echo "\t\t</TD>"
			echo "\t\t</TR>"
			
			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "User" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", " " \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.user.dat
			
			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "System" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", " " \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.system.dat

			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "I/O" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", " " \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.io.dat

			awk '{ \
				printf "\t\t%s\n", "<TR>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", "Idle" \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", " " \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"33%\">" \
					printf "\t\t\t%s\n", $1 \
				printf "\t\t%s\n", "</TD>" \
				printf "\t\t%s\n", "</TR>" \
			}' < $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.idle.dat

			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="33%">'
				echo "\t\t\tUptime"
			echo "\t\t</TD>"
			echo '\t\t<TD WIDTH="33%">'
				echo "\t\t\t "
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN="RIGHT" WIDTH="33%">'
				echo '\t\t\t100%'
			echo "\t\t</TD>"
			echo "\t\t</TR>"

			echo "\t\t</TABLE>"

			echo "<BR><BR>"

			echo '\t\t<TABLE WIDTH="400" BORDER="0">'
			
			echo "\t\t<TR>"
			echo '\t\t<TD WIDTH="77%">'
				echo '\t\t\t<EM>Average kernel load:</EM>'
			echo "\t\t</TD>"
			echo '\t\t<TD ALIGN="RIGHT" WIDTH="33%">'
				set average_kernel	= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.kernel.load.dat`
				echo "\t\t\t$average_kernel"
			echo "\t\t</TD>"
			echo "\t\t</TR>"
			
			echo "\t\t</TABLE>"
			
			echo "<BR><BR>"

			echo '\t\t<TABLE WIDTH="400" BORDER="0">'

				echo "\t\t<TR>"
				echo '\t\t<TD WIDTH="50%">'
				echo "\t\t\t<EM>System load average</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="RIGHT" WIDTH="50%">'
				echo "\t\t\t<EM>Value</EM>"
				echo "\t\t</TD>"
				echo "\t\t</TR>"

				awk -F"average:" '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", "For the past 1 minute" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"50%\">" \
					split ( $2, LOAD, ",") \
					printf "\t\t\t%s\n", LOAD[1] \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.info.uptime.dat

				awk -F"average:" '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", "For the past 5 minutes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"50%\">" \
					split ( $2, LOAD, ",") \
					printf "\t\t\t%s\n", LOAD[2] \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.info.uptime.dat

				awk -F"average:" '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"50%\">" \
					printf "\t\t\t%s\n", "For the past 15 minutes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"50%\">" \
					split ( $2, LOAD, ",") \
					printf "\t\t\t%s\n", LOAD[3] \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.info.uptime.dat

			echo "\t\t</TABLE>"
			
			echo "<BR><BR>"

			echo '\t\t<TABLE WIDTH="400" BORDER="0">'

				echo "\t\t<TR>"
				echo '\t\t<TD WIDTH="70%">'
				echo "\t\t\t<EM>The average number of jobs</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="RIGHT" WIDTH="30%">'
				echo "\t\t\t<EM>Value</EM>"
				echo "\t\t</TD>"
				echo "\t\t</TR>"

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Processes in run queue" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n", $1 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Blocked processes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n",  $2 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat

				awk '{ \
					printf "\t\t%s\n", "<TR>" \
					printf "\t\t%s\n", "<TD WIDTH=\"70%\">" \
					printf "\t\t\t%s\n", "Runnable but swapped processes" \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "<TD ALIGN=\"RIGHT\" WIDTH=\"30%\">" \
					printf "\t\t\t%s\n",  $3 \
					printf "\t\t%s\n", "</TD>" \
					printf "\t\t%s\n", "</TR>" \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.memory.virtual.dat


			echo "\t\t</TABLE>"

			echo "<BR><BR>"



		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t\t</TABLE>"

	echo "\t</TD>"
	echo "\t</TR>"

	echo "\t</TABLE>"

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>


This part of Wotan is monitoring kernel usage.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
