#!/bin/tcsh -f

#
# Wotan.Audit.System.Processes.cgi v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Audit.System.Processes.cgi ,v0.2 1999/10/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
#

#
# Description:
# CGI script which generate Wotan document with information
# about system processes
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">system monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux 
#
case "Linux":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System processes monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Processes3.gif' 'System processes monitoring'`
	&nbsp;<B>System processes monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about System processes  on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#SystemProcesses">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor system processes '`</A>
		&nbsp;Monitor <A HREF="#SystemProcesses">system processes </A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Processes3Finder.gif' 'Monitor system processes'`
	<A NAME="SystemProcesses"><EM><B>Monitor system processes</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

<TABLE ALIGN="CENTER" BORDER="0">
<TR>
<TD>
EOM
	echo '\t<TABLE WIDTH="650" BORDER="0">'

	echo "\t<TR>"
	echo '\t<TD WIDTH="99%" VALIGN="TOP">'
	
		echo '\t\t<TABLE WIDTH="99%" BORDER="0">'
	
		echo "\t\t<TR>"
		echo '\t\t<TD ALIGN="CENTER" VALIGN="TOP">'
			
			echo '\t\t<TABLE WIDTH="99%" BORDER="1">'

				echo "\t\t<TR>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>User</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>PID</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>CPU (%)</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Memory (%)</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Size</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>RSS</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>TTY</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Status</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Start</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Time</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Command</EM>"
				echo "\t\t</TD>"
				echo "\t\t</TR>"

				awk '{ \
					printf "\t\t<TR>\n\t\t%s\n\t\t&nbsp;<A HREF=\"'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=$STATUS&USER="'%s\">%s</A>\n\t\t</TD>\n","<TD WIDTH=\"9%\">",$1,$1 \
					for ( i = 2 ; i <= 7 ; i++) { \
						printf "\t\t%s\n\t\t\t%s\n\t\t</TD>", "<TD ALIGN=\"RIGHT\" WIDTH=\"9%\">", $i \
					} \
					printf "\t\t%s\n\t\t\t%s\n\t\t</TD>\n", "<TD ALIGN=\"LEFT\" NOWRAP WIDTH=\"9%\">", substr( $0, 41, 4) \
					printf "\t\t%s\n\t\t\t%s\n\t\t</TD>\n", "<TD ALIGN=\"LEFT\" NOWRAP WIDTH=\"9%\">", substr( $0, 45, 7) \
					printf "\t\t%s\n\t\t\t%s\n\t\t</TD>\n", "<TD ALIGN=\"LEFT\" NOWRAP WIDTH=\"9%\">", substr( $0, 52, 8) \
					printf "\t\t%s\n\t\t\t%s\n\t\t</TD>\n\t\t</TR>\n", "<TD ALIGN=\"LEFT\" NOWRAP WIDTH=\"9%\">", substr( $0, 60, 25) \
				}' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat

			echo "\t\t</TABLE>"

		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t\t</TABLE>"

	echo "\t</TD>"
	echo "\t</TR>"

	echo "\t</TABLE>"

CGIBody
</TD>
</TR>
</TABLE>

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring system processes.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

#
# SunOS 
#
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'System processes monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Processes3.gif' 'System processes monitoring'`
	&nbsp;<B>System processes monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
	<BR><BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This page contains information about System processes  on host
	<B><EM>`HTMLOut '$HOST'`</EM></B> collected at <EM>`HTMLOut '$TIMESTAMP'`</EM>.
	Host <B><EM>`HTMLOut '$HOST'`</EM></B>
EOM

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information may be new and valid."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, collected information are old or are not valid."
		breaksw	
endsw

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#SystemProcesses">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor system processes '`</A>
		&nbsp;Monitor <A HREF="#SystemProcesses">system processes </A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/System.gif' 'System monitoring'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.cgi?HOST=$HOST&STATUS=$STATUS">System monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Processes3Finder.gif' 'Monitor system processes'`
	<A NAME="SystemProcesses"><EM><B>Monitor system processes</B></EM></A>
	<BR><BR>
</TD>
</TR>
</TABLE>

<TABLE ALIGN="CENTER" BORDER="0">
<TR>
<TD>
EOM
	echo '\t<TABLE WIDTH="650" BORDER="0">'

	echo "\t<TR>"
	echo '\t<TD WIDTH="99%" VALIGN="TOP">'
	
		echo '\t\t<TABLE WIDTH="99%" BORDER="0">'
	
		echo "\t\t<TR>"
		echo '\t\t<TD ALIGN="CENTER" VALIGN="TOP">'
			
			echo '\t\t<TABLE WIDTH="99%" BORDER="1">'

				echo "\t\t<TR>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>User</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>PID</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>CPU (%)</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Memory (%)</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Size</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>RSS</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>TTY</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Status</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Start</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Time</EM>"
				echo "\t\t</TD>"
				echo '\t\t<TD ALIGN="CENTER" WIDTH="9%">'
				echo "\t\t\t<EM>Command</EM>"
				echo "\t\t</TD>"
				echo "\t\t</TR>"

				set processes	= `cat $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat | wc -l`
				set users	= `awk '{ print $1 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set pids	= `awk '{ print $2 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set cpu		= `awk '{ print $3 }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set mem		= `awk '{ print substr ( $0, 20, 5) }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set size	= `awk '{ print substr ( $0, 25, 5) }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set rss		= `awk '{ print substr ( $0, 30, 6) }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set tty		= `awk '{ print substr ( $0, 36, 8) }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set stat	= `awk '{ print substr ( $0, 44, 3) }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 
				set start	= `awk '{ st = substr ( $0, 47, 9) ; gsub ( / /, "", st ) ; print st }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 

				set times	= `awk '{ begin = 56 ; offset = 0 ; char = substr ( $0, begin, 1 ) ; if ( char != " " ) { while ( char != " " ) { char = substr ( $0, begin + offset, 1 ) ; offset++ } ; print substr ( $0, begin, offset) } else { while ( char == " " ) { char = substr ( $0, begin + offset, 1 ) ; offset++ } ; begin += offset - 1 ; while ( char != " " ) { char = substr ( $0, begin + offset, 1 ) ; offset++ } ; print substr ( $0, begin, offset ) } }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat` 

				set commands	= `awk '{ begin = 58 ; offset = 0 ; max = 25 ; end = length ( $0 ) ; char = substr ( $0, begin, 1 ) ; if ( char != " " ) { while ( char != " " ) { char = substr ( $0, begin + offset, 1 ) ; offset++ } ; begin += offset - 1 ; if ( int ( begin + max ) > end ) { offset = end - begin } else { offset = max } }  else { while ( char == " " ) { char = substr ( $0, begin + offset, 1 ) ; offset++ } ; begin += offset - 1 ; if ( int ( begin + max ) > end ) { offset = end - begin } else { offset = max } } ; result = substr ( $0, begin, offset + 1 ) ; gsub ( / / , "\377", result ) ; print result }' < $WOTAN_HOME/hosts/$HOST/data/system/system.processes.status.dat`

				@ process_index	= 1
				while ($process_index <= $processes)

					echo "\t\t<TR>"
					echo '\t\t<TD WIDTH="9%">'
						echo '\t\t\t&nbsp;<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Accounting.User.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'&USER='"$users[$process_index]"'">'"$users[$process_index]"'</A>'
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$pids[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$cpu[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$mem[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$size[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$rss[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$tty[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$stat[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$start[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="RIGHT" WIDTH="9%">'
						echo "\t\t\t$times[$process_index]"
					echo "\t\t</TD>"
					echo '\t\t<TD ALIGN="LEFT" WIDTH="9%" NOWRAP>'
						set command	= `echo $commands[$process_index] | awk '{ command = $0 ; gsub ( /\377/ , " ", command) ; print command }'`
						echo "\t\t\t$command"
					echo "\t\t</TD>"
					echo "\t\t</TR>"

					@ process_index++

				end

			echo "\t\t</TABLE>"

		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t\t</TABLE>"

	echo "\t</TD>"
	echo "\t</TR>"

	echo "\t</TABLE>"

CGIBody
</TD>
</TR>
</TABLE>

<TABLE WIDTH="650" BORDER="0">
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>

This part of Wotan is monitoring system processes.

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw



default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
