#!/bin/tcsh -f

#
# Wotan.Audit.System.cgi v0.6
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.System.cgi ,v0.6 1999/12/18 16:58:20 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about core system
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.cfg
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Determine remote host platform information
#
if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
	set WotanPlarform	= `cat $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info`
else
error:
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Fatal error for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Kill.gif' 'Fatal error'`
	<B>Wotan fatal error for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">Auditing and monitoring page</A> for host `echo $HOST`
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
Wotan can not determine remote host operating system platform. Please, check
Wotan configuration and directory structure for host <EM>`HTMLOut '$HOST'`
</EM>.  For more information see included documentation. Wotan now support
Linux and Solaris operating system only. Other platforms will be supported
later.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto end
endif


#
# Select platform
#
switch ("$WotanPlarform")

#
# Linux and SunOS have the same data format
#
case "Linux":
case "SunOS":

if (-e $WOTAN_HOME/hosts/$HOST/data/timestamp.dat && -f $WOTAN_HOME/hosts/$HOST/data/timestamp.dat ) then
	set TIMESTAMP	= `cat $WOTAN_HOME/hosts/$HOST/data/timestamp.dat | sed "s/-/ /g"`
else
	set TIMESTAMP	= "unknown"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Core system monitoring page for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/System.gif' 'Core system monitoring'`
	&nbsp;<B>Core system monitoring page for host <EM>`HTMLOut '$HOST'`</EM></B>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<B><EM>
	Actions:
	</EM></B>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Devices.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/mech.gif' 'System devices monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Devices.cgi?HOST=$HOST&STATUS=$STATUS">System devices monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Workshop.gif' 'Kernel monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Kernel.cgi?HOST=$HOST&STATUS=$STATUS">Kernel monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/IPC.gif' 'IPC monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.IPC.cgi?HOST=$HOST&STATUS=$STATUS">IPC monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Processes.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Processes3.gif' 'System processes monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.Processes.cgi?HOST=$HOST&STATUS=$STATUS">System processes monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.SysVInit.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/SysVInit.gif' 'System V Init monitoring'`</A>
		&nbsp;<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.System.SysVInit.cgi?HOST=$HOST&STATUS=$STATUS">System V Init monitoring</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Get description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">`HTMLImage '$AUDIT_IMG_URL/Unix.gif' 'Monitoring and auditing page'`</A>
		&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Overview.cgi?HOST=$HOST&STATUS=$STATUS">auditing and monitoring page</A> for host $HOST
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan package is monitoring core system components (kernel,
kernel modules, system devices, memory, I/O subsystems, IPC, processes, etc.).
This is very useful for debugging or for system tuning. Wotan displays the
system status gathered from <EM>/proc</EM> or kernel data structures.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
breaksw

default
	goto error
breaksw

endsw

end:

# /* End of CGI script */
