#!/bin/tcsh -f

#
# Wotan.Monitor.Network.Portscanner.Result.cgi v0.6
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Monitor.Network.Portscanner.Result.cgi ,v0.6 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with result information
# about services which are offering on remote host.
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif

set PROTOCOL	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/PROTOCOL=/ { print $2 }'`
set PROTOCOL	= `echo $PROTOCOL | tr -dc "[:alpha:]"`
if ("$PROTOCOL" == "") set PROTOCOL	= "TCP"
if ("$PROTOCOL" != "TCP" && "$PROTOCOL" != "RPC") set PROTOCOL	= "TCP"

set IDENT	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/IDENT=/ { print $2 }'`
set IDENT	= `echo $IDENT | tr -dc "[:alpha:]"`
if ("$IDENT" == "") set IDENT	= "ON"
if ("$IDENT" != "ON" && "$IDENT" != "OFF") set IDENT	= "ON"

#
# Function for remote host port scanning
#
alias netscanner $NETWORK_SCANNER

#
# Begin of CGI
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan network port scanner result'`
`HTMLBody`

<CENTER>
<TABLE ALIGN=CENTER WIDTH=650>

<TR>
<TD>
<BR>
<CENTER>
`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
</CENTER>
<BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network port scanner result'`
	&nbsp;<B>Network port scanner result page</B>
	<BR><BR>
	<BR><BR>
</TR>
</TD>
		
<TR>
<TD ALIGN=LEFT>
	This page monitor open ports and services on remote host.
	<BR><BR>
</TR>
</TD>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Scan">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Scan remote host'`</A>
		&nbsp;<A HREF="#Scan">Scan</A> remote host
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Monitor.Network.cgi">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network on-line monitor'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Monitor.Network.cgi">network on-line monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/NetworkFinder.gif' 'Scan remote host'`
	<EM><B>Scan remote host</B></EM><A NAME="Scan">
	<BR><BR>
</TD>
</TR>
</TABLE>

<TABLE ALIGN=CENTER BORDER=0>
<TR>
<TD>
EOM

if ("$HOST" != "UNKNOWN_HOST") then

	if ("$PROTOCOL" == "TCP") then
		if ("$IDENT" == "ON") then
			if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
				( netscanner -sT -I $HOST & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& grep -v '^\[' | egrep "^(1|2|3|4|5|6|7|8|9|0)" | awk 'BEGIN{ print "\t<TABLE ALIGN=CENTER BORDER=1>\n\t\t<TR>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Port</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Status</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Protocol</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Service</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Owner</EM>\n\t\t</TD>\n\t\t</TR>" }{ print "\t\t<TR>" ; printf "\t\t<TD ALIGN=\"RIGHT\">\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $1 ; for ( i = 2; i <= 4; i++) printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $i ; printf "\t\t<TD>\n\t\t\t&nbsp;<A HREF=\"'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=up&USER="'%s\">%s</A>\n\t\t</TD>\n", $5, $5 ; print "\t\t<TR>\n" }END{ print "\t</TABLE>" }'
			else
				( netscanner -sT -I $HOST & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& grep -v '^\[' | egrep "^(1|2|3|4|5|6|7|8|9|0)" | awk 'BEGIN{ print "\t<TABLE ALIGN=CENTER BORDER=1>\n\t\t<TR>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Port</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Status</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Protocol</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Service</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Owner</EM>\n\t\t</TD>\n\t\t</TR>" }{ print "\t\t<TR>" ; printf "\t\t<TD ALIGN=\"RIGHT\">\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $1 ; for ( i = 2; i <= 4; i++) printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $i ; printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $5; print "\t\t<TR>\n" }END{ print "\t</TABLE>" }'
			endif
		else
			( netscanner -sT $HOST & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& grep -v '^\[' | egrep "^(1|2|3|4|5|6|7|8|9|0)" | awk 'BEGIN{ printf "\t<TABLE ALIGN=CENTER BORDER=1>\n\t\t<TR>\n<TD WIDTH=\"20%s\" ALIGN=\"CENTER\">\n\t\t\t<EM>Port</EM>\n\t\t</TD>\n<TD WIDTH=\"20%s\" ALIGN=\"CENTER\">\n\t\t\t<EM>Status</EM>\n\t\t</TD>\n<TD WIDTH=\"20%s\" ALIGN=\"CENTER\">\n\t\t\t<EM>Protocol</EM>\n\t\t</TD>\n<TD WIDTH=\"20%s\" ALIGN=\"CENTER\">\n\t\t\t<EM>Service</EM>\n\t\t</TD>\n\t\t</TR>", "%", "%", "%", "%" }{ print "\t\t<TR>" ; printf "\t\t<TD WIDTH=\"20%s\" ALIGN=\"RIGHT\">\n\t\t\t&nbsp;%s\n\t\t</TD>\n", "%", $1 ; for ( i = 2; i <= 4; i++) printf "\t\t<TD WIDTH=\"20%s\">\n\t\t\t&nbsp;%s\n\t\t</TD>\n", "%", $i ; print "\t\t<TR>\n" }END{ print "\t</TABLE>" }'
		endif
	else
		if ("$IDENT" == "ON") then
			if (-e $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info && -f $WOTAN_HOME/hosts/$HOST/etc/Wotan.platform.info) then
				( netscanner -sR -I $HOST & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& grep -v '^\[' | egrep "^(1|2|3|4|5|6|7|8|9|0)" | awk 'BEGIN{ print "\t<TABLE ALIGN=CENTER BORDER=1>\n\t\t<TR>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Port</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Status</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Protocol</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Service</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Owner</EM>\n\t\t</TD>\n\t\t</TR>" }{ print "\t\t<TR>" ; printf "\t\t<TD ALIGN=\"RIGHT\">\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $1 ; for ( i = 2; i <= 4; i++) printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $i ; user = substr ( $0, 54, 20 ) ; gsub ( / /, "", user ) ; printf "\t\t<TD>\n\t\t\t&nbsp;<A HREF=\"'"$AUDIT_CGI_URL/Wotan.Audit.Accounting.User.cgi?HOST=$HOST&STATUS=up&USER="'%s\">%s</A>\n\t\t</TD>\n", user, user ; print "\t\t<TR>\n" }END{ print "\t</TABLE>" }'
			else
				( netscanner -sR -I $HOST & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& grep -v '^\[' | egrep "^(1|2|3|4|5|6|7|8|9|0)" | awk 'BEGIN{ print "\t<TABLE ALIGN=CENTER BORDER=1>\n\t\t<TR>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Port</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Status</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Protocol</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Service</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Owner</EM>\n\t\t</TD>\n\t\t</TR>" }{ print "\t\t<TR>" ; printf "\t\t<TD ALIGN=\"RIGHT\">\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $1 ; for ( i = 2; i <= 4; i++) printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $i ; user = substr ( $0, 54, 20 ) ; gsub ( / /, "", user ) ; printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", user; print "\t\t<TR>\n" }END{ print "\t</TABLE>" }'
			endif
		else
			( netscanner -sR $HOST & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& grep -v '^\[' | egrep "^(1|2|3|4|5|6|7|8|9|0)" | awk 'BEGIN{ print "\t<TABLE ALIGN=CENTER BORDER=1>\n\t\t<TR>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Port</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Status</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Protocol</EM>\n\t\t</TD>\n<TD ALIGN=\"CENTER\">\n\t\t\t<EM>Service</EM>\n\t\t</TD>\n\t\t</TR>" }{ print "\t\t<TR>" ; printf "\t\t<TD ALIGN=\"RIGHT\">\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $1 ; for ( i = 2; i <= 3; i++) printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $i ; printf "\t\t<TD>\n\t\t\t&nbsp;%s\n\t\t</TD>\n", $4" "$5" "$6 ;print "\t\t<TR>\n" }END{ print "\t</TABLE>" }'
		endif
	endif
else
	echo "<B><EM>Error:</EM> remote host not specified.</B>"
endif

CGIBody
</TD>
</TR>
</TABLE>

<TABLE ALIGN=CENTER WIDTH=650>
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<EM><B>&nbsp;Description:</B></EM><A NAME="Description">
<BR><BR>
Wotan package determine which services are offering on remote
host. UDP scan not available - this scan type requires root
privileges.
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

end:

# /* End of CGI script */
