#!/bin/tcsh -f

#
# Wotan.Monitor.Network.Throughput.Result.cgi v0.3
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Monitor.Network.Throughput.Result.cgi ,v0.3 1999/10/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with result information
# about network throughput to remote host
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif

set PORT	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/PORT=/ { print $2 }'`
set PORT	= `echo $PORT | tr -dc "[:digit:]-"`
if ("$PORT" == "") set PORT	= "9"
if ($PORT < 0 || $PORT > 65535) set PORT	= "9"

set BLOCKSIZE	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/BLOCKSIZE=/ { print $2 }'`
set BLOCKSIZE	= `echo $BLOCKSIZE | tr -dc "[:digit:]-"`
if ("$BLOCKSIZE" == "") set BLOCKSIZE	= "1024"
if ($BLOCKSIZE < 512 || $BLOCKSIZE > 4096) set BLOCKSIZE 	= "1024"

set BUFSIZE	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/BUFSIZE=/ { print $2 }'`
set BUFSIZE	= `echo $BUFSIZE | tr -dc "[:digit:]-"`
if ("$BUFSIZE" == "") set BUFSIZE	= "512"
if ($BUFSIZE < 512 || $BUFSIZE > 4096) set BUFSIZE 	= "512"

set PROTOCOL	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/PROTOCOL=/ { print $2 }'`
set PROTOCOL	= `echo $PROTOCOL | tr -dc "[:alpha:]"`
if ("$PROTOCOL" == "") set PROTOCOL	= "TCP"
if ("$PROTOCOL" != "TCP" && "$PROTOCOL" != "RPC") set PROTOCOL	= "TCP"

set DATATYPE	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATATYPE=/ { print $2 }'`
set DATATYPE	= `echo $DATATYPE | tr -dc "[:alpha:]"`
if ("$DATATYPE" == "") set DATATYPE	= "PREDEFINED"
if ("$DATATYPE" != "RANDOM" && "DATATYPE" != "PREDEFINED") set DATATYPE	= "PREDEFINED"

set BLOCKS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/BLOCKS=/ { print $2 }'`
set BLOCKS	= `echo $BLOCKS | tr -dc "[:digit:]-"`
if ("$BLOCKS" == "") set BLOCKS	= "512"
if ($BLOCKS <= 0 || $BLOCKS > 500) set BLOCKS 	= "100"

#
# Begin of CGI
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan network throughput result'`
`HTMLBody`

<CENTER>
<TABLE ALIGN=CENTER WIDTH=650>

<TR>
<TD>
<BR>
<CENTER>
`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
</CENTER>
<BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network throughput result'`
	&nbsp;<B>Network throughput result page</B>
	<BR><BR>
	<BR><BR>
</TR>
</TD>
		
<TR>
<TD ALIGN=LEFT>
	This page monitor network throughput to remote host.
	<BR><BR>
</TR>
</TD>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Throughput">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network throughput'`</A>
		&nbsp;Monitor <A HREF="#Throughput">network throughput</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Monitor.Network.cgi">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network on-line monitor'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Monitor.Network.cgi">network on-line monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/NetworkFinder.gif' 'Monitor network throughput'`
	<EM><B>Monitor network throughput</B></EM><A NAME="Throughput">
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
EOM

if ("$HOST" != "UNKNOWN_HOST") then

	if ("$PROTOCOL" == "TCP") then
		if ("$DATATYPE" == "RANDOM") then
			set THROUGHPUT = `(tcpblast -t -p $PORT -s $BLOCKSIZE -b $BUFSIZE -r -d 0 $HOST $BLOCKS & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& egrep "^$BLOCKS"`
		else
			set THROUGHPUT = `(tcpblast -t -p $PORT -s $BLOCKSIZE -b $BUFSIZE -d 0 $HOST $BLOCKS & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& egrep "^$BLOCKS"`
		endif
	else
		if ("$DATATYPE" == "RANDOM") then
			set THROUGHPUT = `(tcpblast -u -p $PORT -s $BLOCKSIZE -b $BUFSIZE -r -d 0 $HOST $BLOCKS & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& egrep "^$BLOCKS"`
		else
			set THROUGHPUT = `(tcpblast -u -p $PORT -s $BLOCKSIZE -b $BUFSIZE -d 0 $HOST $BLOCKS & ; sleep $WOTAN_NET_TIMEOUT ; kill %1 >& /dev/null ) |& egrep "^$BLOCKS"`
		endif
	endif
	if ("$THROUGHPUT" != "") then
		echo "Result: $THROUGHPUT"
	else
		echo "Result: no data available. Remote host may be down. Please, check host name and port, or try connection later."
	endif

else
	echo "<B><EM>Error:</EM> remote host not specified.</B>"
endif

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<EM><B>&nbsp;Description:</B></EM><A NAME="Description">
<BR><BR>
Wotan monitoring package sends data to the designated port (default
value is 9) on the specified host and reports the average network
throughput.		     
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

end:

# /* End of CGI script */
