#!/bin/tcsh -f

#
# Wotan.Monitor.Network.Throughput.cgi v0.3
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.Monitor.Network.Throughput.cgi ,v0.3 1999/10/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information
# about network throughput to remote host
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.Audit.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]"`


#
# Begin of CGI
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan network throughput monitoring'`
`HTMLBody`

<CENTER>
<TABLE ALIGN=CENTER WIDTH=650>

<TR>
<TD>
<BR>
<CENTER>
`HTMLImage '$AUDIT_IMG_URL/title.gif' 'Wotan Logo'`
</CENTER>
<BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network throughput monitoring'`
	&nbsp;<B>Network throughput monitoring page</B>
	<BR><BR>
	<BR><BR>
</TR>
</TD>
		
<TR>
<TD ALIGN=LEFT>
	This page monitor network throughput to remote host.
	<BR><BR>
</TR>
</TD>

<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$AUDIT_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Throughput">`HTMLImage '$AUDIT_IMG_URL/Finder.gif' 'Monitor network throughput'`</A>
		&nbsp;Monitor <A HREF="#Throughput">network throughput</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Monitor.Network.cgi">`HTMLImage '$AUDIT_IMG_URL/Network.gif' 'Network on-line monitor'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Monitor.Network.cgi">network on-line monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Main page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp; Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan home page</A>
	</TD>
	</TR>
	
	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/NetworkFinder.gif' 'Monitor network throughput'`
	<EM><B>Monitor network throughput</B></EM><A NAME="Throughput">
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
<FORM ACTION="`echo $AUDIT_CGI_URL`/Wotan.Monitor.Network.Throughput.Result.cgi">
<TABLE WIDTH=90%>

<TR>
<TD WIDTH=40% ALIGN=RIGHT>
	Monitored host:
</TD>
EOM

if ("$HOST" != "") then
	echo '<TD WIDTH="60%" ALIGN=LEFT>'
	echo "<EM>$HOST</EM>"
	echo '<INPUT TYPE=HIDDEN NAME="HOST" VALUE="'"$HOST"'">'
	echo "</TD>"
else
	echo '<TD WIDTH="60%" ALIGN=LEFT>'
	set WotanLinuxHosts	= ""
	set WotanHosts		= `egrep -v "^#" $WOTAN_HOME/etc/Wotan.hosts | awk '{print $1}'`
	foreach host (`echo $WotanHosts`)
		set WotanLinuxHosts	= ($WotanLinuxHosts $host)
	end
	@ flag = 0
	echo '\t<SELECT NAME="HOST" SIZE=1>'
	foreach host (`echo $WotanLinuxHosts`)
		if ($flag == 0) then
			echo '\t<OPTION SELECTED>'"$host"
			@ flag = 1
		else
			echo "\t<OPTION>$host"
		endif
	end
	echo "</SELECT>"
	echo "</TD>"
endif

CGIBody
</TR>

<TR>
<TD WIDTH=40% ALIGN=RIGHT>
	Designated port:
</TD>
<TD WIDTH=60% ALIGN=LEFT>
	<INPUT TYPE=TEXT ALIGN="RIGHT" NAME="PORT" VALUE="9" MAXLENGTH="5" SIZE="5">
</TD>
</TR>

<TR>
<TD WIDTH=40% ALIGN=RIGHT>
	Block size:
</TD>
<TD WIDTH=60% ALIGN=LEFT>
	<SELECT NAME="BLOCKSIZE" SIZE=1 ALIGN="RIGHT">
	<OPTION>512
	<OPTION SELECTED>1024
	<OPTION>2048
	<OPTION>3072
	<OPTION>4096
	</SELECT> bytes
</TD>
</TR>

<TR>
<TD WIDTH=40% ALIGN=RIGHT>
	Buffer size:
</TD>
<TD WIDTH=60% ALIGN=LEFT>
	<SELECT NAME="BUFSIZE" SIZE=1>
	<OPTION SELECTED>512
	<OPTION>1024
	<OPTION>2048
	<OPTION>3072
	<OPTION>4096
	</SELECT> bytes
</TD>
</TR>

<TR>
<TD WIDTH=40% ALIGN=RIGHT>
	Number of blocks:
</TD>
<TD WIDTH=60% ALIGN=LEFT>
	<SELECT NAME="BLOCKSIZE" SIZE=1 ALIGN="RIGHT">
	<OPTION>50
	<OPTION SELECTED>100
	<OPTION>150
	<OPTION>200
	<OPTION>250
	<OPTION>300
	<OPTION>350
	<OPTION>400
	<OPTION>450
	<OPTION>500
	</SELECT> KB
</TD>
</TR>

<TR VALIGN="TOP">
<TD WIDTH=40% ALIGN=RIGHT>
	Protocol:
</TD>
<TD WIDTH=60% ALIGN=LEFT>
	<INPUT TYPE="RADIO" NAME="PROTOCOL" VALUE="TCP" CHECKED>
	TCP<BR>
	<INPUT TYPE="RADIO" NAME="PROTOCOL" VALUE="UDP">
	UDP<BR>
</TD>
</TR>

<TR VALIGN="TOP">
<TD WIDTH=40% ALIGN=RIGHT>
	Sent data:
</TD>
<TD WIDTH=60% ALIGN=LEFT>
	<INPUT TYPE="RADIO" NAME="DATATYPE" VALUE="PREDEFINED" CHECKED>
	internal predefined <BR>
	<INPUT TYPE="RADIO" NAME="DATATYPE" VALUE="RANDOM">
	random <BR>
</TD>
</TR>




<TR>
<TD>
	<BR><BR>
</TD>
</TR>

<TR>
<TD WIDTH=60% ALIGN=RIGHT>
	<INPUT TYPE=SUBMIT VALUE="OK">
</TD>
<TD WIDTH=40% ALIGN=LEFT>
	&nbsp;&nbsp;
	<INPUT TYPE=RESET VALUE="RESET">
</TD>
</TR>



</TABLE>
</FORM>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<EM><B>&nbsp;Description:</B></EM><A NAME="Description">
<BR><BR>
Wotan monitoring package sends data to the designated port (default
value is 9) on the specified host and reports the average network
throughput.		     
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$AUDIT_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

end:

# /* End of CGI script */
