#!/bin/tcsh -f

#
# Wotan.SNMP.BrowseDatabase.cgi v0.5
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.BrowseDatabase.cgi ,v0.5 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script for manipulate with Wotan SNMP database
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Set initial database server environment
#
set DB_ERROR_LIST	= ""
set DB_ERROR_FLAG	= "OK"
@ DB_ERROR_INDEX	= 0

#
# Test if database exists
#
if !(-e ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_EXISTS)
endif

#
# Test if CGI executor is owner
#
#if !(-o ${SNMP_DB_ROOT} && -r ${SNMP_DB_ROOT} && -w ${SNMP_DB_ROOT}) then
#	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
#	@ DB_ERROR_INDEX++
#        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_OWNER)
#endif

#
# Test if database is directory
#
if !(-d ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_DIRECTORY)
endif

#
# Test if database is readable
#
if !(-r ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_READABLE)
endif

#
# Test if database is writable
#
if !(-w ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_WRITABLE)
endif

#
# Test, if there are errors on database server
#
if ("$DB_ERROR_FLAG" == "CRITICAL_ERROR") then
	
#
# Parse database server errors
#
@ index		= 1
set ERROR_MSG	= ""
while ($index <= $DB_ERROR_INDEX)
	set ERROR_MSG	= ($ERROR_MSG \<LI\>$DB_ERROR_LIST[$index]\</LI\>)
	@ index++
end

#
# Begin of CGI script
#
CGIHeader
	
#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database server - fatal error'`
`HTMLBody`
	
<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD ALIGN=LEFT>
	`HTMLImage '$SNMP_IMG_URL/Kill.gif' 'Error'`
	<B>
	&nbsp;Wotan database server status:
	</B>
	<BR><BR>
	`HTMLOut 'Fatal database server errors:'`
	<BR><BR>
	<UL>
	`echo "${ERROR_MSG}"`
	</UL>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>
	<TR>
	<TD WIDT=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="mailto:Marek.Uher@uhkt.cz">`HTMLImage '$SNMP_IMG_URL/Mail.gif' 'Mail'`</A>
		Contact <A HREF="mailto:Marek.Uher@uhkt.cz">Wotan SNMP</A> administrator
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>
	
<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
	<EM><B>&nbsp;Description:</B></EM>
	<BR><BR>
	<UL>
		<LI>
		<EM>Internal runtime error</EM>
		- sorry, Wotan database server can't browse SNMP database.
		Reason:
		<BR><BR>
		<CENTER>
		<TT>Internal runtime server error.</TT>
		</CENTER>
		<BR>
		Please, contact Wotan SNMP administrator (see bellow).
		</LI>
	</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>
	
</TABLE>
</CENTER>

`HTMLEnd`
goto CGI_END
EOM
endif

ls -tr ${SNMP_DB_ENTRY}.* >! ${SNMP_DB_ROOT}/cache

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database server browser'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/Info.gif' 'Info'`	
	<B>
	<EM>
	Wotan database server status:
	</EM>
	</B>
	<BR><BR>
	SNMP database server successfuly opened.
	<BR>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Databases">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect'`</A>
		&nbsp;Inspect <A HREF="#Databases">available databases</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.ReindexDatabase.cgi">`HTMLImage '$SNMP_IMG_URL/CylinderWrenchSpreadsheet.gif' 'Reindex'`</A>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.ReindexDatabase.cgi">Reindex</A> Wotan SNMP database
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>

</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
<TABLE ALIGN=LEFT>
<TR>
<TD ALIGN=LEFT>
	<BR><BR>
	<EM>
	<B>
	`HTMLImage '$SNMP_IMG_URL/FilecabinetFolder.gif' 'Available databases'`
	<A NAME="Databases">Available databases:</A>
	<BR><BR>
	</B>
	</EM>
</TD>
</TR>

<TR>
<TD>
EOM

	foreach database (`cat ${SNMP_DB_ROOT}/cache`)

		set DATABASE_ID	= `echo $database | awk -F"session." '{print $2}'`
		set HOST	= `fgrep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2 | sed "s/ //g"`
		echo "\t<TABLE BORDER=0>"
		echo "\t\t<TR>"
		echo "\t\t<TD>"
		echo "\t\t<EM><B>Database ID:</B></EM>"
		echo "\t\t</TD>"
		echo "\t\t<TD>"
		echo -n '#<A HREF="'
		echo -n "$SNMP_CGI_URL/Wotan.SNMP.OpenDatabase.cgi"
		echo -n '?HOST='
		echo -n $HOST
		echo -n '&DATABASE_ID='
		echo -n $DATABASE_ID
		echo -n '">'
		echo "$DATABASE_ID</A>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"

		set TIMESTAMP	= `grep -F "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`
		echo "\t\t<TR>"
		echo "\t\t<TD>"
		echo "\t\t<EM><B>Description:</B></EM>"
		echo "\t\t</TD>"
		echo "\t\t<TD>"
		echo "\t\t<TABLE>"
			echo "\t\t\t<TR>"
			echo "\t\t\t<TD>"
				echo "\t\t\t\tHost entry:"
			echo "\t\t\t</TD>"
			echo "\t\t\t<TD>"
				echo '\t\t\t\t<TT><A HREF="'"$SNMP_CGI_URL"'/Wotan.SNMP.OpenDatabase.cgi?HOST='"$HOST"'&DATABASE_ID='"$DATABASE_ID"'">'"$HOST"'</A></TT>'
			echo "\t\t\t</TD>"
			echo "\t\t\t</TR>"

			echo "\t\t\t<TR>"
			echo "\t\t\t<TD>"
				echo "\t\t\t\tTime entry:"
			echo "\t\t\t</TD>"
			echo "\t\t\t<TD>"
				echo "\t\t\t\t<TT>$TIMESTAMP</TT>"
			echo "\t\t\t</TD>"
			echo "\t\t\t</TR>"
		echo "\t\t</TABLE>"
		echo "\t\t</TD>"
		echo "\t\t</TR>"
		echo "\t</TABLE><BR>"
	end

CGIBody	
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><B><EM>&nbsp;Description:</EM></B></A>
<BR>
<UL>
	<LI>
	<EM>Database browser</EM> 
	- this interface allow to browse in database server. You can select
	one database and than inspect it. You can simply compare value of each
	SNMP object in one databse with SNMP object in other database.
	</LI>
</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

CGI_END:

# /* End of CGI script */
