#!/bin/tcsh -f

#
# Wotan.SNMP.CreateDatabase.cgi v0.4
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.CreateDatabase.cgi ,v0.4 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which returns HTML document with Wotan SNMP database 
# interface
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib
source ../cgi-lib/Wotan.DB.lib

#
# Enable secure writing to database (ON/OFF)
# (Enabling SECURE_WR may caused some runtime errors)
#
set SECURE_WR	= "OFF"

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Set path to MIB database
#
set MIBFILE		= ${SNMP_MIB}

#
# Generate new database unique ID
#
set DATABASE_ID		= "0"
GenNewDBIndex DATABASE_ID
if ("${DATABASE_ID}" == "0") then
	HashDBIndex DATABASE_ID
endif
StoreDBIndex DATABASE_ID

#
# Set time stamp
#
set TIMESTAMP		= "`date '+Timestamp: %b %d %Y %k:%M:%S'`"

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
set PORT	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/PORT=/ { print $2 }'`
set PORT	= `echo $PORT | tr -dc "[:digit:]"`
if ("$PORT" == "") then
	set PORT	= "161"
endif
set COMMUNITY	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/COMMUNITY=/ { print $2 }'`
set COMMUNITY	= `echo $COMMUNITY | tr -dc "[:alnum:]-_"`
if ("$COMMUNITY" == "") then
	set COMMUNITY	= "public"
endif

#
# Test HOST variable
#
if ("${HOST}" == "") then

	set DB_ERROR_FLAG	= "CRITICAL_ERROR"

#
# Begin of CGI script
#
CGIHeader
	
#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database server - fatal error'`
`HTMLBody`
	
<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD ALIGN=LEFT>
	`HTMLImage '$SNMP_IMG_URL/Kill.gif' 'Error'`
	<B>
	&nbsp;Wotan database server status:
	</B>
	<BR><BR>
	`HTMLOut 'Fatal errors for database ID \#${DATABASE_ID}:'`
	<BR><BR>
	<UL>
	Wrong host name or host name isn't specified.
	</UL>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>
	
<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
	<EM><B>&nbsp;Description:</B></EM><A NAME="Description">
	<BR><BR>
	<UL>
		<LI>
		<EM>Host name problems</EM>
		- sorry, can't create Wotan SNMP database. CGI parser found 
		error(s):
		<BR><BR>
		<CENTER>
		<TT>Wrong host name or host name isn't specified</TT>.
		</CENTER>
		<BR>
		Please, go back to Wotan SNMP main page and try to fill form
		again with valid host name.
		</LI>
	</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>
	
</TABLE>
</CENTER>

`HTMLEnd`
EOM
UngetDBIndex DATABASE_ID
RestoreDBIndex DATABASE_ID
goto CGI_END
endif

#
# Test PORT variable
#
if ("${PORT}" == "") then
	set PORT =	"161"
endif

#
# Test COMMUNITY variable
#
if ("${COMMUNITY}" == "") then
	set PORT =	"public"
endif

#
# Set initial database server environment
#
set DB_ERROR_LIST	= ""
set DB_ERROR_FLAG	= "OK"
@ DB_ERROR_INDEX	= 0

#
# Test if database exists
#
if !(-e ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_EXISTS)
endif

#
# Test if CGI executor is owner (enable this option for secure writing)
#
if ("${SECURE_WR}" == "ON") then
	if !(-o ${SNMP_DB_ROOT} && -r ${SNMP_DB_ROOT} && -w ${SNMP_DB_ROOT}) then
		set DB_ERROR_FLAG	= "CRITICAL_ERROR"
		@ DB_ERROR_INDE
	        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_OWNER)
	endif
endif

#
# Test if database is directory
#
if !(-d ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_DIRECTORY)
endif

#
# Test if database is readable
#
if !(-r ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_READABLE)
endif

#
# Test if database is writable
#
if !(-w ${SNMP_DB_ROOT}) then
	set DB_ERROR_FLAG	= "CRITICAL_ERROR"
	@ DB_ERROR_INDEX++
        set DB_ERROR_LIST	= (${DB_ERROR_LIST} NOT_WRITABLE)
endif

#
# Try connection to remote host
#
set TEST_CONNECTION		= `snmpSniffer -R $SNMP_RETRIES -p $PORT $HOST $COMMUNITY system`
if ("$TEST_CONNECTION" == "$SNMP_ERROR" || "$TEST_CONNECTION" == "") then
	set DB_ERROR_FLAG	= "NO_CONNECTION"
endif

#
# Build new database
#
if ("${DB_ERROR_FLAG}" !=  "CRITICAL_ERROR" && "${DB_ERROR_FLAG}" != "NO_CONNECTION") then
	CGIBuildDatabase $HOST $PORT $COMMUNITY $DATABASE_ID $TIMESTAMP
	if ($? != 0) set DB_ERROR_FLAG	= "CRITICAL_ERROR"
endif

#
# Test database consistency
#
if ("${DB_ERROR_FLAG}" !=  "CRITICAL_ERROR" && "${DB_ERROR_FLAG}" != "NO_CONNECTION") then
	set TEST_OBJECT	= `CGISelectObject $snmpSystemUptime $DATABASE_ID`
	if ("$TEST_OBJECT" == "") then
		set DB_ERROR_FLAG	= "NOT_LINUX"
	endif
endif

#
# Test, if there are errors on database server
#
if ("$DB_ERROR_FLAG" == "CRITICAL_ERROR") then
	
#
# Parse database server errors
#
@ index		= 1
set ERROR_MSG	= ""
while ($index <= $DB_ERROR_INDEX)
	set ERROR_MSG	= ($ERROR_MSG \<LI\>$DB_ERROR_LIST[$index]\</LI\>)
	@ index++
end

#
# Begin of CGI script
#
CGIHeader
	
#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database server - fatal error'`
`HTMLBody`
	
<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD ALIGN=LEFT>
	`HTMLImage '$SNMP_IMG_URL/Kill.gif' 'Error'`
	<B>
	&nbsp;Wotan database server status:
	</B>
	<BR><BR>
	`HTMLOut 'Fatal errors for database ID \#${DATABASE_ID}:'`
	<BR><BR>
	<UL>
	`echo "${ERROR_MSG}"`
	</UL>
</TD>
</TR>
	
<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	<TR>
	<TD WIDT=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="mailto:spravce@uhkt.cz">`HTMLImage '$SNMP_IMG_URL/Mail.gif' 'Mail'`</A>
		Contact <A HREF="mailto:spravce@uhkt.cz">Wotan SNMP administrator</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
	<EM><B>&nbsp;Description:</B></EM><A NAME="Description">
	<BR><BR>
	<UL>
		<LI>
		<EM>Internal runtime error</EM>
		- sorry, Wotan database server can't create SNMP database entry for 
		host <TT>`HTMLOut '$HOST'`</TT>. Reason:
		<BR><BR>
		<CENTER>
		<TT>Internal runtime server error.</TT>
		</CENTER>
		<BR>
		Please, contact Wotan SNMP administrator (see bellow).
		</LI>
	</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>
	
</TABLE>
</CENTER>

`HTMLEnd`
EOM
UngetDBIndex DATABASE_ID
RestoreDBIndex DATABASE_ID
goto CGI_END
endif

#
# Test, if there are errors - connection problems
#
if ("$DB_ERROR_FLAG" == "NO_CONNECTION") then

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database server - connection error'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD ALIGN=LEFT>
	`HTMLImage '$SNMP_IMG_URL/Kill.gif' 'Error'`
	<B>
	&nbsp;Wotan database server status:
	</B>
	<BR><BR>
	Fatal error - connection to host
	<TT>
	`HTMLOut $HOST`
	</TT>
	fail.
	<BR><BR><BR>
</TD>
</TR>
	
<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>
	
<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
	<EM><B>&nbsp;Description:</B></EM><A NAME="Description">
	<BR><BR>
	<UL>
		<LI>
		<EM>Remote host problems</EM>
		- sorry, Wotan database server can't create SNMP connection to 
		host <TT>`HTMLOut '$HOST'`</TT>. Reason:
		<BR><BR>
		<CENTER>
		<TT>Remote host may be down.</TT>
		</CENTER>
		<BR>
		Please, check host name, SNMP port and SNMP community, or
		try connection later.
		</LI>
	</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>
	
<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>
`HTMLEnd`
EOM
UngetDBIndex DATABASE_ID
RestoreDBIndex DATABASE_ID
goto CGI_END
endif

#
# Test, if there are errors - remote host isn't Linux box
#
if ("$DB_ERROR_FLAG" == "NOT_LINUX") then

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database server - remote host error'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD ALIGN=LEFT>
	`HTMLImage '$SNMP_IMG_URL/Kill.gif' 'Error'`
	<B>
	&nbsp;Wotan database server status:
	</B>
	<BR><BR>
	Remote host
	<TT>
	`HTMLOut '$HOST'`
	</TT>
	is not Linux box.
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>
	
<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
	<EM><B>&nbsp;Description:</B></EM><A NAME="Description">
	<BR><BR>
	<UL>
		<LI>
		<EM>Remote host problems</EM>
		- sorry, Wotan database server can't create SNMP database for host
		<TT>`HTMLOut '$HOST'`</TT>. Reason:
		<BR><BR>
		<CENTER>
		<TT>Remote host not running Linux operating system or MIB of
		remote host may be corrupted.</TT>
		</CENTER>
		<BR>
		Please, be sure, that remote host is Linux box.
		</LI>
	</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>
	
<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>
`HTMLEnd`
EOM
UngetDBIndex DATABASE_ID
RestoreDBIndex DATABASE_ID
goto CGI_END
endif

#
# There are no errors
#
if ("$DB_ERROR_FLAG" == "OK") then
	
#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database for host $HOST'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>
	
<TR>
<TD ALIGN=LEFT>
	`HTMLImage '$SNMP_IMG_URL/Info.gif' 'Info'`	
	<B>
	<EM>
	Wotan database server status:
	</EM>
	</B>
	<BR><BR>
	Wotan SNMP database session ID
	<TT>
	`HTMLOut '\#$DATABASE_ID'`
	</TT>
	for host
	<TT>
	`HTMLOut '$HOST'`
	</TT>
	successfuly created.
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/Filecabinet.gif' 'Open databse'`</A>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Open database</A>	
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
        `HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
        <EM><B>&nbsp;Description:</B></EM><A NAME="Description">
        <BR><BR>
        <UL>
                <LI>
                <EM>Database created</EM>
                - Wotan database server has successfuly created new database which
		contains SNMP objects for remote host. In this time, you can
		open database (<TT>Action: Open database</TT>, see bellow) or
		you can create new database (<TT>Action: Back to Wotan SNMP main page</TT>).
                </LI>
        </UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM
goto CGI_END
endif

#
# CGI end label
#
CGI_END:

# /* End of CGI script */
