#!/bin/tcsh -f

#
# Wotan.SNMP.Main.cgi v0.3
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.Main.cgi ,v0.3 1999/10/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with SNMP interface 
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.Audit.cfg
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
set STATUS	= `echo $QUERY_STRING | awk  'BEGIN { RS = "&"; FS = "="} \\
/STATUS=/ { print $2 }'`
set STATUS	= `echo $STATUS | tr -dc "[:alpha:]"`
switch ("$STATUS")
	case "up":
	case "down":
		breaksw
	default:
		set STATUS	= "unknown"
		breaksw
endsw

#
# Begin of CGI
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP main page'`
`HTMLBody`

<CENTER>
<TABLE ALIGN=CENTER WIDTH=650>

<TR>
<TD>
	<BR>
	<CENTER>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	</CENTER>
	<BR>
</TD>
</TR>

<TR>
<TD ALIGN="CENTER">
	<B>
	`HTMLImage '$SNMP_IMG_URL/SNMP.gif' 'SNMP monitor'`
	Wotan SNMP extension monitor
EOM

if ("$HOST" != "") then
	echo "for host <EM>$HOST</EM>"
endif

CGIBody
	</B>
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
	This part of Wotan package is monitoring SNMP Management Information
	Base (MIB) extension for Linux
EOM

if ("$HOST" != "") then
	echo "on remote host <B><EM>$HOST</EM></B>."
else
	echo "."
endif

if ("$HOST" != "") then

	echo "Host <B><EM>$HOST</EM></B>"

switch ("$STATUS")

	case "up":
		echo 'is <EM><FONT COLOR="#009900">'"$STATUS"'</FONT></EM>.'
		echo "In this case, SNMP daemon may be running on host <B><EM>$HOST</EM></B>."
		breaksw

	case "down":
		echo 'is <EM><FONT COLOR="#FF0000">'"$STATUS"'</FONT></EM>.'
		echo "In this case, SNMP daemon not running on host <B><EM>$HOST</EM></B>." 
		breaksw
		
	default:
		echo 'status is <EM><FONT COLOR="#FF0000">unknown</FONT></EM>.'
		echo "In this case, SNMP daemon may not be running on host <B><EM>$HOST</EM></B>."
		breaksw	
endsw
endif

CGIBody
</TD>
</TR>


<TR>
<TD ALIGN=LEFT>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#CreateDatabase">`HTMLImage '$AUDIT_IMG_URL/Filecabinet.gif' 'Create database'`</A>
		&nbsp;Create <A HREF="#CreateDatabase">new Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.BrowseDatabase.cgi">`HTMLImage '$SNMP_IMG_URL/FilecabinetOpen.gif' 'Open database'`</A>
		&nbsp;&nbsp;Open existing <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.BrowseDatabase.cgi">Wotan SNMP databases</A>
	</TD>
	</TR>

EOM

if ("$HOST" != "") then

	echo "\t<TR>"
	echo '\t<TD WIDTH="5%">'
		echo '\t\t&nbsp;'
	echo "\t</TD>"
	echo '\t<TD WIDTH="95%">'
		echo '\t\t<A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'"><IMG SRC="'"$AUDIT_IMG_URL"'/HandPointing.gif" BORDER=0 ALT="Back"></A>&nbsp;Back to <A HREF="'"$AUDIT_CGI_URL"'/Wotan.Audit.Overview.cgi?HOST='"$HOST"'&STATUS='"$STATUS"'">auditing and monitoring page</A> for host'" $HOST"
	echo "\t</TD>"
	echo "\t</TR>"
endif

CGIBody
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">`HTMLImage '$AUDIT_IMG_URL/Monitoring.gif' 'Monitoring and auditing page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_CGI_URL`/Wotan.Audit.Main.cgi">main auditing and monitoring page</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">`HTMLImage '$AUDIT_IMG_URL/Home.gif' 'Wotan home page'`</A>&nbsp;Back to <A HREF="`echo $AUDIT_DOC_URL`/Wotan.Main.html">Wotan main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
<TR>

<TR>
<TD ALIGN=LEFT>
	<BR><BR><BR>
	`HTMLImage '$AUDIT_IMG_URL/Filecabinet.gif' 'Create new database'`
	<EM><B>Create new database</B></EM><A NAME="CreateDatabase">
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN="CENTER">
	<FORM ACTION="../cgi-bin/Wotan.SNMP.CreateDatabase.cgi">
	<A NAME="CreateDatabase">
	<TABLE WIDTH="85%">

	<TR>
	<TD WIDTH=20% ALIGN=RIGHT>
		Linux host:
	</TD>
EOM

if ("$HOST" != "") then
	echo '<TD WIDTH="80%" ALIGN=LEFT>'
	echo "<EM>$HOST</EM>"
	echo '<INPUT TYPE=HIDDEN NAME="HOST" VALUE="'"$HOST"'">'
	echo "</TD>"
else
	echo '<TD WIDTH="80%" ALIGN=LEFT>'
	set WotanLinuxHosts	= ""
	set WotanHosts		= `egrep -v "^#" $WOTAN_HOME/etc/Wotan.hosts | awk '{print $1}'`
	foreach host (`echo $WotanHosts`)
		if (-e $WOTAN_HOME/hosts/$host/etc/Wotan.platform.info) then
			set WotanPlarform	= `cat $WOTAN_HOME/hosts/$host/etc/Wotan.platform.info`
			if ( "$WotanPlarform" == "Linux" ) then
				set WotanLinuxHosts	= ($WotanLinuxHosts $host)
			endif
		endif
	end
	@ flag = 0
	echo '\t<SELECT NAME="HOST" SIZE=1>'
	foreach host (`echo $WotanLinuxHosts`)
		if ($flag == 0) then
			echo '\t<OPTION SELECTED>'"$host"
			@ flag = 1
		else
			echo "\t<OPTION>$host"
		endif
	end
	echo "</SELECT>"
	echo "</TD>"
endif

CGIBody
	</TR>

	<TR>
	<TD WIDTH=20% ALIGN=RIGHT>
		SNMP port:
	</TD>
	<TD WIDTH=80% ALIGN=LEFT>
		<INPUT TYPE=TEXT NAME="PORT" VALUE="161" MAXLENGTH="5" SIZE="5">
	</TD>
	</TR>

	<TR>
	<TD WIDTH=20% ALIGN=RIGHT>
		Community:
	</TD>
	<TD WIDTH=80% ALIGN=LEFT>
		<INPUT TYPE=TEXT NAME="COMMUNITY" VALUE="public" MAXLENGTH="10" SIZE="10">
	</TD>
	</TR>

	<TR>
	<TD>
		&nbsp;<BR>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=80% ALIGN=RIGHT>
		<INPUT TYPE=SUBMIT VALUE="OK">
		&nbsp;
	</TD>
	<TD WIDTH=20% ALIGN=LEFT>
		&nbsp;
		<INPUT TYPE=RESET VALUE="RESET">
	</TD>
	</TR>

	</TABLE>
	</FORM>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR>
`HTMLImage '$AUDIT_IMG_URL/BookOpen.gif' 'Description'`
<A NAME="Description"><EM><B>&nbsp;Description:</B></EM></A>
<BR><BR>
This part of Wotan is monitoring remote host MIB extended definitions - textual
convention which is intended to identify the manufacturer, model, and
version of a specific hardware or software product.  It is suggested that these
object identifiers are allocated such that all products from a particular
manufacturer are registered under a subtree distinct to that manufacturer. In
addition, all versions of a product should be registered under a subtree
distinct to that product.  With this strategy, a management station may
uniquely determine the manufacturer and/or model of a product whose product ID
is unknown to the management station.  Objects of this type may be useful for
inventory purposes or for automatically detecting incompatibilities or version
mismatches between various hardware and software components on a system.
<BR>
</TD>
</TR>


<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

end:

# /* End of CGI script */
