#!/bin/tcsh -f

#
# Wotan.SNMP.OpenDatabase.cgi v0.3
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.OpenDatabase.cgi, v0.3 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script open Wotan SNMP database for remote host
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database successfuly opened'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/Info.gif' 'Info'`	
	<B>
	<EM>
	Wotan database server status
	</EM>
	</B>
	<BR><BR>
	Wotan SNMP database ID
	<TT>
	`HTMLOut '\#$DATABASE_ID'`
	</TT>
	for host
	<TT>
	`HTMLOut '$HOST'`
	</TT>
	successfuly opened.
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Actions">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect'`</A>
		&nbsp;&nbsp;<A HREF="#Actions">Inspect object</A> in Wotan SNMP database
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/FilecabinetOpen.gif' 'Opened database'`
	<EM><B>
	<A NAME="Actions">Available items</A>
	</B></EM>
	<BR><BR>
	Following list contains database objects, which may be inspect:
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>

<TABLE ALIGN=LEFT>
<TR>
<TD ALIGN=LEFT>
	
<TABLE BORDER=0>

<TR>
<TD>&nbsp;</TD>
<TD COLSPAN=3></TD>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.Uptime.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Remote host uptime</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.LocalTime.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Remote host local time</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.InitialBootDevice.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Remote host initial boot device</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.BootParameters.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Remote host kernel boot options</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.NumberOfUsers.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Number of users working on remote host</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.ProcessesInfo.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Remote host processes information</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.PhysicalMemoryInfo.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Remote host physical memory information</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.ProcessorInfo.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Remote host processor information</A></TD>
	</TR>

	<TR>
	<TD>&nbsp;</TD>
	<TD>`HTMLImage '$SNMP_IMG_URL/Document.gif' 'Database object'`</TD>
	<TD><A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.RemoteSystem.StorageInformation.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">System storages and file systems information</A></TD>
	</TR>
</TABLE>
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
	<A NAME="Description">
	<EM><B>
	&nbsp;Description:
	</B></EM>
	</A>
	<BR><BR>
	<UL>
		<LI>
		<EM>Wotan SNMP object database</EM>
		- database which contains specific SNMP objects for remote Linux host.
		Each SNMP object stored in this database can be easy inspected. This
		version of Wotan SNMP cannot allow to set SNMP object. This means that
		all SNMP objects are read only.
		</LI>
	</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
