#!/bin/tcsh -f

#
# Wotan.SNMP.ReindexDatabase.cgi v0.1
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.ReindexDatabase.cgi ,v0.1 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script for reindexing Wotan SNMP database
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

set MM		= "11"
set DD		= "04"
set hh		= "0"
set mm		= "0"
set CC		= "19"
set YY		= "99"
set ss		= "00"
set maxIndex    = "0"
set maxIndex    = `cat ${SNMP_DB_ROOT}/index`
@ index = 1
while ($index <= $maxIndex)
	@ mm ++
	if ($mm >= 60) then
		@ mm = 0
		@ hh ++
	endif
	@ tmm	= $mm
	if ($mm < 10) then
		set mm	= "0$mm"
	endif
	@ thh	= $hh
	if ($hh < 10) then
		set hh	= "0$hh"
	endif
	touch -c --time=atime -t ${MM}${DD}${hh}${mm} ${SNMP_DB_ENTRY}.$index
	touch -c --time=mtime -t ${MM}${DD}${hh}${mm} ${SNMP_DB_ENTRY}.$index
	@ mm = $tmm
	@ hh = $thh
	@ index ++
end

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Wotan SNMP database server - reindexing done'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/Info.gif' 'Info'`	
	<B>
	<EM>
	Wotan database server status:
	</EM>
	</B>
	<BR><BR>
	Wotan SNMP database server successfuly reindexed.
	<BR>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDT=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.BrowseDatabase.cgi">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Back'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.BrowseDatabase.cgi">Wotan SNMP database</A> browser
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="Description">
<BR>
<UL>
	<LI>
	<EM>Reindexing</EM> 
	- update Wotan SNMP database indexes.
	<BR><BR>
	</LI>
</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

CGI_END:

# /* End of CGI script */
