#!/bin/tcsh -f

#
# Wotan.SNMP.RemoteSystemInitialBootDevice.cgi v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.RemoteSystemInitialBootDevice.cgi, v0.2 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with remote host initial
# boot device
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

set SNMP_OBJECT 	= `CGISelectObject $snmpBootDevice $DATABASE_ID | cut -d ':' -f 2`
set BOOT_DEVICE_TYPE	= `CGISelectObject $snmpStorageDescr.$SNMP_OBJECT $DATABASE_ID | cut -d '"' -f 2`
set PARTITION_ID	= `CGISelectObject $snmpMountPoint.$SNMP_OBJECT $DATABASE_ID | cut -d '"' -f 2`
set MOUNT_POINT		= `CGISelectObject $snmpRemoteMountPoint.$SNMP_OBJECT $DATABASE_ID | cut -d '"' -f 2`

set HOST_ID	= `grep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2`
set TIME_ID	= `grep "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Remote system initial boot device'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`CGIDBInfo '$DATABASE_ID' '$HOST_ID' '$TIME_ID'`
</TR>
</TD>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#SystemUptime">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
		&nbsp;Inspect object: <A HREF="#InitBootDevice">Initial boot device</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Open databse'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
	&nbsp;<EM><B>Inspect initial boot device</B></EM>
	<A NAME="InitBootDevice">
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
<TABLE BORDER=0 ALIGN=CENTER>
<TR>
<TD ALIGN=CENTER VALIGN=CENTER>
	`HTMLImage '$SNMP_IMG_URL/DiskFloppy.gif' 'Initial boot device'`
	&nbsp;&nbsp;
</TD>
<TD ALIGN=LEFT>
	<TABLE ALIGN=CENTER BORDER=0>
		<TR>
		<TD WIDTH="60%">
		<EM>
		<B>
		<A HREF="#BootDeviceType">Boot device type:</A>
		</B>
		</EM>
		</TD>
		<TD WIDTH="40%">
		&nbsp;
		`HTMLOut '$BOOT_DEVICE_TYPE'`
		</TD>
		</TR>		
		
		<TR>
		<TD WIDTH="60%">
		<EM>
		<B>
		<A HREF="#BootDevice">Boot device:</A>
		</B>
		</EM>
		</TD>
		<TD WIDTH="40%">
		&nbsp;
		`HTMLOut '$PARTITION_ID'`
		</TD>		
		</TR>

		<TR>
		<TD WIDTH="60%">
		<EM>
		<B>
		<A HREF="#MountPoint">Mount point:</A>		
		</B>
		</EM>
		</TD>
		<TD WIDTH="40%">
		&nbsp;
		`HTMLOut '$MOUNT_POINT'`
		</TD>
		</TR>
	</TABLE>
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="Description">
<BR><BR>
<UL>
	<LI>
	<EM>Initial boot device</EM>
	- the MIB entry for the device from which remote host is configured to load 
	its initial operating system configuration.
	<BR><BR>
	</LI>
	<LI>
	<EM>Boot device type</EM><A NAME="BootDeviceType">
	- a description of the type and instance of the boot device.
	<BR><BR>
	</LI>
	<LI>
	<EM>Boot device description</EM><A NAME="BootDevice">
	- a description of the name and/or address of the server that this file
	system is mounted from. This may also include parameters such as the
	mount point on the remote file  system.  If this is not a remote
	file system, this string should contain local hard disk partition.
	<BR><BR>
	</LI>
	<LI>
	<EM>Mount point</EM><A NAME="MountPoint">
	- the path name of the root of this file system.
	</LI>
</UL>
</TD>
</TR>


<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
