#!/bin/tcsh -f

#
# Wotan.SNMP.RemoteSystem.LocalTime.cgi v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.RemoteSystem.LocalTime.cgi ,v0.2 1999/05/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with remote host local time
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

set SNMP_OBJECT 	= `CGISelectObject $snmpSystemDate $DATABASE_ID | cut -d ':' -f 3`

set HOST_ID	= `grep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2`
set TIME_ID	= `grep "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`

#
# Convert remote system local time from hex to dec format
#
@ YEAR	= `echo ${SNMP_OBJECT} | awk '{printf "0x%s", $2}' | xargs printf "%d\n"`
if ($YEAR <= 99) then
	@ YEAR	= 19$YEAR
else
	@ $YEAR	= 20$YEAR
endif
 
@ MONTH	= `echo ${SNMP_OBJECT} | awk '{printf "0x%s", $3}' | xargs printf "%d\n"`

@ DAY	= `echo ${SNMP_OBJECT} | awk '{printf "0x%s", $4}' | xargs printf "%d\n"`

@ HOUR	= `echo ${SNMP_OBJECT} | awk '{printf "0x%s", $5}' | xargs printf "%d\n"`
if ($HOUR < 10) then
	set HOUR	= "0$HOUR"
endif

@ MIN	= `echo ${SNMP_OBJECT} | awk '{printf "0x%s", $6}' | xargs printf "%d\n"`
if ($MIN < 10) then
	set MIN	= "0$MIN"
endif


@ SEC	= `echo ${SNMP_OBJECT} | awk '{printf "0x%s", $7}' | xargs printf "%d\n"`
if ($SEC < 10) then
	set SEC		= "0$SEC"
endif

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Remote system local time'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`CGIDBInfo '$DATABASE_ID' '$HOST_ID' '$TIME_ID'`
</TR>
</TD>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#LocalDate">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
		&nbsp;Inspect object: <A HREF="#LocalDate">Local date and time</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Open databse'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
	&nbsp;<EM><B>Inspect system local time and date</B></EM>
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
<TABLE BORDER=0 ALIGN=CENTER>
<TR>
<TD ALIGN=CENTER VALIGN=CENTER>
	`HTMLImage '$SNMP_IMG_URL/Time.gif' 'Local time and date'`
</TD>
<TD ALIGN=LEFT>
	<TABLE BORDER=0 ALIGN=CENTER>
	<TR>
	<TD ALIGN=RIGHT>
		<EM><B>
		<A HREF="#LocalTime">Local time:</A>
		</B></EM>
	</TD>
	<TD ALIGN=LEFT>
		`HTMLOut '$HOUR\:$MIN\:$SEC'`
	</TD>
	</TR>

	<TR>
	<TD ALIGN=RIGHT>
		<EM><B>
		<A HREF="#LocalDate">Local date:</A>
		</B></EM>
	</TD>
	<TD ALIGN=LEFT>
		`HTMLOut '$DAY.$MONTH.$YEAR'`
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="Description">
<BR><BR>
<UL>
	<LI>
	<EM>Local time and date</EM><A NAME="LocalTime"><A NAME="LocalDate">
	- the host's value of the local date and local time of day.
	</LI>
</UL>
</TD>
</TR>


<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
