#!/bin/tcsh -f

#
# Wotan.SNMP.RemoteSystem.NumberOfUsers.cgi v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.RemoteSystem.NumberOfUsers.cgi, v0.2 1999/05/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with number of users
# working on remote host
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#


#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

set SNMP_OBJECT 	= `CGISelectObject $snmpNumUsers $DATABASE_ID | cut -d ':' -f 2`

set HOST_ID	= `grep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2`
set TIME_ID	= `grep "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Number of users working on remote system'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`CGIDBInfo '$DATABASE_ID' '$HOST_ID' '$TIME_ID'`
</TR>
</TD>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#NumOfUsers">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
		&nbsp;Inspect object: <A HREF="#NumOfUsers">Number of working users</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>
	
	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Open databse'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
	&nbsp;<EM><B>Inspect number of working users</B></EM>
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
<TABLE BORDER=0 ALIGN=CENTER>
<TR>
<TD ALIGN=CENTER VALIGN=CENTER>
	`HTMLImage '$SNMP_IMG_URL/Accounting.gif' 'Number of working users'`
	&nbsp;&nbsp;
</TD>
<TD ALIGN=LEFT>
		<EM><B>
		<A HREF="#NumOfUsers">Current working users:</A>
		</B></EM>
		&nbsp;&nbsp;`HTMLOut '$SNMP_OBJECT'` session(s)
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="Description">
<BR><BR>
<UL>
	<LI>
	<EM>Number of working users</EM><A NAME="NumOfUsers">
	- the number of user sessions for which this host is storing state
	information. A session is a collection of processes requiring a single
	act of user authentication and possibly subject to collective job control.
	</LI>
</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
