#!/bin/tcsh -f

#
# Wotan.SNMP.RemoteSystemPhysicalMemoryInformation.cgi v0.2
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.RemoteSystemPhysicalMemoryInformation.cgi, v0.2 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with remote host physical 
# memory information
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#


#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

@ SNMP_OBJECT 	= `CGISelectObject $snmpMemorySize $DATABASE_ID | cut -d ':' -f 2`

@ REAL_MEM	= ($SNMP_OBJECT * 1024)

if ($SNMP_OBJECT > 1024) then
	@ NORM_MEM	= ($SNMP_OBJECT / 1024)
endif 

set HOST_ID	= `grep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2`
set TIME_ID	= `grep "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Remote host physical memory information'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`CGIDBInfo '$DATABASE_ID' '$HOST_ID' '$TIME_ID'`
</TR>
</TD>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Memory">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
		&nbsp;Inspect object: <A HREF="#Memory">physical memory</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Open databse'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
	&nbsp;<EM><B>Inspect physical memory</B></EM>
	<A NAME="Memory">
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
<TABLE BORDER=0 ALIGN=CENTER>
<TR>
<TD ALIGN=RIGHT VALIGN=CENTER>
	`HTMLImage '$SNMP_IMG_URL/memorychip.gif' 'Physical memory information'`
	&nbsp;&nbsp;
</TD>
<TD ALIGN=LEFT>
	<TABLE WIDTH=450 BORDER=0>
	<TR>
	<TD ALIGN=LEFT>
		<EM><B>
		<A HREF="#PhysicalMemory">Physical memory:</A>
		</B></EM> (total)
	</TD>
	<TD ALIGN=RIGHT>
		`HTMLOut '$SNMP_OBJECT'`
	</TD>
	<TD>
		KB
	</TD>
	</TR>

	<TR>
	<TD ALIGN=LEFT>
		<EM><B>
		<A HREF="#DetectedMemory">Detected memory</A>
		</B></EM> (boot)
		<EM><B>
		:
		</B></EM>
	</TD>
	<TD ALIGN=RIGHT>
		`HTMLOut '$REAL_MEM'`
	</TD>
	<TD>
		B
	</TD>
	</TR>

	<TR>
	<TD ALIGN=LEFT>
		<EM><B>
		<A HREF="#SystemMemory">System memory</A>
		</B></EM> (available)
		<EM><B>
		:
		</B></EM>
	</TD>
	<TD ALIGN=RIGHT>
		`HTMLOut '$NORM_MEM'`
	</TD>
	<TD>
		MB
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="Description">
<BR><BR>
<UL>
	<LI>
	<EM>Memory size</EM>
	- the amount of main memory instaled on the remote host.
	<BR><BR>
	</LI>
	<LI>
	<EM>Physical memory</EM><A NAME="PhysicalMemory">
	- the amount of physical memory instaled on the remote host 
	(detected by BIOS on system boot).
	<BR><BR>
	</LI>
	<LI>
	<EM>Detected memory</EM><A NAME="DetectedMemory">
	- the amount of detected memory on the remote host (detected
	by kernel on system boot).
	<BR><BR>
	</LI>
	<LI>
	<EM>System memory</EM><A NAME="SystemMemory">
	- the amount of available memory for operating system on the 
	remote host.
	<BR><BR>
	</LI>
</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
