#!/bin/tcsh -f

#
# Wotan.SNMP.RemoteSystemProcessesInfo.cgi v0.3
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.RemoteSystemProcessesInfo.cgi, v0.3 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with information about
# running / loaded processes
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

set RunningProcesses 	= `CGISelectObject $snmpSystemProcesses $DATABASE_ID | cut -d ':' -f 2`
set MaximumProcesses	= `CGISelectObject $snmpMaxProcesses $DATABASE_ID | cut -d ':' -f 2`

set HOST_ID	= `grep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2`
set TIME_ID	= `grep "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Number of process contexts'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`CGIDBInfo '$DATABASE_ID' '$HOST_ID' '$TIME_ID'`
</TR>
</TD>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#ProcessesInfo">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
		&nbsp;Inspect object: <A HREF="#ProcessesInfo">Processes information</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Open databse'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
	&nbsp;<EM><B>Inspect processes information</B></EM>
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
<A NAME="ProcessesInfo">
<TABLE BORDER=0 ALIGN=CENTER>
<TR>
<TD ALIGN=CENTER VALIGN=CENTER>
	`HTMLImage '$SNMP_IMG_URL/Processes3.gif' 'Number of process contexts'`
	&nbsp;&nbsp;
</TD>
<TD ALIGN=LEFT>
		<EM><B>
		<A HREF="#CurrentProcesses">Current loaded / running processes:</A>
		</B></EM>
		<BR>
		&nbsp;&nbsp;`HTMLOut '$RunningProcesses'` context(s)
		<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER VALIGN=CENTER>
	`HTMLImage '$SNMP_IMG_URL/Stoplight.gif' 'Maximum number of process contexts'`
	&nbsp;&nbsp;
</TD>
<TD ALIGN=LEFT>
		<EM><B>
		<A HREF="#MaxProcesses">Maximum loaded / running processes:</A>
		</B></EM>
		<BR>
		&nbsp;&nbsp;`HTMLOut '$MaximumProcesses'` context(s)
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="Description">
<BR><BR>
<UL>
	<LI>
	<EM>Number of running processes</EM><A NAME="CurrentProcesses">
	- the number of process contexts currently loaded or running
	on this system.
	<BR><BR>
	</LI>

	<LI>
	<EM>Maximum number of running processes</EM><A NAME="MaxProcesses">
	- the maximum number of process contexts this system can support.
	If there is no fixed maximum, the value should be zero. On systems
	that have a fixed maximum, this object can help diagnose failures
	that occur when this maximum is reached.
	</LI>
</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
