#!/bin/tcsh -f

#
# Wotan.SNMP.RemoteSystem.ProcessorInfo.cgi v0.5
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.RemoteSystem.ProcessorInfo.cgi ,v0.5 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with remote host processor
# information
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

set HOST_ID	= `grep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2`
set TIME_ID	= `grep "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`

set NumberOfCPU	= `CGISelectObject $snmpProcessor $DATABASE_ID | wc -l`

set CPU		= ""
set CPU_Model	= ""
set CPU_ID	= ""
set CPU_Status	= ""
set CPU_Errors	= ""
set CPU_Load	= ""	

@ CPUIndex		= 1
while ($CPUIndex <= $NumberOfCPU)
	set CPU 	= ($CPU `CGISelectObject $snmpDeviceDescr.$CPUIndex $DATABASE_ID | cut -d ':' -f 3 | cut -d ',' -f 1`)
	set Model	= `CGISelectObject $snmpDeviceDescr.$CPUIndex $DATABASE_ID | cut -d ':' -f 4 | cut -d '"' -f 1`
	set Model	= `echo $Model | awk '{printf "%s%s", $1, $2}'`
	set CPU_Model	= ($CPU_Model $Model)
	set CPU_ID	= ($CPU_ID `CGISelectObject $snmpDeviceID.$CPUIndex $DATABASE_ID | cut -d ':' -f 2`)
	set CPU_Status	= ($CPU_Status `CGISelectObject $snmpDeviceStatus.$CPUIndex $DATABASE_ID | cut -d ':' -f 2 | cut -d '(' -f 1`)
	set CPU_Errors	= ($CPU_Errors `CGISelectObject $snmpDeviceErrors.$CPUIndex $DATABASE_ID | cut -d ':' -f 2`)
	set CPU_Load	= ($CPU_Load `CGISelectObject $snmpProcessorLoad.$CPUIndex $DATABASE_ID | cut -d ':' -f 2`)
	@ CPUIndex++
end

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Remote system uptime'`
`HTMLBody`

<CENTER>
<TABLE WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`CGIDBInfo '$DATABASE_ID' '$HOST_ID' '$TIME_ID'`
</TR>
</TD>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#InspectProcerssor">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
		&nbsp;Inspect object: <A HREF="#InspectProcerssor">Processor information</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#Description">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#Description">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Open databse'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>
	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
	&nbsp;<EM><B>Inspect processor information</B></EM>
	<A NAME="InspectProcerssor">
	<BR><BR>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER WIDTH="100%">
EOM

@ CPUIndex	= 1
while ($CPUIndex <= $NumberOfCPU)

echo "<TABLE ALIGN=CENTER>"
echo "<TR>"
echo "<TD ALIGN=RIGHT>"
	echo -n '\t<IMG SRC="'
	echo -n "$SNMP_IMG_URL/procesor.gif"
	echo '" ALT="CPU">'
echo "</TD>"
echo "<TD ALIGN=LEFT>"

	echo '\t<TABLE WIDTH="100%" BORDER=0>\n'

	echo "\t<TR>"
	echo "\t<TD>"
	
		echo "\t\t<EM><B>"
		echo '\t\t<A HREF="#ProcessorID">Processor ID:</A>'
		echo "\t\t</B></EM>"
	echo "\t</TD>\n"

	echo "\t<TD>"
		echo "\t\t$CPUIndex"
	echo "\t</TD>"
	echo "\t</TR>"


	echo "\t<TR>"
	echo "\t<TD>"
	
		echo "\t\t<EM><B>"
		echo '\t\t<A HREF="#CPUType">CPU type:</A>'
		echo "\t\t</B></EM>"
	echo "\t</TD>\n"

	echo "\t<TD>"
		echo "\t\t$CPU[$CPUIndex]"
	echo "\t</TD>"
	echo "\t</TR>\n"

	echo "\t<TR>"
	echo "\t<TD>"
	
		echo "\t\t<EM><B>"
		echo '\t\t<A HREF="#CPUModel">CPU model:</A>'
		echo "\t\t</B></EM>"
	echo "\t</TD>\n"

	echo "\t<TD>"
		echo "\t\t$CPU_Model[$CPUIndex]"
	echo "\t</TD>"
	echo "\t</TR>\n"

	echo "\t<TR>"
	echo "\t<TD>"
	
		echo "\t\t<EM><B>"
		echo '\t\t<A HREF="#CPUFirmware">CPU firmware:</A>'
		echo "\t\t</B></EM>"
	echo "\t</TD>\n"

	echo "\t<TD>"
		echo "\t\t$CPU_ID[$CPUIndex]"
	echo "\t</TD>"
	echo "\t</TR>\n"

	echo "\t<TR>"
	echo "\t<TD>"
	
		echo "\t\t<EM><B>"
		echo '\t\t<A HREF="#CPUStatus">CPU status:</A>'
		echo "\t\t</B></EM>"
	echo "\t</TD>\n"

	echo "\t<TD>"
		echo "\t\t$CPU_Status[$CPUIndex]"
	echo "\t</TD>"
	echo "\t</TR>\n"

	echo "\t<TR>"
	echo "\t<TD>"
	
		echo "\t\t<EM><B>"
		echo '\t\t<A HREF="#CPUErrors">CPU errors:</A>'
		echo "\t\t</B></EM>"
	echo "\t</TD>\n"

	echo "\t<TD>"
		echo "\t\t$CPU_Errors[$CPUIndex]"
	echo "\t</TD>"
	echo "\t</TR>\n"

	echo "\t<TR>"
	echo "\t<TD>"
	
		echo "\t\t<EM><B>"
		echo '\t\t<A HREF="#CPULoad">CPU load:</A>'
		echo "\t\t</B></EM>"
	echo "\t</TD>\n"

	echo "\t<TD>"
		echo "\t\t$CPU_Load[$CPUIndex]"
	echo "\t</TD>"
	echo "\t</TR>\n"

	echo "\t</TABLE>\n\t<BR>"

echo "</TD>"
echo "</TR>"
echo "</TABLE>"
@ CPUIndex++
end

CGIBody
</TD>
</TR>

<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="Description">
<BR><BR>
<UL>
	<LI>
	<EM>Processor table information</EM> 
	- The (conceptual) table of processors contained by the host. Note
	that this table is potentially sparse: a (conceptual) entry exists
	only if the correspondent value of the object is intaled and
	activated processor.
	<BR><BR>
	</LI>

	<LI>
	<EM>Processor ID</EM><A NAME="ProcessorID">
	- A unique value for each processor contained by the host. The value
	for each processor must remain constant at least from one re-initialization
	of the agent to the next re-initialization.
	<BR><BR>
	</LI>

	<LI>
	<EM>CPU type</EM><A NAME="CPUType">
	- An indication of the type of processor
	<BR><BR>
	</LI>

	<LI>
	<EM>CPU model</EM><A NAME="CPUModel">
	- A textual description of this processor, including the processor's
	manufacturer and revision, and optionally, its serial number.
	<BR><BR>
	</LI>

	<LI>
	<EM>CPU firmware</EM><A NAME="CPUFirmware">
	- The product ID of the firmware associated with the processor.
	<BR><BR>
	</LI>

	<LI>
	<EM>CPU status</EM><A NAME="CPUStatus">
	- The current operational state of the processor described by this
	row of the table. A value unknown indicates that the current state
	of the processor is unknown. A value running indicates that the
	processor is up and running and that no unusual error conditions 
	are known. The warning state indicates that agent has been informed
	of an unusual error condition by the operational software but that
	the device is still 'operational'. A value of testing, indicates
	that the processor is not available for use because it is in the
	testing state.  The state of down is used only when the agent has
	been informed that the processor is not available for any use.
	<BR><BR>
	</LI>

	<LI>
	<EM>CPU errors</EM><A NAME="CPUErrors">
	- The number of errors detected on this processor. It should be noted
	that as this object has a syntax of counter, that it does not have a
	defined initial value. However, it is recommended that this object be
	initialized to zero.
	<BR><BR>
	</LI>

	<LI>
	<EM>CPU load</EM><A NAME="CPULoad">
	- The average, over the last minute, of the percentage of time that
	this processor was not idle.The average, over the last minute, of the
	percentage of time that this processor was not idle.
	</LI>
</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
