#!/bin/tcsh -f

#
# Wotan.SNMP.RemoteSystem.StorageInformation.cgi v0.7
# (c)1999 Marek Uher, Marek.Uher@uhkt.cz
#

# 
# @Ident:
# $Id: Wotan.SNMP.RemoteSystem.StorageInformation.cgi, v0.7 1999/11/09 15:58:00 quark Exp $
# $Author: Marek Uher, Marek.Uher@uhkt.cz $
# $Platform: Linux Apache HTTP server distribution $
#

#
# Description:
# CGI script which generate Wotan document with remote system 
# storage information
#

#
# Include configuration file
#
source ../cgi-etc/Wotan.SNMP.cfg

#
# Include libraries
#
source ../cgi-lib/Wotan.CGI.lib
source ../cgi-lib/Wotan.SNMP.lib

#
# *****************************************************************************
#			   Copyright 1999 by Marek Uher
#
#				All Rights Reserved
#
# Permission  to  use,  copy,  modify,  and  distribute  this  software and its
# documentation  for  any  purpose  and without fee is hereby granted. Provided
# that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
# pertaining  to  distribution  of the software without specific, written prior
# permission.
#
# Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
# Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR APROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# *****************************************************************************
#

#
# Parse and wrape CGI variable QUERY_STRING
#
set HOST	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/HOST=/ { print $2 }'`
set HOST	= `echo $HOST | tr -dc "[:alnum:]-_"`
if ("$HOST" == "") then
	set HOST	= "UNKNOWN_HOST"
endif
set DATABASE_ID	= `echo "$QUERY_STRING" | awk  'BEGIN { RS = "&"; FS = "=" } \\
/DATABASE_ID=/ { print $2 }'`
set DATABASE_ID	= `echo $DATABASE_ID | tr -dc "[:digit:]"`
if ("$DATABASE_ID" == "") then
	set DATABASE_ID	= "1"
endif

set HOST_ID	= `grep "Host ID:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2`
set TIME_ID	= `grep "Timestamp:" ${SNMP_DB_ENTRY}.$DATABASE_ID | cut -d ':' -f 2,3,4`

@ NumberOfStorages 	= `CGISelectObject $snmpStorageIndex $DATABASE_ID | wc -l`
set StorageIndexes	= `CGISelectObject $snmpStorageIndex $DATABASE_ID | cut -d ':' -f 2`

#echo $StorageIndexes

@ LookUpIndex			= 1
set StorageEntryType		= ""
set StorageEntryDescription	= ""
set StorageEntryAllocationUnits	= ""
set StorageEntryStorageSize	= ""
set StorageEntryUsed		= ""
set StorageEntryFailures	= ""
set FSPartitions		= ""
set FSMountPoints		= ""
set FSTypes			= ""
set FSAccessMethods		= ""
set FSBootableFlags		= ""

foreach index (`echo $StorageIndexes`)

	set StorageType	= `CGISelectObject $snmpStorageType.$index $DATABASE_ID | cut -d ':' -f 2`
	switch ($StorageType)

		case $snmpStorageTypeUNKNOW:
			set StorageEntryType	= ($StorageEntryType unknown)
		breaksw

		case $snmpStorageTypeRAM:
			set StorageEntryType	= ($StorageEntryType RAM)
		breaksw

		case $snmpStorageTypeVM:
			set StorageEntryType	= ($StorageEntryType VM)
		breaksw

		case $snmpStorageTypeHDD:
			set StorageEntryType	= ($StorageEntryType HDD)
		breaksw

		case $snmpStorageTypeRDD:
			set StorageEntryType	= ($StorageEntryType RemovableDisk)
		breaksw

		case $snmpStorageTypeFDD:
			set StorageEntryType	= ($StorageEntryType FDD)
		breaksw

		case $snmpStorageTypeCD:
			set StorageEntryType	= ($StorageEntryType CD-ROM)
		breaksw

		case $snmpStorageTypeRAMD:
			set StorageEntryType	= ($StorageEntryType RAMDisk)
		breaksw

		default:
			set StorageEntryType	= ($StorageEntryType unknown) 
		breaksw
	endsw

	set StorageDescription		= `CGISelectObject $snmpStorageDescr.$index $DATABASE_ID | cut -d '"' -f 2`
	switch ($StorageDescription)

		case Mem:
			set StorageEntryDescription	= ($StorageEntryDescription Memory)
		breaksw

		case Swap:
			set StorageEntryDescription	= ($StorageEntryDescription Swap)
		breaksw

		case Floppy:
			set StorageEntryDescription	= ($StorageEntryDescription Floppy)
		breaksw

		case Disk:
			set StorageEntryDescription	= ($StorageEntryDescription Disk)
		breaksw
	endsw

	set StorageEntryAllocationUnits		= ($StorageEntryAllocationUnits `CGISelectObject $snmpAllocationUnits.$index $DATABASE_ID | cut -d ':' -f 2`)

	set StorageEntryStorageSize		= ($StorageEntryStorageSize `CGISelectObject $snmpStorageSize.$index $DATABASE_ID | cut -d ':' -f 2`)

	set StorageEntryUsed			= ($StorageEntryUsed `CGISelectObject $snmpStorageUsed.$index $DATABASE_ID | cut -d ':' -f 2`)

	set StorageEntryFailures		= ($StorageEntryFailures `CGISelectObject $snmpAllocationFailures.$index $DATABASE_ID | cut -d ':' -f 2`)

	set FSPartitionID			= `CGISelectObject $snmpMountPoint.$index $DATABASE_ID | cut -d '"' -f 2`
	if ("$FSPartitionID" == "") then
		set FSPartitionID		= "none"
	endif
	set FSPartitions			= ($FSPartitions $FSPartitionID)

	set FSMountPoint			= `CGISelectObject $snmpRemoteMountPoint.$index $DATABASE_ID | cut -d '"' -f 2`
	if ("$FSMountPoint" == "") then
		set FSMountPoint		= "none"
	endif
	set FSMountPoints			= ($FSMountPoints $FSMountPoint)

	set FSType	= `CGISelectObject $snmpFSType.$index $DATABASE_ID | cut -d ':' -f 2`
	switch ($FSType)

		case $FSOther:
			set FSTypes	= ($FSTypes other)
		breaksw

		case $FSUnknown:
			set FSTypes	= ($FSTypes unknown)
		breaksw

		case $FSBerkeleyFFS:
			set FSTypes	= ($FSTypes Berkeley_FFS)
		breaksw

		case $FSSysVFS:
			set FSTypes	= ($FSTypes System_V_FS)
		breaksw

		case $FSFAT:
			set FSTypes	= ($FSTypes FAT)
		breaksw

		case $FSHPFS:
			set FSTypes	= ($FSTypes HPFS)
		breaksw

		case $FSSHFS:
			set FSTypes	= ($FSTypes SHFS)
		breaksw

		case $FSSMFS:
			set FSTypes	= ($FSTypes SMFS)
		breaksw

		case $FSNTFS:
			set FSTypes	= ($FSTypes NTFS)
		breaksw

		case $FSVNode:
			set FSTypes	= ($FSTypes VNode)
		breaksw

		case $FSJournaled:
			set FSTypes	= ($FSTypes Journaled)
		breaksw

		case $FSiso9660:
			set FSTypes	= ($FSTypes ISO_9660)
		breaksw

		case $FSRockRidge:
			set FSTypes	= ($FSTypes Rock_Ridge)
		breaksw

		case $FSNFS:
			set FSTypes	= ($FSTypes NFS)
		breaksw

		case $FSNetware:
			set FSTypes	= ($FSTypes Netware)
		breaksw

		case $FSAFS:
			set FSTypes	= ($FSTypes AFS)
		breaksw

		case $FSDFS:
			set FSTypes	= ($FSTypes DFS)
		breaksw

		case $FSAppleshare:
			set FSTypes	= ($FSTypes Appleshare)
		breaksw

		case $FSRFS:
			set FSTypes	= ($FSTypes RFS)
		breaksw

		case $FSDGCFS:
			set FSTypes	= ($FSTypes DGCFS)
		breaksw

		case $FSBFS:
			set FSTypes	= ($FSTypes BFS)
		breaksw

		default:
			set FSTypes	= ($FSTypes unknown) 
		breaksw
	endsw

	set FSAccess	= `CGISelectObject $snmpFSAccess.$index $DATABASE_ID | cut -d ':' -f 2 | cut -d '(' -f 1`
	switch ($FSAccess)

		case $FSAccessRW:
			set FSAccessMethods	= ($FSAccessMethods RW)
		breaksw

		case $FSAccessRO:
			set FSAccessMethods	= ($FSAccessMethods RO)
		breaksw

		default:
			set FSAccessMethods     = ($FSAccessMethods unknown)
		breaksw
	endsw

	set FSBootableFlag	= `CGISelectObject $snmpFSBootable.$index $DATABASE_ID | cut -d ':' -f 2 | cut -d '(' -f 1`
	switch ($FSBootableFlag)

		case $FSBootable:
			set FSBootableFlags	= ($FSBootableFlags yes)
		breaksw

		case $FSNotBootable:
			set FSBootableFlags	= ($FSBootableFlags no)
		breaksw

		default:
			set FSBootableFlags     = ($FSBootableFlags unknown)
		breaksw
	endsw


	@ LookUpIndex++
end

#
# Begin of CGI script
#
CGIHeader

#
# Begin of CGI and HTML body
#
CGIBody
`HTMLHeader 'Remote host storage information'`
`HTMLBody`

<CENTER>
<TABLE ALIGN=CENTER WIDTH=650>

<TR>
<TD ALIGN=CENTER>
	<BR>
	`HTMLImage '$SNMP_IMG_URL/title.gif' 'Wotan Logo'`
	<BR><BR>
</TD>
</TR>

<TR>
<TD>
	`CGIDBInfo '$DATABASE_ID' '$HOST_ID' '$TIME_ID'`
</TD>
</TR>

<TR>
<TD>
	`HTMLImage '$SNMP_IMG_URL/HandOpen.gif' 'Actions'`
	<EM><B>
	Actions:
	</B></EM>
	<BR><BR>
	<TABLE>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#StorageFSInfo">`HTMLImage '$SNMP_IMG_URL/Finder.gif' 'Inspect object'`</A>
		&nbsp;Inspect object: <A HREF="#StorageFSInfo">Storages and file system information</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="#TDescription">`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`</A>
		&nbsp;Get <A HREF="#TDescription">description</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">`HTMLImage '$SNMP_IMG_URL/HandPointing.gif' 'Open databse'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.OpenDatabase.cgi?HOST=$HOST&DATABASE_ID=$DATABASE_ID">Wotan SNMP database</A>
	</TD>
	</TR>

	<TR>
	<TD WIDTH=5%>
		&nbsp;
	</TD>
	<TD WIDTH=95%>
		<A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">`HTMLImage '$SNMP_IMG_URL/Home.gif' 'Home'`</A>
		Back to <A HREF="`echo $SNMP_CGI_URL`/Wotan.SNMP.Main.cgi">Wotan SNMP main page</A>
	</TD>
	</TR>

	</TABLE>
</TD>
</TR>

<TR>
<TD>
	<BR><BR>
	`HTMLImage '$SNMP_IMG_URL/PieGraph.gif' 'Storage and FS information'`
	<EM><B>&nbsp;Inspect storages and file systems information</B></EM>
	<A NAME="StorageFSInfo">
	<BR><BR>
</TD>
</TR>
</TABLE>

<TABLE WIDTH=1200 ALIGN=CENTER>
<TR>
<TD ALIGN=CENTER>
	<TABLE ALIGN=CENTER BORDER=1>
		<TR>
		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#StorageID">Storage ID</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#MediumType">Medium type</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#Description">Description</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#AllocUnits">Alloc. units</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#Size">Size</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#Used">Used</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#AllocErrors">Alloc. errors</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#PartitionID">Partition ID</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#MountPoint">Mount point</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#FileSystem">File system</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#AccessMethod">Access method</A>
			</B></EM>
		</TD>

		<TD ALIGN=CENTER>
			<EM><B>
			<A HREF="#BootableFlag">Bootable flag</A>
			</B></EM>
		</TD>
		</TR>
EOM

@ LookUpIndex = 1

while ($LookUpIndex <= $NumberOfStorages)

	echo "\t\t<TR>"

	echo "\t\t<TD ALIGN=RIGHT>"
		echo "\t\t\t$StorageIndexes[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=CENTER>"
		echo "\t\t\t$StorageEntryType[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=LEFT>"
		echo "\t\t\t&nbsp;&nbsp;$StorageEntryDescription[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=RIGHT>"
		echo "\t\t\t$StorageEntryAllocationUnits[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=RIGHT>"
		echo "\t\t\t$StorageEntryStorageSize[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=RIGHT>"
		echo "\t\t\t$StorageEntryUsed[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=RIGHT>"
		echo "\t\t\t$StorageEntryFailures[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=LEFT>"
		echo "\t\t\t&nbsp;&nbsp;$FSPartitions[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=LEFT>"
		echo "\t\t\t&nbsp;&nbsp;$FSMountPoints[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=CENTER>"
		echo "\t\t\t&nbsp;&nbsp;$FSTypes[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=CENTER>"
		echo "\t\t\t&nbsp;&nbsp;$FSAccessMethods[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t<TD ALIGN=CENTER>"
		echo "\t\t\t&nbsp;&nbsp;$FSBootableFlags[$LookUpIndex]"
	echo "\t\t</TD>"

	echo "\t\t</TR>"
	@ LookUpIndex++ 
end

CGIBody
	</TABLE>
</TD>
</TR>
</TABLE>

<TABLE ALIGN=CENTER WIDTH=650>
<TR>
<TD ALIGN=LEFT>
<BR><BR>
`HTMLImage '$SNMP_IMG_URL/BookOpen.gif' 'Description'`
<B><EM>&nbsp;Description:</EM></B><A NAME="TDescription">
<BR><BR>
<UL>
	<LI>
	<EM>Storage table</EM> 
	- The (conceptual) table of logical storage areas on
	the host. An entry shall be placed in the storage table for each 
	logical area of storage that is allocated and has fixed resource 
	limits. The amount of storage represented in an entity is the amount
	actually usable by the requesting entity, and excludes loss due to 
	formatting or file system reference information.
	<BR><BR>
	These entries are associated with logical storage areas, as might be
	seen by an application, rather than physical storage entities which
	are typically seen by an operating system. Storage such as tapes and 
	floppies without file systems on them are typically not allocated in
	chunks by the operating system to requesting applications, and therefore
	shouldn't appear in this table. Examples of valid storage for this 
	table include disk partitions, file systems, RAM (for some architectures
	this is further segmented into regular memory, and so on), backing 
	store for virtual memory ('swap space').
	<BR><BR>
	This table is intended to be a useful diagnostic for out of memory and
	out of buffers types of failures. In addition, it can be a useful
	performance monitoring tool for tracking memory, disk, or buffer usage.
	<BR><BR>
	</LI>

	<LI>
	<EM>Storage entry</EM>
	 - A (conceptual) entry for one logical storage area on the host
	<BR><BR>
	</LI>

	<LI>
	<EM>Storage ID</EM><A NAME="StorageID">
	- A unique value for each logical storage area contained by the host.
	<BR><BR>
	</LI>

	<LI>
	<EM>Medium type</EM><A NAME="MediumType">
	- The type of storage represented by this entry.
	<BR><BR>
	</LI>

	<LI>
	<EM>Description</EM><A NAME="Description">
	- A description of the type and instance of the storage described 
	by this entry.
	<BR><BR>
	</LI>

	<LI>
	<EM>Allocation units</EM><A NAME="AllocUnits">
	- The size, in bytes, of the data objects allocated from this pool.
	If this entry is monitoring sectors, blocks, buffers, or packets, for
	example, this number will commonly be greater than one. Otherwise this
	number will typically be one.
	<BR><BR>
	</LI>

	<LI>
	<EM>Size</EM><A NAME="Size">
	- The size of the storage represented by this entry, in specific
	units.
	<BR><BR>
	</LI>

	<LI>
	<EM>Used</EM><A NAME="Used">
	- The amount of the storage represented by this entry that is 
	allocated, in specific units.
	<BR><BR>
	</LI>

	<LI>
	<EM>Allocation errors</EM><A NAME="AllocErrors">
	- The number of requests for  storage  represented by this entry
	that could not be honored due to not enough storage. It should be 
	noted that as this object has a syntax of counter, that it does not
	have a defined initial value. However, it is recommended that this 
	object be initialized to zero.
	<BR><BR>
	</LI>

	<LI>
	<EM>Partition ID</EM><A NAME="PartitionID">
	- The path name of the root of this file system or address of the
	server that this file system is mounted from.
	<BR><BR>
	</LI>

	<LI>
	<EM>Mount point</EM><A NAME="MountPoint">
	- A  description of the name where this file system is mounted on.
	This may also include parameters such as the mount point on the remote
	file  system.  If  this is not a remote file system, this string should
	have a length of zero.
	<BR><BR>
	</LI>

	<LI>
	<EM>File system</EM><A NAME="FileSystem">
	- The value of this object identifies the type of this file system.
	<BR><BR>
	</LI>

	<LI>
	<EM>Access method</EM><A NAME="AccessMethod">
	- An  indication  if  this file system is logically configured by the
	operating system to be readable and writable or only readable. This does 
	not represent any local access-control policy, except one that is applied
	to the file system as a whole.
	<BR><BR>
	</LI>

	<LI>
	<EM>Bootable flag</EM><A NAME="BootableFlag">
	- A flag indicating whether this file system is bootable.
	</LI>
</UL>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	<HR WIDTH=650>
</TD>
</TR>

<TR>
<TD ALIGN=CENTER>
	`HTMLAddress '$SNMP_ADMIN'`
</TD>
</TR>

</TABLE>
</CENTER>

`HTMLEnd`
EOM

# /* End of CGI script */
