/*
 *
 * wotan.pstatus.c v1.0
 * (c)1999 Marek Uher, Marek.Uher@uhkt.cz
 *
 * Description:
 * This is simple Solaris 2.x processor status info
 *
 */

/*
 *                          Copyright 1999 by Marek Uher
 *
 *                               All Rights Reserved
 *
 * Permission  to  use,  copy,  modify,  and  distribute  this  software and its
 * documentation  for  any  purpose  and without fee is hereby granted. Provided
 * that  that  the  name  Marek Uher  not  be  used  in advertising or publicity
 * pertaining  to  distribution  of the software without specific, written prior
 * permission.
 *
 * Marek Uher DISCLAIMS  ALL  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED  WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS, IN NO EVENT SHALL
 * Marek Uher BE LIABLE  FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER  RESULTING  FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

/*
 * Include header files
 */
#include <stdio.h>
#include <error.h>
#include <sys/unistd.h>
#include <sys/processor.h>
#include <sys/types.h>

/*
 * Ident info
 */
static char const rcsid[]	= "$Id: wotan.pstatus.c,v 0.1 1999/11/01 16:14:07 quark Exp $";
static char const author[]	= "$Author: Marek Uher, Marek.Uher@uhkt.cz $";
static char const platform[]	= "$Platform: SunOS 5.x $";

/*
 *  Main function
 */
int main ( int argc, char *argv[])
{
	processorid_t processor_ID;
	int status;
	int numOfOnlineProcessors = sysconf(_SC_NPROCESSORS_ONLN);

	for ( processor_ID = 0; numOfOnlineProcessors > 0 ; processor_ID++)
	{
		status = p_online( processor_ID, P_STATUS);
		if ( status == -1 && errno == EINVAL)
			continue;
		printf("Processor %d present\n", processor_ID);
		numOfOnlineProcessors--;
		return (0);
	}
}

/* End of file wotan.pstatus.c */
